//---------------------------------------------------------------------------
// DSAccess Performance Monitor  .H file for LODCTR.EXE
//
//	Copyright 1999 - 2001 Microsoft Corporation.  All rights reserved.
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Cache Instance Object and counters
//
// One object instance per unique Cache Instance (2 max)
//---------------------------------------------------------------------------
#define CACHE_OBJ                                          0
#define CACHE_HITS_RATE                                    2
#define CACHE_MISSES_RATE                                  4
#define CACHE_EXPIRIES_USER_RATE                           6
#define CACHE_EXPIRIES_CONFIG_RATE						   8
#define CACHE_INSERTS_USER_RATE                           10
#define CACHE_INSERTS_CONFIG_RATE						  12

#define CACHE_LDAP_SEARCHES_RATE                          14
#define CACHE_ASYNC_NOTIFIES                              16
#define CACHE_ASYNC_READS                                 18
#define CACHE_ASYNC_SEARCHES                              20

#define CACHE_TOTAL_USER_ENTRIES                          22
#define CACHE_TOTAL_CONFIG_ENTRIES						  24
#define CACHE_USER_DN_ENTRIES                             26
#define CACHE_CONFIG_DN_ENTRIES                           28
#define CACHE_USER_SRCH_ENTRIES                           30
#define CACHE_CONFIG_SRCH_ENTRIES                         32
#define CACHE_USER_NFDN_ENTRIES                           34
#define CACHE_CONFIG_NFDN_ENTRIES                         36
#define CACHE_USER_NFGUID_ENTRIES                         38
#define CACHE_CONFIG_NFGUID_ENTRIES                       40

#define CACHE_SIZE_TOTAL_USER_ENTRIES                     42
#define CACHE_SIZE_TOTAL_CONFIG_ENTRIES					  44
#define CACHE_SIZE_USER_DN_ENTRIES                        46
#define CACHE_SIZE_CONFIG_DN_ENTRIES                      48
#define CACHE_SIZE_USER_SRCH_ENTRIES                      50
#define CACHE_SIZE_CONFIG_SRCH_ENTRIES                    52
#define CACHE_SIZE_USER_NFDN_ENTRIES                      54
#define CACHE_SIZE_CONFIG_NFDN_ENTRIES                    56
#define CACHE_SIZE_USER_NFGUID_ENTRIES                    58
#define CACHE_SIZE_CONFIG_NFGUID_ENTRIES                  60


//---------------------------------------------------------------------------
// 64 bit counters for accumulating totals
//---------------------------------------------------------------------------
#define CACHE_HITS_TOTAL                                  62
#define CACHE_MISSES_TOTAL                                64
#define CACHE_EXPIRIES_USER_TOTAL                         66
#define CACHE_EXPIRIES_CONFIG_TOTAL                       68
#define CACHE_INSERTS_USER_TOTAL                          70
#define CACHE_INSERTS_CONFIG_TOTAL                        72
#define CACHE_LDAP_SEARCHES_TOTAL                         74

//---------------------------------------------------------------------------
// Per Process API counters
//
// One object instance per process using dsaccess
//---------------------------------------------------------------------------
#define PROC_OBJ                                          76
#define PROC_PROCID                                       78
#define PROC_RATE_Read                               	  80
#define PROC_RATE_Search                             	  82

//---------------------------------------------------------------------------
// LDAP Search Time (PROC_TIME_Read and PROC_TIME_Search are 64 bit)
//---------------------------------------------------------------------------
#define PROC_TIME_Read                                    84
#define PROC_TIME_Read_BASE                               86
#define PROC_TIME_Search                                  88
#define PROC_TIME_Search_BASE                             90

//---------------------------------------------------------------------------
// DC Object and counters
//
// One object instance per DC (64 max)
//---------------------------------------------------------------------------
#define DC_OBJ											 92
#define DC_RATE_READ									 94
#define DC_RATE_SEARCH									 96
#define DC_RATE_TIMEOUTS								 98
#define DC_RATE_FATAL_ERRORS							100
#define DC_RATE_DISCONNECTS								102
#define DC_RATE_SEARCH_FAILURES							104
#define DC_RATE_BIND_FAILURES							106
#define DC_OUTSTANDING_REQUESTS							108
#define DC_TIME_NETLOGON								110
#define DC_TIME_GETHOSTBYNAME							112
#define DC_AVG_TIME_KERBEROS							114
#define DC_AVG_TIME_CONNECTION							116
#define DC_LOCAL_SITE									118
#define DC_STATE_REACHABILITY							120
#define DC_STATE_SYNCHRONIZED							122
#define DC_STATE_GC_CAPABLE								124
#define DC_STATE_IS_PDC									126
#define DC_STATE_SACL_RIGHT								128
#define DC_STATE_CRITICAL_DATA							130
#define DC_STATE_NETLOGON								132
#define DC_STATE_OSVERSION								134

//---------------------------------------------------------------------------
// LDAP Search Time (DC_TIME_READ and DC_TIME_SEARCH are 64 bit)
//---------------------------------------------------------------------------
#define DC_TIME_READ									136
#define DC_TIME_READ_BASE								138
#define DC_TIME_SEARCH									140
#define DC_TIME_SEARCH_BASE								142

#define GLOBAL_OBJ										144
#define GLOBAL_TIME_DISCOVERY							146
#define GLOBAL_TIME_DNSQUERY							148
#define GLOBAL_DC_IN_SITE								150
#define GLOBAL_GC_IN_SITE								152
#define GLOBAL_DC_OUT_OF_SITE							154
#define GLOBAL_GC_OUT_OF_SITE							156


//---------------------------------------------------------------------------
// Markers for last counters for each object type
//---------------------------------------------------------------------------
#define CACHE_SHORT_OBJ_END     CACHE_SIZE_CONFIG_NFGUID_ENTRIES
#define CACHE_SHORT_OBJ_NUM     (CACHE_SHORT_OBJ_END - CACHE_OBJ) / 2
#define CACHE_LONG_OBJ_END      CACHE_LDAP_SEARCHES_TOTAL
#define CACHE_LONG_OBJ_NUM      (CACHE_LONG_OBJ_END - CACHE_SHORT_OBJ_END) / 2

#define CACHE_OBJ_NUM           (CACHE_SHORT_OBJ_NUM + CACHE_LONG_OBJ_NUM)

#define PROC_SHORT_OBJ_END  	PROC_RATE_Search
#define PROC_SHORT_OBJ_NUM		(PROC_SHORT_OBJ_END - PROC_OBJ) / 2
#define PROC_SEARCH_OBJ_END		PROC_TIME_Search_BASE
#define PROC_SEARCH_OBJ_NUM		(PROC_SEARCH_OBJ_END - PROC_SHORT_OBJ_END) / 4

#define PROC_OBJ_NUM      		(PROC_SHORT_OBJ_NUM + PROC_SEARCH_OBJ_NUM * 2)

#define DC_SHORT_OBJ_END      	DC_STATE_OSVERSION
#define DC_SHORT_OBJ_NUM      	(DC_SHORT_OBJ_END - DC_OBJ) / 2
#define DC_SEARCH_OBJ_END		DC_TIME_SEARCH_BASE
#define DC_SEARCH_OBJ_NUM		(DC_SEARCH_OBJ_END - DC_SHORT_OBJ_END) / 4

#define DC_OBJ_NUM      		(DC_SHORT_OBJ_NUM + DC_SEARCH_OBJ_NUM * 2)

#define GLOBAL_OBJ_END      	GLOBAL_GC_OUT_OF_SITE
#define GLOBAL_OBJ_NUM      	(GLOBAL_OBJ_END - GLOBAL_OBJ) / 2

