// *******************************************************************************************
//
//  MasPerf2.h
//
//  Server side support for performance counters.
//
//  Copyright 2001 Microsoft Corporation, All Rights Reserved.
//
//  Project:  Server synchronization of Outlook data with wireless mobile devices.
//
//  Platform: Win32.
//
//  Remarks:
//      *** External file shipped with the product ***
//
//      Offset definition file for exensible counter objects and counters
//
//      These "relative" offsets must start at 0 and be multiples of 2 (i.e.
//      even numbers). In the Open Procedure, they will be added to the 
//      "First Counter" and "First Help" values fo the device they belong to, 
//      in order to determine the  absolute location of the counter and 
//      object names and corresponding help text in the registry.
//
//      this file is used by the extensible counter DLL code as well as the 
//      counter name and help text definition file (.INI) file that is used
//      by LODCTR to load the names into the registry.
//
// *******************************************************************************************

#define MASPERFOBJ                       0
#define CURRENTADSREQUESTS               2
#define CURRENTUSERS                     4 
#define BADREQUESTS                      6
#define CLIENTCMDSYNCSEC                 8
#define CLIENTCMDSENDMAILSEC            10
#define CLIENTCMDSMARTFORWARDSEC        12
#define CLIENTCMDSMARTREPLYSEC          14
#define CLIENTCMDGETATTACHMENTSEC       16
#define CLIENTCMDGETHIERARCHYSEC        18
#define CLIENTCMDCREATECOLLECTIONSEC    20
#define CLIENTCMDDELETECOLLECTIONSEC    22
#define CLIENTCMDMOVECOLLECTIONSEC      24
#define CLIENTCMDFOLDERSYNCSEC          26
#define CLIENTCMDFOLDERCREATESEC        28
#define CLIENTCMDFOLDERDELETESEC        30
#define CLIENTCMDFOLDERUPDATESEC        32
#define CLIENTCMDMOVEITEMSSEC           34
#define CLIENTCMDGETITEMESTIMATESEC     36
#define CLIENTCMDMEETINGRESPONSESEC     38
#define CLIENTCMDNOTIFYSEC              40
#define CLIENTADDSEC                    42
#define CLIENTCHANGESEC                 44
#define CLIENTDELETESEC                 46
#define CLIENTFETCHSEC                  48
#define SERVERADDSEC                    50
#define SERVERCHANGESEC                 52
#define SERVERDELETESEC                 54
#define SERVERSOFTDELETESEC             56
#define CURRENTCONNECTREQUESTS          58
#define CURRENTSERVERREQUESTS           60
#define SERVERREQUESTSSEC               62
#define TOTALUSERS                      64
#define TOTALSERVERSYNCITEMS            66
#define TOTALCLIENTCMDSENDMAIL          68
#define TOTALCLIENTCMDSMARTFORWARD      70
#define TOTALCLIENTCMDSMARTREPLY        72
#define TOTALCLIENTCMDGETATTACHMENT     74
#define TOTALCLIENTCMDGETHIERARCHY      76
#define TOTALCLIENTCMDCREATECOLLECTION  78
#define TOTALCLIENTCMDDELETECOLLECTION  80
#define TOTALCLIENTCMDMOVECOLLECTION    82
#define TOTALCLIENTCMDFOLDERSYNC        84
#define TOTALCLIENTCMDFOLDERCREATE      86
#define TOTALCLIENTCMDFOLDERDELETE      88
#define TOTALCLIENTCMDFOLDERUPDATE      90
#define TOTALCLIENTCMDMOVEITEMS         92
#define TOTALCLIENTCMDGETITEMESTIMATE   94
#define TOTALCLIENTCMDMEETINGRESPONSE   96
#define TOTALCLIENTCMDNOTIFY            98 
#define TOTALCLIENTADD                  100
#define TOTALCLIENTCHANGE               102
#define TOTALCLIENTDELETE               104
#define TOTALCLIENTFETCH                106
#define TOTALSERVERADD                  108
#define TOTALSERVERCHANGE               110 
#define TOTALSERVERDELETE               112
#define TOTALSERVERSOFTDELETE           114
#define TOTALCLIENTCMDSYNC              116
#define SERVERSYNCITEMSSEC              118
#define TOTALCLIENTSYNCITEMS            120
#define CLIENTSYNCITEMSSEC              122
