/*==========================================================================*\

    Module:        sdstorectrs.h

    Copyright Microsoft Corporation 1998, All Rights Reserved.

    Author:        maheshj

    Descriptions:  Object and Counter definitions for store driver in store.

\*==========================================================================*/

//
//  Object and Counter definitions
//

#define OBJECT_SDSTORE                              0

#define SDSTORE_NUM_SENDQ_SUBMIT                    2
#define SDSTORE_NUM_SENDQ_REQUEUE                   4
#define SDSTORE_NUM_SENDQ_DELETE                    6
#define SDSTORE_NUM_GATEWAY_SUBMIT                  8
#define SDSTORE_NUM_GATEWAY_DELETE                  10
#define SDSTORE_NUM_INBOUND                         12
#define SDSTORE_NUM_LOCAL_DELIVERY                  14
#define SDSTORE_NUM_GATEWAY_DELIVERY                16
#define SDSTORE_NUM_BLOCKS_SIZE                     18
#define SDSTORE_NUM_READ_BLOCKS                     20
#define SDSTORE_NUM_GET_SIZE                        22
#define SDSTORE_NUM_WRITE_BLOCKS                    24
#define SDSTORE_NUM_REOPEN                          26
#define SDSTORE_NUM_WRITE_CONFLICT                  28
#define SDSTORE_NUM_PENDING_IIS_ACKS                30
#define SDSTORE_NUM_LOCAL_RECIPIENTS                32
#define SDSTORE_NUM_GATEWAY_RECIPIENTS              34
#define SDSTORE_NUM_DELIVERY_THREADS                36
#define SDSTORE_NUM_DELIVERY_ITEMS                  38
#define SDSTORE_NUM_MTSIN_MESSAGES                  40
#define SDSTORE_NUM_MTSOUT_MESSAGES                 42
// Temp Table counters.
#define SDSTORE_NUM_TEMP_TABLE_TOTAL                              44
#define SDSTORE_NUM_TEMP_TABLE_CURRENT                            46
#define SDSTORE_NUM_TEMP_TABLE_DELETE                             48
// Tracks open hsots and cache hits
#define SDSTORE_NUM_OPEN_HSOT_CURRENT                             50
#define SDSTORE_NUM_HSOT_CACHE_SEARCH_TOTAL                       52
#define SDSTORE_NUM_HSOT_CACHE_HIT_TOTAL                          54
// Tracks moves from the outbox.
#define SDSTORE_NUM_SUBMIT_LIST_CURRENT                           56
#define SDSTORE_NUM_MOVED_LIST_CURRENT                            58
#define SDSTORE_NUM_MOVED_TOTAL                                   60
// TaskQ Counters
#define SDSTORE_NUM_TASKQ_ITEMS_CREATE_IMSG                       62
#define SDSTORE_NUM_TASKQ_THREADS_CREATE_IMSG                     64
#define SDSTORE_NUM_TASKQ_ITEMS_CREATE_LISTS                      66
#define SDSTORE_NUM_TASKQ_THREADS_CREATE_LISTS                    68

