<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">
<xsl:template match="/">
	<SPAN id="__dailyApptCont">
	<xsl:attribute name="shortdate"><xsl:eval>g_szShortDate;</xsl:eval></xsl:attribute>
	<xsl:attribute name="longdate"><xsl:eval>g_szLongDate;</xsl:eval></xsl:attribute>
	<xsl:attribute name="msdate"><xsl:eval>g_iMsDate;</xsl:eval></xsl:attribute>
	<xsl:for-each select="a:multistatus/a:response">
	 <xsl:if expr="mfSetDates(this)">
	  <DIV tabindex="0">
	  <xsl:attribute name="id"><xsl:value-of select="a:href" /></xsl:attribute>
	  <xsl:for-each select="a:propstat/a:prop">
		<xsl:attribute name="allowedit"><xsl:eval>fAllowModify;</xsl:eval></xsl:attribute>
		<xsl:attribute name="alldayevent"><xsl:eval>bIsMultiday?"1":"0";</xsl:eval></xsl:attribute>
		<xsl:attribute name="spansdays"><xsl:eval>bSpansDays?"1":"0";</xsl:eval></xsl:attribute>
		<xsl:attribute name="dtstartHour"><xsl:eval>nHrStart;</xsl:eval></xsl:attribute>
		<xsl:attribute name="dtstartMinute"><xsl:eval>nMinStart;</xsl:eval></xsl:attribute>
		<xsl:attribute name="dtendHour"><xsl:eval>nHrEnd;</xsl:eval></xsl:attribute>
		<xsl:attribute name="dtendMinute"><xsl:eval>nMinEnd;</xsl:eval></xsl:attribute>
		<xsl:attribute name="dtstartDisplay"><xsl:eval>szDisplayStart;</xsl:eval></xsl:attribute>
		<xsl:attribute name="dtendDisplay"><xsl:eval>szDisplayEnd;</xsl:eval></xsl:attribute>

		<xsl:attribute name="appointment">1</xsl:attribute>
		<xsl:attribute name="dtstartUTC"><xsl:value-of select="dtstart" /></xsl:attribute>
		<xsl:attribute name="dtendUTC"><xsl:value-of select="dtend" /></xsl:attribute>
		<xsl:attribute name="sensitivity"><xsl:value-of select="sensitivity" /></xsl:attribute>
			
		<xsl:attribute name="instancetype"><xsl:value-of select="instancetype" /></xsl:attribute>
		<xsl:attribute name="busystatus"><xsl:value-of select="busystatus" /></xsl:attribute>
		<xsl:attribute name="pr_cdormid"><xsl:value-of select="pr_cdormid" /></xsl:attribute>
		<xsl:attribute name="stateflags"><xsl:value-of select="apptstateflags" /></xsl:attribute>
		<xsl:attribute name="uid"><xsl:value-of select="uid" /></xsl:attribute>
			
		<xsl:choose>
		<xsl:when expr="bIsMultiday==false">
			<xsl:attribute name="class">dailyAppt</xsl:attribute>
			<xsl:attribute name="style"><xsl:eval>szStyle;</xsl:eval></xsl:attribute>
			<xsl:attribute name="_minStart"><xsl:eval>nTotMinStart;</xsl:eval></xsl:attribute>
			<xsl:attribute name="_minEnd"><xsl:eval>nTotMinEnd;</xsl:eval></xsl:attribute>
			<TABLE cellpadding='0' cellspacing='0' class='dailyApptTable'>
			<TBODY>
			<TR class='dailyApptTopbar'>
			<TD rowspan='3' grabBar='1'>
				<xsl:attribute name="class">dailyApptLeftbar <xsl:eval>mfSetDates.szStatusStyleName</xsl:eval></xsl:attribute>
				<xsl:if expr="true!=g_fIsDelegate">
					<xsl:attribute name="style"><xsl:eval>szCursorLeft</xsl:eval></xsl:attribute>
				</xsl:if>
			</TD>
			<TD class='dailyApptTopbar' topbar='1' >
				<xsl:if expr="true!=g_fIsDelegate">
					<xsl:attribute name="style"><xsl:eval>szCursorTop</xsl:eval></xsl:attribute>
				</xsl:if>
			</TD></TR>
			<TR>
			<TD class='dailyApptBody' noWrap='1'>
				<xsl:attribute name="title"><xsl:eval>szDisplayStart+" - "+szDisplayEnd + "\n" + mfSetDates.szSubj + mfSetDates.szLoc</xsl:eval></xsl:attribute>
				<xsl:if expr="true==fHasReminder">
					<IMG class='dailyApptImg' src='/exchweb/img/view-reminder2.gif' height='13' width='16' border='0'></IMG>
				</xsl:if>
				<xsl:if expr="nSensitivity=='2'">
					<IMG class='dailyApptImg' src='/exchweb/img/view-private2.gif' height='13' width='16' border='0'></IMG>
				</xsl:if>
				<xsl:if expr="true==fIsMeeting">
					<IMG class='dailyApptImg' src='/exchweb/img/view-meeting2.gif' height='13' width='16' border='0'></IMG>
				</xsl:if>
				<xsl:if expr="szInstanceType=='2'">
					<IMG class='dailyApptImg' src='/exchweb/img/view-recur2.gif' height='13' width='16' border='0'></IMG>
				</xsl:if>
				<xsl:if expr="szInstanceType=='3'">
					<IMG class='dailyApptImg' src='/exchweb/img/view-exception2.gif' height='13' width='16' border='0'></IMG>
				</xsl:if>
				<xsl:choose>
				<xsl:when expr="g_fIsUnix=='0'">
					<xsl:choose>
					<xsl:when expr="g_Direction=='rtl'">
						<xsl:eval>mfSetDates.szSubj</xsl:eval>&#x200F;<xsl:eval>mfSetDates.szLoc</xsl:eval>&#x200F;
					</xsl:when>
					<xsl:otherwise>
						<xsl:eval>mfSetDates.szSubj</xsl:eval>&#x200E;<xsl:eval>mfSetDates.szLoc</xsl:eval>&#x200E;
					</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:eval>mfSetDates.szSubj</xsl:eval><xsl:eval>mfSetDates.szLoc</xsl:eval>
				</xsl:otherwise>
				</xsl:choose>
			</TD></TR>
			<TR class='dailyApptBottombar'>
			<TD class='dailyApptBottombar' bottombar='1' >
				<xsl:if expr="true!=g_fIsDelegate">
					<xsl:attribute name="style"><xsl:eval>szCursorBottom</xsl:eval></xsl:attribute>
				</xsl:if>
			</TD>
			</TR></TBODY>
			</TABLE>
		</xsl:when>
		<xsl:otherwise>
			<xsl:attribute name="class">dailyAllDayAppointment</xsl:attribute>
			<div>
			<xsl:attribute name="style"><xsl:eval>szStyle;</xsl:eval></xsl:attribute>
			<xsl:attribute name="title"><xsl:eval>mfSetDates.szSubj + "\n" + mfSetDates.szLoc</xsl:eval></xsl:attribute>
			<xsl:if expr="true==bSpansDays">
				<IMG class='dailyApptImg' src='/exchweb/img/view-spanday2.gif' height='13' width='13' border='0'></IMG>
			</xsl:if>
			<xsl:if expr="true==fHasReminder">
				<IMG class='dailyApptImg' src='/exchweb/img/view-reminder2.gif' height='13' width='16' border='0'></IMG>
			</xsl:if>
			<xsl:if expr="nSensitivity=='2'">
				<IMG class='dailyApptImg' src='/exchweb/img/view-private2.gif' height='13' width='16' border='0'></IMG>
			</xsl:if>
			<xsl:if expr="true==fIsMeeting">
				<IMG class='dailyApptImg' src='/exchweb/img/view-meeting2.gif' height='13' width='16' border='0'></IMG>
			</xsl:if>
			<xsl:if expr="szInstanceType=='2'">
				<IMG class='dailyApptImg' src='/exchweb/img/view-recur2.gif' height='13' width='16' border='0'></IMG>
			</xsl:if>
			<xsl:if expr="szInstanceType=='3'">
				<IMG class='dailyApptImg' src='/exchweb/img/view-exception2.gif' height='13' width='16' border='0'></IMG>
			</xsl:if>
			<xsl:choose>
			<xsl:when expr="g_fIsUnix=='0'">
				<xsl:choose>
				<xsl:when expr="g_Direction=='rtl'">
					<xsl:eval>mfSetDates.szSubj</xsl:eval>&#x200F;<xsl:eval>mfSetDates.szLoc</xsl:eval>&#x200F;
				</xsl:when>
				<xsl:otherwise>
					<xsl:eval>mfSetDates.szSubj</xsl:eval>&#x200E;<xsl:eval>mfSetDates.szLoc</xsl:eval>&#x200E;
				</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:eval>mfSetDates.szSubj</xsl:eval><xsl:eval>mfSetDates.szLoc</xsl:eval>
			</xsl:otherwise>
			</xsl:choose>
			</div>
		</xsl:otherwise>
		</xsl:choose>
	  </xsl:for-each>
	  </DIV>
	 </xsl:if>
	</xsl:for-each>
	</SPAN>
</xsl:template>


<xsl:script><![CDATA[   //> end CDATA tag for VID colorizing
//ADDGLOBALSHERE
var rgDate=new Array();
rgDate[0] = new Date();
rgDate[1] = new Date();
var nMinStart,nMinEnd,nHrStart,nHrEnd,nTotMinStart,nTotMinEnd,nMinDuration;
var szStyle,szDisplayStart,szDisplayEnd,bSpansDays;
var fAllowModify="0";
var oEndDate=new Date();
var reIsoDates = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):\d{2}\.\d{3}Z?$/;
var szCursorTop="cursor:n-resize;";
var szCursorLeft="cursor:move;";
var szCursorBottom="cursor:s-resize;";
var nSensitivity="0";
//RETURNS: true if valid start/end times
mfSetDates.szStatusStyleName="";
mfSetDates.szSubj="";
mfSetDates.szLoc="";
var szInstanceType="0";
var fHasReminder=false;
var fIsMeeting=false;
function mfSetDates(e)
{
	var nMsTodaysDate=g_oDate.getTime();
	g_oDate.setHours(24,0,0,0);
	var nMsTodaysDateEnd = g_oDate.getTime();
	g_oDate.setHours(-24,0,0,0);

	var nodeReminderNextTime = selectSingleNode("a:propstat/a:prop/remindernexttime");
	if (nodeReminderNextTime != null)
	{
		var szReminders = nodeReminderNextTime.text;
		fHasReminder=( szReminders.length && "4501-01-01T00:00:00.000Z" !== szReminders );
	}

	var nodeApptStateFlags = selectSingleNode("a:propstat/a:prop/apptstateflags");
	if (nodeApptStateFlags != null)
	{
		var szStateFlag = nodeApptStateFlags.text;
		fIsMeeting = ("1" == szStateFlag || "3" == szStateFlag);
	}

	var nodeBusyStatus = selectSingleNode("a:propstat/a:prop/busystatus");
	if (nodeBusyStatus != null)
	{
		var szBusyValue = nodeBusyStatus.text;
		var rgStatusStyles  = {"BUSY":"colorBusy","FREE":"colorFree","TENTATIVE":"colorTentative","OOF":"colorOOF"}; 
		mfSetDates.szStatusStyleName =  rgStatusStyles[szBusyValue.toUpperCase()];
	}

	var nodeInstanceType = e.selectSingleNode("a:propstat/a:prop/instancetype");
	if (nodeInstanceType != null)
		szInstanceType = nodeInstanceType.text;

	var nodeSensitivity = e.selectSingleNode("a:propstat/a:prop/sensitivity");
	if (nodeSensitivity != null)
		nSensitivity = nodeSensitivity.text;
	fAllowModify = ("2"==nSensitivity && g_fIsDelegate) ? "0" : "1";

	if ("1"==fAllowModify)
	{
		var nodeSubject = e.selectSingleNode("a:propstat/a:prop/subject");
		if (nodeSubject != null && nodeSubject.text.length)
			mfSetDates.szSubj = nodeSubject.text;
		else 
			mfSetDates.szSubj = g_szNoSubject;
		
		var nodeLocation = e.selectSingleNode("a:propstat/a:prop/location");
		if (nodeLocation != null && 0 != nodeLocation.text.length)
			mfSetDates.szLoc = " (" + nodeLocation.text + ")";
		else
			mfSetDates.szLoc="";

		szCursorTop="cursor:n-resize;";
		szCursorLeft="cursor:move;";
		szCursorBottom="cursor:s-resize;";
	}
	else
	{
		mfSetDates.szSubj=L_PrivAppt;
		mfSetDates.szLoc=szCursorTop=szCursorLeft=szCursorBottom="";
	}

	if (g_fReadonly)
	{
		szCursorTop=szCursorLeft=szCursorBottom="cursor:default;";
	}

	var arr,ms1,ms2;
	var nodedtstart = e.selectSingleNode("a:propstat/a:prop/dtstart");

	if (nodedtstart != null)
	{
		reIsoDates.lastIndex=0;
		arr = reIsoDates.exec( nodedtstart.text );
		if (arr)
		{
			ms1 = Date.UTC(arr[1],arr[2]-1,arr[3],arr[4],arr[5],0);
			rgDate[0].setTime(ms1);
			szDisplayStart=mfFormatTime(rgDate[0].getHours(),rgDate[0].getMinutes());
		}
	}

	var nodedtend = e.selectSingleNode("a:propstat/a:prop/dtend");

	if (nodedtend != null)
	{
		reIsoDates.lastIndex=0;
		arr = reIsoDates.exec( nodedtend.text );
		if (arr)
		{
			ms2 = Date.UTC(arr[1],arr[2]-1,arr[3],arr[4],arr[5],0);
			rgDate[1].setTime(ms2);
			szDisplayEnd=mfFormatTime(rgDate[1].getHours(),rgDate[1].getMinutes());
		}
	}	
	if (ms1 && ms2)
	{
		//filter items not on this day
		if (!(ms1 < nMsTodaysDateEnd && ms2 > nMsTodaysDate)) 
		{
			return(false);
		}
		nMinDuration = Math.abs(Math.floor( (ms2-ms1)/60000 ));
		if (0==nMinDuration) nMinDuration=30; //gotta show something

		if ( ms1 < nMsTodaysDate ) //started yesterday must end today
		{
			//set the end and calc top
			nMinEnd = rgDate[1].getMinutes();
			nHrEnd = rgDate[1].getHours();
			nTotMinEnd = nMinEnd + (nHrEnd*60);
			if (0==nTotMinEnd) nTotMinEnd=30;//1440;
			nTotMinStart = nTotMinEnd - nMinDuration;
			nMinStart = rgDate[0].getMinutes();
			nHrStart = rgDate[0].getHours();
		}
		else
		{
			nMinStart = rgDate[0].getMinutes();
			nHrStart = rgDate[0].getHours();
			nTotMinStart=nMinStart + (nHrStart*60);
			nTotMinEnd = nTotMinStart + nMinDuration;
			nMinEnd = rgDate[1].getMinutes();
			nHrEnd = rgDate[1].getHours();
		}
		//shrink to fit container bottom
		//var nHeight = (nTotMinStart+nMinDuration > 1440) ?  1440 - nTotMinStart : nMinDuration;
		bSpansDays = (nTotMinStart+nMinDuration > 1440)||(0>nTotMinStart);
		bIsMultiday = (((ms2-ms1)/3600000) >= 24) ? true : false; 
		szStyle=(bIsMultiday) ? 
				"" :
				"position:absolute;left:0px;top:"+nTotMinStart+"px;height:"+nMinDuration+";";
		return (true);
	}
	else return(false); //missing a start/end time
}

//default to 24hr format (worldwide standard)
mfFormatTime.szFormat=g_szTimeFormat;
//RETURNS: formatted time string or false=fail (invalid entry)
function mfFormatTime(iHr,iMn)
{
	
	var szRet = mfFormatTime.szFormat;
	if (-1 < szRet.search(/\[t/g)) //must be first before we modify iHr
	{
		szRet =	szRet.replace(/\[tt\]/g, (iHr>11 && iHr<24)?L_PM:L_AM);
		szRet =	szRet.replace(/\[t\]/g, (iHr>11 && iHr<24)?L_PM:L_AM);
	}
	if (-1 < szRet.search(/\[h/g)) //12 hour format
	{
		if (iHr>12) iHr -= 12;
		if (iHr==0) iHr=12;
		szRet =	szRet.replace(/\[hh\]/g, iHr>9?iHr:"0"+iHr);
		szRet =	szRet.replace(/\[h\]/g, iHr);
	}
	if (-1 < szRet.search(/\[H/g)) //24 hour	format
	{
		szRet =	szRet.replace(/\[HH\]/g, iHr>9?iHr:"0"+iHr);
		szRet =	szRet.replace(/\[H\]/g, iHr);
	}
	if (-1 < szRet.search(/\[m/g))
	{
		szRet =	szRet.replace(/\[mm\]/g, iMn>9?iMn:"0"+iMn);
		szRet =	szRet.replace(/\[m\]/g, iMn);
	}
	return(szRet);
}
	
//>
]]></xsl:script>
</xsl:stylesheet>
