<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">
<xsl:template match="/">
	<TABLE nowrap="1" class="weeklyMainTable" cellpadding="0" cellspacing="0">
	<TR>
	<TD class="weeklyColumnDiv">
	<xsl:apply-templates select='a:multistatus' />
	<xsl:apply-templates select='a:multistatus' />
	<xsl:apply-templates select='a:multistatus' />
	<xsl:if expr="formatDateHeader.bWeekendDone">
		<xsl:apply-templates select='a:multistatus' />
	</xsl:if>
	</TD>
	<TD class="weeklyColumnDiv">
	<xsl:apply-templates select='a:multistatus' />
	<xsl:apply-templates select='a:multistatus' />
	<xsl:apply-templates select='a:multistatus' />
	<xsl:if expr="formatDateHeader.nCount &lt; 7">
		<xsl:apply-templates select='a:multistatus' />
	</xsl:if>
	</TD></TR>
	</TABLE>
</xsl:template>

<!--builds each appointment item-->
<xsl:template match="a:prop">
	<xsl:if expr="mfSetDates(this)">
<DIV nowrap="true">
	<xsl:attribute name="id"><xsl:value-of select="../../a:href" /></xsl:attribute>
	<xsl:attribute name="instancetype"><xsl:value-of select="instancetype" /></xsl:attribute>
	<xsl:attribute name="pr_cdormid"><xsl:value-of select="pr_cdormid" /></xsl:attribute>
	<xsl:attribute name="stateflags"><xsl:value-of select="apptstateflags" /></xsl:attribute>
	<xsl:attribute name="uid"><xsl:value-of select="uid" /></xsl:attribute>
	<xsl:attribute name="allowedit"><xsl:eval>fAllowModify;</xsl:eval></xsl:attribute>
	<xsl:choose>
	<xsl:when expr="bIsMultiday==false">
		<xsl:attribute name="class">weeklyAppointment</xsl:attribute>
		<xsl:attribute name="HOLDCLASSNAME">weeklyAppointment</xsl:attribute>
	</xsl:when>
	<xsl:otherwise>
		<xsl:attribute name="class">weeklyAlldayAppointment</xsl:attribute>
		<xsl:attribute name="HOLDCLASSNAME">weeklyAlldayAppointment</xsl:attribute>
	</xsl:otherwise>
	</xsl:choose>
	<xsl:attribute name="title"><xsl:eval>szDisplayStart + " - " +szDisplayEnd + "\n"</xsl:eval><xsl:eval>mfSetDates.szSubj + "\n" + mfSetDates.szLoc</xsl:eval></xsl:attribute>
	<DIV><xsl:attribute name="class">weeklyAppointmentText</xsl:attribute>
	 <xsl:if expr="bIsMultiday==false">
		<xsl:eval>szDisplayStart + " - " +szDisplayEnd + " "</xsl:eval>
	 </xsl:if>
	<xsl:if expr="true==fHasReminder">
		<IMG class='dailyApptImg' src='/exchweb/img/view-reminder2.gif' height='13' width='16' border='0'></IMG>
	</xsl:if>
	<xsl:if expr="nSensitivity=='2'">
		<IMG class='dailyApptImg' src='/exchweb/img/view-private2.gif' height='13' width='16' border='0'></IMG>
	</xsl:if>
	<xsl:if expr="true==fIsMeeting">
		<IMG class='dailyApptImg' src='/exchweb/img/view-meeting2.gif' height='13' width='16' border='0'></IMG>
	</xsl:if>
	<xsl:if expr="szInstanceType=='2'">
		<IMG class='dailyApptImg' src='/exchweb/img/view-recur2.gif' height='13' width='16' border='0'></IMG>
	</xsl:if>
	<xsl:if expr="szInstanceType=='3'">
		<IMG class='dailyApptImg' src='/exchweb/img/view-exception2.gif' height='13' width='16' border='0'></IMG>
	</xsl:if>
	<xsl:choose>
	<xsl:when expr="g_fIsUnix=='0'">
		<xsl:choose>
		<xsl:when expr="g_Direction=='rtl'">
			<xsl:eval>mfSetDates.szSubj</xsl:eval>&#x200F;<xsl:eval>mfSetDates.szLoc</xsl:eval>&#x200F;
		</xsl:when>
		<xsl:otherwise>
			<xsl:eval>mfSetDates.szSubj</xsl:eval>&#x200E;<xsl:eval>mfSetDates.szLoc</xsl:eval>&#x200E;
		</xsl:otherwise>
		</xsl:choose>
	</xsl:when>
	<xsl:otherwise>
		<xsl:eval>mfSetDates.szSubj</xsl:eval><xsl:eval>mfSetDates.szLoc</xsl:eval>
	</xsl:otherwise>
	</xsl:choose>
	</DIV>

</DIV>
	</xsl:if>
</xsl:template>

<xsl:script><![CDATA[   //> end CDATA tag for VID colorizing

//ADDGLOBALSHERE

var rgDate=new Array();
rgDate[0] = new Date();
rgDate[1] = new Date();
var szDisplayStart,szDisplayEnd;

//Sets globals for appointment properties
//RETURNS: true if valid start/end times
mfSetDates.reIsoDates = /^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):\d{2}\.\d{3}Z?$/;
mfSetDates.szSubj="";
mfSetDates.szLoc="";
var fAllowModify="0";
var nSensitivity="0";
var szInstanceType="0";
var fHasReminder=false;
var fIsMeeting=false;

function mfSetDates(e)
{
	var arr,ms1,ms2;
	mfSetDates.reIsoDates.lastIndex=0;
	arr = mfSetDates.reIsoDates.exec( e.selectSingleNode("dtstart").text );
	if (arr)
	{
		ms1 = Date.UTC(arr[1],arr[2]-1,arr[3],arr[4],arr[5],0);
		rgDate[0].setTime(ms1);
		szDisplayStart=mfFormatTime(rgDate[0].getHours(),rgDate[0].getMinutes());
	}
	var szReminders = selectSingleNode("remindernexttime").text;
	fHasReminder=( szReminders.length && "4501-01-01T00:00:00.000Z" !== szReminders );
	var szStateFlag = selectSingleNode("apptstateflags").text;
	fIsMeeting = ("1" == szStateFlag || "3" == szStateFlag);
	szInstanceType = e.selectSingleNode("instancetype").text;
	nSensitivity = e.selectSingleNode("sensitivity").text;
	fAllowModify = ("2"==nSensitivity && g_fIsDelegate) ? "0" : "1";

	if ("1"==fAllowModify)
	{
		if (e.selectSingleNode("subject") && e.selectSingleNode("subject").text.length)
			mfSetDates.szSubj=e.selectSingleNode("subject").text;
		else 
			mfSetDates.szSubj=g_szNoSubject;
		if (e.selectSingleNode("location") && 0 != e.selectSingleNode("location").text.length)
			mfSetDates.szLoc=" ("+e.selectSingleNode("location").text+")";
		else 
			mfSetDates.szLoc="";
	}
	else
	{
		mfSetDates.szSubj=L_PrivAppt;
		mfSetDates.szLoc=szCursorTop=szCursorLeft=szCursorBottom="";
	}


	mfSetDates.reIsoDates.lastIndex=0;
	arr = mfSetDates.reIsoDates.exec( e.selectSingleNode("dtend").text );
	if (arr)
	{
		ms2 = Date.UTC(arr[1],arr[2]-1,arr[3],arr[4],arr[5],0);
		rgDate[1].setTime(ms2);
		szDisplayEnd=mfFormatTime(rgDate[1].getHours(),rgDate[1].getMinutes());
	}
	if (ms1 && ms2)
	{
		bIsMultiday = (((ms2-ms1)/3600000) >= 24) ? true : false; 
		return (true);
	}
	else return(false); //missing a start/end time
}

//RETURNS: formatted time string or false=fail (invalid entry)
function mfFormatTime(iHr,iMn)
{
	var szRet = g_szTimeFormat;
	szRet = szRet.replace(/\[tt\]/g, (iHr>11 && iHr<24)?L_PM:L_AM);
	szRet = szRet.replace(/\[t\]/g, (iHr>11 && iHr<24)?L_PM.charAt(0):L_AM.charAt(0));
	if ( -1 < g_szTimeFormat.search(/\[h/g) ) //12 hour format (can't be mixed)
	{
		if (iHr>12) iHr -= 12;
		if (iHr==0) iHr=12;
	}

	szRet = szRet.replace(/\[hh\]/g, iHr>9?iHr:"0"+iHr);
	szRet = szRet.replace(/\[h\]/g, iHr);
	szRet = szRet.replace(/\[HH\]/g, iHr>9?iHr:"0"+iHr);
	szRet = szRet.replace(/\[H\]/g, iHr);
	szRet = szRet.replace(/\[mm\]/g, iMn>9?iMn:"0"+iMn);
	szRet = szRet.replace(/\[m\]/g, iMn);
	return(szRet);
}
	
formatDateHeader.nCount=0;
formatDateHeader.bWeekendDone=false;
formatDateHeader.oDateCurCell;
formatDateHeader.szDate="";
formatDateHeader.szBodyClass="weeklyDateCell";
formatDateHeader.rgszTitleClass=new Array("weeklyDateHeader","weeklySelectedDateHeader");
formatDateHeader.nTitleClass=0;
formatDateHeader.msDate=0;
function formatDateHeader()
{
	var x;
	if (null==formatDateHeader.oDateCurCell) //1st time in
	{
		formatDateHeader.oDateCurCell = new Date(g_oDate);
	}
	else
	{
		formatDateHeader.oDateCurCell.setDate(formatDateHeader.oDateCurCell.getDate()+1);
		formatDateHeader.oDateCurCell.setHours(0,0,0,0);
	}
	formatDateHeader.msDate=formatDateHeader.oDateCurCell.getTime();
	
	//highlights selected date cell
	formatDateHeader.nTitleClass=(formatDateHeader.nCount == g_idxDateSelected-2)?1:0;
	
	var iDay = formatDateHeader.oDateCurCell.getDay();
	if (iDay==0 || iDay==6)
	{
		formatDateHeader.szBodyClass="weeklyWeekendDateCell";
		formatDateHeader.bWeekendDone=true;
	}
	else
	{
		formatDateHeader.szBodyClass="weeklyDateCell";
	}
	
	var iMonth = formatDateHeader.oDateCurCell.getMonth();
	var iDate = formatDateHeader.oDateCurCell.getDate();
	//use loc string format	"ie: us	= [dddd], [MMMM] [dd]"
	var szH = g_szLongDateNoYearFormat.replace(/\[dddd\]/g, g_rgszLongDayNames[iDay]);
	szH = szH.replace(/\[ddd\]/g, g_rgszShortDayNames[iDay]);
	szH = szH.replace(/\[MMMM\]/g, g_rgszLongMonths[iMonth]);
	szH = szH.replace(/\[MMM\]/g, g_rgszShortMonths[iMonth]);
	szH = szH.replace(/\[MM\]/g,(++iMonth<10)? "0"+iMonth : iMonth);
	szH = szH.replace(/\[M\]/g,iMonth);
	szH = szH.replace(/\[dd\]/g,(iDate<10)? "0"+iDate : iDate);
	szH = szH.replace(/\[d\]/g,iDate);

	formatDateHeader.szDate=szH;
	formatDateHeader.nCount++;
	return(true);
}


//>
]]></xsl:script>
</xsl:stylesheet>
