// Copyright (c) 2000-2001 Microsoft Corporation.  All rights reserved.
//<script>
var m_fInit = false
var m_szFolderURL = null;
var m_szType = "pragma/<http://schemas.microsoft.com/exchange/newmail>";
var m_fEnabled = false;
var m_fState = 0;
var m_fConnected = false;

var m_idTimer = null;			// Interval timer
var m_iPollTime = 15;			// # of minutes between each poll
var m_idSubscription = null;
var m_msLifeTime = 0;			// Timeout in milliseconds before subscription timesout.
var m_oXmlSubscribe = null;
var m_oXmlPoll = null;

var CONST_MS_IN_1MIN = 1000 * 60;
var CONST_B_POLLING = 0x1;
var CONST_B_SEARCH = 0x2;
var CONST_B_FOLDER = 0x4;
var CONST_B_SUBSCRIPTION = 0x8;
var CONST_B_TIMER = 0x10;
var CONST_B_NEXTAPPT = 0x20;

// Public methods
function f_poll()
{
	mf_Poll();
}

function f_getBusy()
{
	return( (0 != (15 & m_fState)) );
}

function f_getState()
{
	return m_fState;
}

function f_getFolder()
{
	return m_szFolderURL;
}

function f_setFolder( szVal )
{
	m_szFolderURL = szVal;
	if( 0 == m_szFolderURL.length )
	{
		m_szFolderURL = null;
	}
}

function f_getEnable()
{
	return( m_fEnabled );
}

function f_setEnable( fVal )
{
	switch( typeof( fVal ) )
	{
		case "boolean":
			m_fEnabled = fVal;
			break;
		case "string":
			fVal = fVal.toLowerCase();
			m_fEnabled = (-1 != fVal.search( /true|1/i ));
			break;
		case "number":
			m_fEnabled = (fVal != 0);
			break;
		default:
			m_fEnabled = false;
			break;
	}

	if( m_fInit )
	{
		if( m_fEnabled )
		{
			if( 0 == m_fState )
			{
				if( null != m_szFolderURL && 0 < m_szFolderURL.length )
				{
					mf_Subscribe(m_szFolderURL,m_szType);
				}
				else
				{
					m_fEnabled = false;;
				}
			}
		}
		else
		{
			m_idSubscription = null;
			mf_StopTimer();
		}
	}
	return( m_fEnabled );
}

function f_getConnected()
{
	return( m_fConnected );
}

function f_getInterval()
{
	return( m_iPollTime );
}

function f_setInterval( newVal )
{
	var nVal = parseInt( newVal, 10 );
	if( !isNaN( nVal ) )
	{
		m_iPollTime = Math.max( nVal, 1 );
	}
}

// Event firing functions
function mf_FireError( szText )
{
	var oEvent= createEventObject();
	oEvent.szReason = szText;
	eError.fire(oEvent);
}

function mf_FireConnect( )
{
	var oEvent= createEventObject();
	oEvent.state = m_fConnected;
	eConnect.fire(oEvent);
}

// Attached functions
function onUnload()
{
	f_setEnable( false );
}

// Internal functions
// Set up a polling frequency to check for folder notifications.
function mf_StartTimer()
{
	mf_StopTimer();
	var nTime = m_iPollTime*CONST_MS_IN_1MIN;
	nTime = ( 60000 < m_msLifeTime ) ? Math.min( nTime, m_msLifeTime-60000 ) : nTime;
	m_idTimer = element.document.parentWindow.setInterval(mfcb_Timer, nTime );
	if( null != m_idTimer )
	{
		m_fState |= CONST_B_TIMER;
	}
	else
	{
		mf_FireError( "Timer resource failure." );
	}
}

// Stop poll of folder notification
function mf_StopTimer()
{
	if( null != m_idTimer )
	{
		element.document.parentWindow.clearInterval(m_idTimer);
		m_fState &= ~CONST_B_TIMER;
		m_idTimer=null;
	}
	mf_stopped();
}

// Timer callback to actually check folder for change.
function mfcb_Timer()
{
	mf_Poll();
}

//null function
function mfcb_Noop()
{
	return ;
}

// Create a subscription on the folder for notification
function mf_Subscribe(szURL, szType )
{
	if( !m_fEnabled )
	{
		return;
	}

	m_idSubscription = null;
	try
	{
		m_oXmlSubscribe = new ActiveXObject('Microsoft.XMLHTTP');
		m_oXmlSubscribe.onreadystatechange = mfcb_Subscribe;
		m_oXmlSubscribe.open("SUBSCRIBE", szURL, true);
		m_oXmlSubscribe.setRequestHeader("Notification-Type", szType);
		m_oXmlSubscribe.setRequestHeader("Translate", "f" );
		m_oXmlSubscribe.setRequestHeader("Depth", "1");
		m_fState |= CONST_B_SUBSCRIPTION;
		m_oXmlSubscribe.send();
	}
	catch(e)
	{
		m_fState &= ~CONST_B_SUBSCRIPTION;
		mf_FireError( "[XMLHTTP failure: Subscribe] " + e.description );
		m_fConnected = false;
		mf_FireConnect( );
	}
}

function mfcb_Subscribe()
{
	if( 4 == m_oXmlSubscribe.readyState )
	{
		m_oXmlSubscribe.onreadystatechange=mfcb_Noop;
		m_fState &= ~CONST_B_SUBSCRIPTION;
		if( !m_fEnabled )
		{
			return;
		}

		if( (200 <= m_oXmlSubscribe.status) && (300 > m_oXmlSubscribe.status) )
		{
			mf_StopTimer();
			m_idSubscription = m_oXmlSubscribe.getResponseHeader("Subscription-id");
			m_msLifeTime = m_oXmlSubscribe.getResponseHeader("Subscription-lifetime") * 1000;
			if( null != m_idSubscription )
			{
				mf_Subscribed();
			}
		}
		else
		{
			m_idSubscription = null;
			m_msLifeTime = 0;
			mf_FireError( "Subscription failed. HTTP status code " + m_oXmlSubscribe.status );
			m_fConnected = false;
			mf_FireConnect( );
		}
	}
}

// Check for notification by using stored subscription identifier
function mf_Poll()
{
	if( !m_fEnabled )
	{
		return;
	}
	// If poll or search still pending ignore request.
	if( 0 < (m_fState & (CONST_B_POLLING + CONST_B_SEARCH)) )
	{
		return;
	}

	if( null != m_idSubscription )
	{
		try
		{
			m_oXmlPoll = new ActiveXObject('Microsoft.XMLHTTP');
			m_oXmlPoll.onreadystatechange = mfcb_Poll;
			m_oXmlPoll.open("POLL", m_szFolderURL, true);
			m_oXmlPoll.setRequestHeader("Subscription-id", m_idSubscription);
			m_fState |= CONST_B_POLLING;
			m_oXmlPoll.send();
		}
		catch(e)
		{
			m_fState &= ~ CONST_B_POLLING;
			mf_FireError( "[XMLHTTP failure: Poll] " + e.description );
			if( m_fConnected )
			{
				m_fConnected = false;
				mf_FireConnect( );
			}
		}
	}
}

function mfcb_Poll()
{
	if( 4 == m_oXmlPoll.readyState )
	{
		m_oXmlPoll.onreadystatechange = mfcb_Noop;
		m_fState &= ~ CONST_B_POLLING;
		if( !m_fEnabled )
		{
			return;
		}

		if( 200 <= m_oXmlPoll.status && 300 > m_oXmlPoll.status )
		{
			// check notification status.
			var obj = m_oXmlPoll.responseXML.selectSingleNode("a:multistatus/a:response/a:status");
			var szStatus = (null != obj) ? obj.text : "";

			if( szStatus.indexOf("200 OK") > 0 )
			{
				//data has changed
				mf_FireOnChange(true);
			}
			else if(szStatus.indexOf("412 Precondition Failed") > 0)
			{
				//subscription timed out
				m_idSubscription=null;
				mf_Subscribe(m_szFolderURL, m_szType);
			}
			else
			{
				mf_FireOnChange(false);
			}
		}
		else
		{
			if( m_fConnected )
			{
				m_fConnected = false;
				mf_FireConnect( );
			}
		}
	}
}

