//Copyright (c) 2000-2001 Microsoft Corporation.  All rights reserved.
//<script>

var m_szPlusIcon = "tree-splus20.gif";
var m_szMinusIcon = "tree-sminus20.gif";
var m_szNoChildrenIcon = "tree-clear16.gif";
var m_szHourglassIcon = "hourglass.gif";
var m_szImagePath = "/exchweb/img/"
var m_rgSpecialFolderURL = new Array();
var m_szAcceptLang = "";
var m_objAllElements = element.all; //Global reference to the htc elements collections
var m_szDocumentDomain = window.document.domain;
var m_rgAuthDomains = new Array();  //Contains authenticated domain names
var m_rgobjXSL = new Array();

//Make signed numbers for errors returned in error object
var E_FAIL = (1^ 0x80004005) + 1;

var m_szXMLTransferData = '<transferdata xmlns:a="DAV:">' +
										'<item>' +
											'<objectname></objectname>' +
											'<objectid></objectid>' +
											'<content-class></content-class>' +
											'<droptype></droptype>' +
											'<a:href></a:href>' +
										'</item>' +
									'</transferdata>';

var m_objXMLTransferData = null;
var m_fAllowDragDrop = true;
var m_objTransformXSL = null;
var g_rgRequestFactory = new Array();

/************PROPERTY ACCESS METHODS****************/

function put_AllowDragDrop(newVal)
{
	m_fAllowDragDrop = coerceToBool(newVal);
}

function get_SelectedNode()
{
	var obj = m_objAllElements("msOWA_selected");

	if( null == obj) return(null);

	var objRet = new Object();
	var objNode = obj.nextSibling;
	objRet.url = objNode.id;
	objRet.isDeletedItems = (objNode.id==m_rgSpecialFolderURL["deleteditems"]);
	objRet.contentClass = objNode.contentClass;
	objRet.displayname = objNode.innerText;
	objRet.left = objNode.offsetLeft;
	return(objRet);
}

function get_XSLDoc()
{
	return(m_objTransformXSL);
}
/******************************************/

/************EVENT FIRING METHODS****************/
function mf_FireOnSelectFolder(node)
{
	var objEvent = createEventObject();
	objEvent.url			= node.id;
	objEvent.displayName	= node.innerText;
	objEvent.isDeletedItems = (node.id==m_rgSpecialFolderURL["deleteditems"]);
	_idselectFolder.fire(objEvent);
}

function mf_FireOnFolderOpComplete(szCommand, iStatus, szStatusText, szLocation, iContentType)
{
	var objEvent = createEventObject();
	objEvent.command		= szCommand;
	objEvent.iStatus		= iStatus;
	objEvent.statusText		= szStatusText;
	objEvent.location		= szLocation;
	objEvent.contentType	= iContentType;
	_idfolderOperationComplete.fire(objEvent);
}

function mf_FireOnError(statusCode, statusText, szCommand)
{
	var objEvent		= createEventObject();
	objEvent.statusCode	= statusCode;
	objEvent.statusText	= statusText;
	objEvent.command	= szCommand;
	_ideventonError.fire(objEvent);
}
/******************************************/
/************EVENT HANDLING METHODS****************/

function onDocumentReady()
{
	if(null != this.viewClass)
		mf_LoadXSL();
}

function onKeyDown()
{
	if(event.altKey || event.ctrlKey || event.keyCode == 9) return;

	var objElement = event.srcElement;
	var iAction = 0;
	switch(event.keyCode)
	{
		case 13://enter
			event.returnValue=false;

			if( "A" == objElement.tagName )
				mf_SelectNode(objElement, true);

			return;
		case 37://left
		case 109: //minus key
			iAction=3;
			break;
		case 39://right
		case 107: //plus key
			iAction = 2;
			break;
		default:
			return;
	}
	var objFolder = objElement.parentElement;
	var obj = null;
	if(null != objFolder)
	{
		if("nodeContainer" != objFolder.id)
		{
			var objSelElement = m_objAllElements("msOWA_selected")

			if(null != objSelElement)
			{
				objSelElement.nextSibling.focus();
				obj = objSelElement.parentElement;
			}
		}
		else
		{
			obj = objFolder;
		}

		if(2 == iAction)
			mf_ExpandFolder(obj);
		else if( 3 == iAction)
			mf_CollapseFolder(obj, false);

		event.returnValue = false;
	}
}

function onContextMenu()
{
	//Note: onMouseDown will select the folder
	var obj = event.srcElement;
	if ("A" == obj.tagName)
	{
		event.returnValue = obj;
	}
	else if("folderIcon" == obj.id)
	{
		var objFolder = obj.parentElement;
		var objAnchor = objFolder.children(objFolder.url);
		if(null != objAnchor)
		{
			event.returnValue = obj;
		}
	}
}

function onDragStart()
{
	if(true != m_fAllowDragDrop  )return;

	var obj = null;
	var objSrc = event.srcElement;

	if("A" == objSrc.tagName)
	{
		obj = objSrc;
	}
	else if("folderIcon" == objSrc.id)
	{
		var objFolder = objSrc.parentElement;
		obj = objFolder.children(objFolder.url);
		if(null == obj) return;
	}
	else
	{
		event.cancelBubble=true;
		event.returnValue=false;
		return;
	}

	if(null != obj)
	{
		window.event.dataTransfer.effectAllowed="all";
		//BUILD XML stream for the data string
		if (m_objXMLTransferData == null)
		{
			m_objXMLTransferData = new ActiveXObject("Microsoft.xmldom")
			m_objXMLTransferData.loadXML(m_szXMLTransferData)
		}

		var objXML =  m_objXMLTransferData.documentElement;
		var node = objXML.selectSingleNode("item/objectid");
		node.text = obj.id;
		node = objXML.selectSingleNode("item/content-class");
		node.text = obj.contentClass;

		node = objXML.selectSingleNode("item/a:href");
		node.text = obj.id;
		node = objXML.selectSingleNode("item/objectname");
		node.text = obj.innerText;
		node = objXML.selectSingleNode("item/droptype");
		node.text = "folder";

		var dataString = objXML.xml;
		window.event.dataTransfer.setData("Text", dataString);
		window.event.dataTransfer.setData("URL", obj.id)
	}

}

function onDrop()
{
	if(m_fAllowDragDrop != true) return;
	var szURL = null;
	var szData = null;
	if("A" == event.srcElement.tagName)
	{
		szURL = event.srcElement.id;

	}
	else if("folderIcon" == event.srcElement.id)
	{
		var objFolder = event.srcElement.parentElement;
		szURL = objFolder.url;
	}
	if(null != szURL)
	{
		szData = event.dataTransfer.getData("Text");
		var szCommand = (window.event.ctrlKey) ? "copy" : "move";
		f_DropXMLData(szData,szURL,szCommand);
	}
}

function onDragOver()
{
	if(m_fAllowDragDrop != true)return;

	if("A" == event.srcElement.tagName || "folderIcon" == event.srcElement.id)
	{
		event.cancelBubble= true;
		event.returnValue = false;

		if (window.event.dataTransfer.getData("Text") != null)
		{
			window.event.dataTransfer.dropEffect = (event.ctrlKey) ? "copy" : "move";
		}
	}
}


function onClick()
{
	var obj = event.srcElement;
	if("expIndicator"  == obj.id)
	{
		var objFolderDIV = obj.parentElement;

		if("true" !== objFolderDIV.expanded)
			mf_ExpandFolder(objFolderDIV, false);
		else
			mf_CollapseFolder(objFolderDIV, false);

		event.cancelBubble=true;
		event.returnValue=false;
	}
	else if("A"	 == obj.tagName)
	{
		mf_SelectNode(obj, true);
	}
	else if("folderIcon" == obj.id)
	{
		var objFolder = obj.parentElement;
		var objAnchor = objFolder.children(objFolder.url);
		if(null != objAnchor) mf_SelectNode(objAnchor, true);
	}
}

function onMouseDown()
{
	//Catch the onmousedown event with the right mouse button down
	if (2 == event.button && ("A" == event.srcElement.tagName || "folderIcon" == event.srcElement.id) )
	{
		var objAnchor = event.srcElement.parentElement.all[event.srcElement.parentElement.url];
		if (null != objAnchor)
		{
			mf_SelectNode(objAnchor, false);  //Do not fire the event to select
		}
	}
}

function mf_XSLDOC(iVersion)
{
	if(null != m_rgobjXSL[iVersion])
	{
		return m_rgobjXSL[iVersion];
	}
	else
	{
		if(1== iVersion)
		{
			var objXSL = new ActiveXObject("Microsoft.xmldom");
			objXSL.loadXML(m_objTransformXSL.xml);
			m_rgobjXSL[iVersion] = objXSL;
		}
		else
		{
			var objXSL = new ActiveXObject("MSXML2.DOMDocument");
			objXSL.loadXML(m_objTransformXSL.xml);
			m_rgobjXSL[iVersion] = objXSL;
		}
		return objXSL;
	}
}


/******************************************/
/************PUBLIC METHODS****************/

function f_AddHierarchy(szRootURL, fExpanded, szDisplayName)
{

	if(szRootURL == null || szRootURL.length == 0) return(null);

	var objDIV = window.document.createElement("DIV");
	objDIV.id = "TLH";

	var objContext = new Object();
	objContext.displayName = szDisplayName;
	objContext.folderContainer = element.insertAdjacentElement("beforeEnd", objDIV);

	var objRequest = new requestFactory(szRootURL,"PROPFIND", objContext, mfcb_AddHierarchy)

	objRequest.expand = fExpanded;
	var http_propFind = objRequest.xmlhttp;

	if(null == http_propFind) return;

	var szPropfind = '<?xml version="1.0"?>' +
						'<a:propfind xmlns:a="DAV:" xmlns:b="urn:schemas:httpmail:" xmlns:c="http://schemas.microsoft.com/exchange/" >' +
						'<a:prop><a:href/><a:displayname/><a:hassubs/><a:contentclass/><b:unreadcount/><c:smallicon/>' +
						'<b:inbox/><b:calendar/><b:sentitems/><b:deleteditems/><b:contacts/><b:drafts/><b:outbox/><b:sendmsg/><b:msgfolderroot/><a:contentclass/>' +
						'</></>';
	http_propFind.setRequestHeader( "Depth", "0");
	http_propFind.setRequestHeader( "Brief", "t");
	http_propFind.setRequestHeader( "Content-type", "text/xml");
	http_propFind.send(szPropfind);
}

function mfcb_AddHierarchy(objRequest)
{

	var objXMLHTTP =  objRequest.xmlhttp;
	var iStatus = objXMLHTTP.status;
	if(iStatus < 300)
	{
		var objContext = objRequest.context;
		var objFolderTLH = objContext.folderContainer;
		var szDisplayName = objContext.displayName;
		var objXSL = mf_XSLDOC(objRequest.xmlVersion);
		var objXML = objXMLHTTP.responseXML;

		if(null == objXML) return;

		objFolderTLH.innerHTML = mf_TransformNode(objXML, objXSL);
		if(null != szDisplayName)
		{
			var objFolder = objFolderTLH.children[0];
			if(null != objFolder)
			{
				var objAnchor = objFolder.children(objFolder.url);
				objAnchor.innerText = szDisplayName;
			}
		}
		mf_InitSpecialFolders(objXML);
		if(true == objRequest.expand)
		{
			mf_ExpandFolder(objFolderTLH.children("nodeContainer"),true);
		}
	}
	else
	{
		mf_FireOnError(iStatus, objXMLHTTP.statusText,"Add Hierarchy");
	}
}

function f_CloneTree(treeNode)
{
	// Copy the item wholesale.
	element.innerHTML = treeNode.innerHTML;
	m_rgobjXSL[mf_GetXMLDom.version] = m_objTransformXSL = treeNode.XSLDoc;
}

function f_DropXMLData(szXMLData, szDestinationFolderURL, szCommand)
{
	if(szXMLData == null) return(false);

	var objXML = new ActiveXObject("Microsoft.xmldom");
	objXML.loadXML(szXMLData);

	if(null == objXML.xml || "" == objXML.xml ) return(false);

	var objHREFNodes = objXML.selectNodes("transferdata/item/a:href")
	szCommand = szCommand.toLowerCase();
	var szXMLVerb = szCommand;
	if(objHREFNodes.length > 1) szCommand = "b" + szCommand;

	var objContentTypeNode = objXML.selectSingleNode("transferdata/item/content-class");
	var szContentClass = objContentTypeNode.text;

	var iContentType = 0;
	if (szContentClass.search(/ipm\./i) != -1)
	{
		iContentType = 1;  //Set content type Message or document
	}
	else if (szContentClass.search(/^ipf\./i) != -1 || szContentClass.indexOf("folder") >= 0)
	{
		iContentType = 2;  //Set content type to hierarchy
	}

	var szXMLRequest = "";
	var szFolderURL  = "";
	switch(szCommand)
	{
		case "bcopy":
		case "bmove":
			if (objHREFNodes.length > 0)
			{
			//Find out where the messages came from
				var szOriginFolderURL = objHREFNodes.item(0).text;
				var re = /(.*\/)[^\/]+$/;
				var rgRes = szOriginFolderURL.match(re);
				if( null == rgRes[1] )
				{
					return(false);
				}
				szFolderURL = rgRes[1];

				var szXMLRequest;
				szXMLRequest = "<?xml version='1.0'?><a:" + szXMLVerb + " xmlns:a='DAV:'><a:target>";

				for(i=0; i < objHREFNodes.length; i++)
				{
					szXMLRequest += objHREFNodes.item(i).xml;
				}

				szXMLRequest += "</a:target></a:" + szXMLVerb + ">";
			}
			break;

		case "move":
		case "copy":
			szFolderURL = objXML.selectSingleNode("transferdata/item/a:href").text;

			var szURLCompName = szFolderURL
			var iIndex = szURLCompName.substr(0,szURLCompName.length-1).lastIndexOf("/")
			szURLCompName = szURLCompName.substr(iIndex + 1)
			szDestinationFolderURL = szDestinationFolderURL + szURLCompName ;
			break;
	}

	if ("" != szFolderURL)
		mf_MoveCopyObject(szFolderURL,szDestinationFolderURL, szCommand,szXMLRequest, iContentType);

	return;
}

function f_MoveFolder(szObjectURL, szDestinationURL)
{
	if(null != szObjectURL && null != szDestinationURL)
	{
		if(szObjectURL != szDestinationURL)
		{
			mf_MoveCopyObject(szObjectURL,szDestinationURL,"move", null, 2)
		}
		return(true);
	}
	return(false);
}


function f_CopyFolder(szObjectURL, szDestinationURL)
{
	if(null != szObjectURL && null != szDestinationURL)
	{
		if(szObjectURL != szDestinationURL)
		{
			mf_MoveCopyObject(szObjectURL,szDestinationURL,"copy", null, 2)
		}
		return(true);
	}
	return(false);
}
function f_UpdateFolderCount(szFolderURL)
{
	var objAnchor =   m_objAllElements(szFolderURL);

	if(null == objAnchor)return;

	var objFolderDIV;
	objFolderDIV = objAnchor.parentElement;

	if(null != objFolderDIV)
	{
		mf_UpdateCount(objFolderDIV);
	}
}

function f_RemoveFolder(szFolderURL)
{
	var objAnchor =   m_objAllElements(szFolderURL);
	var objFolderDIV;
	var iChildCount = 0;
	var objChildContainer;
	if(null == objAnchor)return;

	objFolderDIV = objAnchor.parentElement;

	if(null != objFolderDIV)
	{
		var objParentFolder = objFolderDIV.parentElement.parentElement;
		objFolderDIV.removeNode(true);

		if(null != objParentFolder)
		{
			var objChildContainer = objParentFolder.children("nodeChildrenContainer");
			if(null != objChildContainer)
			{
				var iChildCount = objChildContainer.children.length;
				if(0 == iChildCount)
				{
					objChildContainer.style.display = "none";
					objParentFolder.expanded = "false";
					objParentFolder.children("expIndicator").src = m_szImagePath + m_szNoChildrenIcon;
				}
			}
		}
	}
}

function f_CreateFolder(szParentURL,szNewFolderName, szContentClass)
{
	if(mf_IsIllegalFolderName(szNewFolderName))
	{
		mf_FireOnError(1001,"Illegal Character","Create Folder")
		return;
	}

	if(szParentURL.charAt(szParentURL.length-1) != "/")
	{
		szNewFolderName = "/" + toUTF8(szNewFolderName) + "/"
	}
	else
	{
		szNewFolderName = toUTF8(szNewFolderName) + "/"
	}
	var objContext = new Object();
	objContext.parentURL =  szParentURL;
	objContext.contentClass = szContentClass;

	var szNewLocation = szParentURL + szNewFolderName;

	var objRequest = new requestFactory(szNewLocation,"MKCOL",objContext, mfcb_CreateFolder)

	if(null == objRequest.xmlhttp) return;

	var szXML = '<a:propertyupdate xmlns:a="DAV:" xmlns:b="http://schemas.microsoft.com/mapi/proptag/" >' +
				'<a:set>' +
					'<a:prop><b:0x3613001f>' + szContentClass + '</></>' +
				'</>' +
				'</>';
	var objXMLHTTP = objRequest.xmlhttp;
	objXMLHTTP.setRequestHeader("Overwrite:", "F");
	objXMLHTTP.setRequestHeader("Content-type", "text/xml");
	objXMLHTTP.setRequestHeader("Translate", "f");
	objXMLHTTP.send(szXML);

}

function mfcb_CreateFolder(objRequest)
{
	var objXMLHTTP = objRequest.xmlhttp;
	var szStatusText = "";
	var szNewFolderURL = "";
	var iStatus = objXMLHTTP.status;

	if (iStatus == 207 || iStatus == 201)
	{
		szNewFolderURL = objXMLHTTP.getResponseHeader("Location");
		var objAnchor = m_objAllElements(objRequest.context.parentURL);
		mf_FireOnFolderOpComplete("MKCOL", iStatus, objXMLHTTP.statusText, szNewFolderURL, 2)
		mf_ExpandFolder(objAnchor.parentElement,true);
	}
	else
	{
		mf_FireOnError(iStatus, objXMLHTTP.statusText,"MKCOL");
	}

}

function f_DeleteFolder(szFolderURL)
{
	var urlIndex = szFolderURL.indexOf(m_rgSpecialFolderURL["msgfolderroot"]);
	if (urlIndex != -1) //Check to see if we are in the private store
	{
		urlIndex =  szFolderURL.indexOf(m_rgSpecialFolderURL["deleteditems"]);  //Check to see if the folder is already in deleted items

		if (urlIndex == -1)
		{
			var iOffSet = 0;
			if (szFolderURL.charAt(szFolderURL.length-1) == "/")
			{
				iOffSet = 1
			}
			var iPos = szFolderURL.lastIndexOf("/", szFolderURL.length - 1 - iOffSet);

			var szFolderName = szFolderURL.substring(iPos + 1, szFolderURL.length - iOffSet);

			var szDestination = m_rgSpecialFolderURL["deleteditems"] + szFolderName;
			mf_MoveCopyObject(szFolderURL,szDestination,"MOVE", "", 2);
		}
		else
		{
			mf_DeleteFolder(szFolderURL);
		}
	}
	else
	{
		mf_DeleteFolder(szFolderURL);
	}
}

function mfcb_DeleteFolder(objRequest)
{
	var iStatus = 0;
	var objXMLHTTP = objRequest.xmlhttp;
	iStatus = objXMLHTTP.status

	if(iStatus < 300)
	{
		f_RemoveFolder(objRequest.url);
		mf_FireOnFolderOpComplete("DELETE", iStatus, objXMLHTTP.statusText,objXMLHTTP.getResponseHeader("Location"),2)
	}
	else
	{
		mf_FireOnError(iStatus, objXMLHTTP.statusText, "DELETE")
	}

}

function f_RefreshFolder(szObjectURL)
{
	var node = m_objAllElements(szObjectURL);
	if(null != node)
	{
		var objFolderDIV = node.parentElement;
		mf_UpdateCount(objFolderDIV);
		if("true" === objFolderDIV.expanded) //Re-expand the folder
			mf_ExpandFolder(objFolderDIV, true);
	}
}

function f_RenameFolder(szObjectURL, szNewName)
{
	if(mf_IsIllegalFolderName(szNewName))
	{
		mf_FireOnError(1001,"Illegal Character","Rename Folder")
		return(false);
	}

	// Retrieve the base path minus the last folder.
	var re = /(.*\/)[^\/]+[\/]?$/;
	var rgRes = szObjectURL.match(re);
	if( null == rgRes[1] )
	{
		return(false);
	}

	var newURL = rgRes[1] + toUTF8(szNewName);
	var objFolder = m_objAllElements(szObjectURL)
	if (null==objFolder)
	{
		//If the folder is not in the tree control then return false
		return(false)
	}
	var objContext = new Object();
	objContext.folder = objFolder;
	objContext.name  = szNewName;

	var objRequest = new requestFactory(szObjectURL,"MOVE",objContext,mfcb_RenameFolder);

	var objXMLHTTP = objRequest.xmlhttp;
	if(null == objXMLHTTP) return;

	objXMLHTTP.setRequestHeader( "Destination:", newURL);
	objXMLHTTP.setRequestHeader("Overwrite:", "F");
	objXMLHTTP.setRequestHeader("Translate:", "F");
	objXMLHTTP.setRequestHeader("Allow-rename:", "t");
	objXMLHTTP.send();
}

function mfcb_RenameFolder(objRequest)
{
	var objXMLHTTP = objRequest.xmlhttp;
	var iStatus = objXMLHTTP.status;

	if(iStatus > 300)
	{
		mf_FireOnError(iStatus,objXMLHTTP.statusText, "Rename Folder")
		return;
	}

	var objContext = objRequest.context;
	var objFolder = objContext.folder;
	if(null == objFolder)
	{
		return;
	}
	var szLocation = objXMLHTTP.getResponseHeader("Location")
	objFolder.id = szLocation;
	objFolder.url = szLocation;
	objFolder.innerText = objContext.name;
	objFolder.href = szLocation;
	objFolder.parentElement.url = szLocation;

	mf_CollapseFolder(objFolder.parentElement, true);

}


function mf_ConstructBatchXML(rgObjects, szVerb)
{
	var szXMLBatchString = "<?xml version='1.0'?><a:" + szVerb + " xmlns:a='DAV:'><a:target>";

	var i;
	for(i=0; i < rgObjects.length; i++)
	{
		szXMLBatchString += "<a:href>" + rgObjects[i] + "</a:href>";
	}
	szXMLBatchString += "</a:target></a:" + szVerb + ">";
	return(szXMLBatchString);
}



function mf_DoBatchOperation(rgObjectURL, szDestinationURL, szVerb,iContentType)
{
	// Retrieve the base path minus the last folder.
	var re = /(.*\/)[^\/]*$/;
	var rgRes = rgObjectURL[0].match(re);
	if( null == rgRes[1] )
	{
		return(false);
	}

	var szXML = mf_ConstructBatchXML(rgObjectURL, String(szVerb).toLowerCase());
	mf_MoveCopyObject(rgRes[1], szDestinationURL, szVerb,szXML, iContentType);
}

function mf_LoadXSL()
{
	m_objTransformXSL = mf_GetXMLDom();
	m_objTransformXSL.async = true;
	m_objTransformXSL.onreadystatechange = mfcb_LoadXSL;
	m_objTransformXSL.load(this.viewClass);
}

function mfcb_LoadXSL()
{
	if(4 == m_objTransformXSL.readyState)
		_ideventonReady.fire();
}


function mf_UpdateCount(objFolder)
{

	var objRequest = new requestFactory(objFolder.url,"PROPFIND",objFolder, mfcb_UpdateCount)
	var http_propFind = objRequest.xmlhttp;

	if(null == http_propFind) return;

	var szPropfind = '<?xml version="1.0"?>' +
						'<a:propfind xmlns:a="DAV:" xmlns:b="urn:schemas:httpmail:" >' +
						'<a:prop><a:href/><a:hassubs/><b:unreadcount/></></>';
	http_propFind.setRequestHeader( "Depth", "0");
	http_propFind.setRequestHeader( "Brief", "t");
	http_propFind.setRequestHeader( "Content-type", "text/xml");
	http_propFind.send(szPropfind);
}
function mfcb_UpdateCount(objRequest)
{
	var objFolder = objRequest.context;

	if(null == objFolder) return;

	var objXMLHTTP = objRequest.xmlhttp;
	var objResponseXML = objXMLHTTP.responseXML;

	if(null == objResponseXML) return;

	var objUnreadNode = objResponseXML.selectSingleNode("//d:unreadcount");


	if(null != objUnreadNode)
	{
		var iUnreadCount = parseInt(objUnreadNode.text,10);
		var objUnread = objFolder.children("MSOWA_unreadcount");
		var objAnchor = objFolder.children(objFolder.url);
		if(0 < iUnreadCount)
		{
			objUnread.innerText = "(" + iUnreadCount + ")";
			objUnread.style.display = "";
			objAnchor.style.fontWeight = "bold";
		}
		else
		{
			objUnread.style.display = "none";
			objAnchor.style.fontWeight = "normal";
		}
	}

	var objHassubs = objResponseXML.selectSingleNode("//a:hassubs");

	if(null != objHassubs)
	{
		var fHassubs = coerceToBool(objHassubs.text);
		var objImg = objFolder.children("expIndicator");
		var objChildContainer = objFolder.children("nodeChildrenContainer");

		if(null != objChildContainer)
		{
			if(0 < objChildContainer.children.length && !fHassubs)
			{
				objChildContainer.innerHTML = "";
				objChildContainer.style.display = "none";
				objImg.style.cursor = "auto";
				objImg.src = m_szImagePath + m_szNoChildrenIcon;
			}
		}

		if(fHassubs && "true" !== objFolder.expanded)
		{
			objImg.src = m_szImagePath + m_szPlusIcon;
			objImg.style.cursor = "hand";
		}
	}

}



function mf_AlterXSLTests(szTestName, szTestValue)
{
	var objNode = m_objTransformXSL.selectSingleNode("//@test[. = '" + szTestName + "']");
	if(null != objNode)
	{
		objNode.value = "a:href[. $ieq$ '" + szTestValue + "']"
	}

}

function mf_MoveCopyObject(szFolderURL, szDestinationFolderURL, szCommand, szXMLRequest, iContentType)
{
	szCommand = szCommand.toUpperCase();
	var objContext = new Object();
	objContext.contentType = iContentType;
	objContext.command = szCommand;
	objContext.folderURL = szFolderURL;
	var objRequest = new requestFactory(szFolderURL,szCommand,objContext,mfcb_MoveCopy);
	objXMLHTTP = objRequest.xmlhttp;

	if(null == objXMLHTTP) return;

	objXMLHTTP.setRequestHeader( "Destination:", szDestinationFolderURL);
	objXMLHTTP.setRequestHeader( "Content-type:", "text/xml");
	objXMLHTTP.setRequestHeader("Overwrite:", "F");
	objXMLHTTP.setRequestHeader("Translate:", "F");
	objXMLHTTP.setRequestHeader("Allow-rename:", "t");
	objXMLHTTP.send(szXMLRequest);

}

function mfcb_MoveCopy(objRequest)
{
	var objXMLHTTP = objRequest.xmlhttp;
	var iStatus = objXMLHTTP.status;
	var objContext = objRequest.context;
	var szLocation = objXMLHTTP.getResponseHeader("Location");

	if(iStatus < 300)
	{
		if(2 == objContext.contentType)
		{

			var iOffSet = 0;
			if (szLocation.charAt(szLocation.length-1) == "/")
			{
				iOffSet = 1
			}

			var iPos = szLocation.lastIndexOf("/", szLocation.length - 1 - iOffSet);
			var szFolderName = szLocation.substring(0,iPos + 1);
			var objAnchor = m_objAllElements(szFolderName);
			var objSrcNode =   m_objAllElements(objContext.folderURL);

			if(null != objAnchor && null != objSrcNode)
			{
				var objOldFolder = objSrcNode.parentElement;
				var objNewFolder = objOldFolder.cloneNode(true);
				objNewFolder.url = szLocation;
				var objNewAnchor = objNewFolder.children(objSrcNode.id);
				objNewAnchor.id = szLocation;
				objNewAnchor.href = szLocation;
				if ("COPY" == objContext.command)
				{
					objNewAnchor.style.backgroundColor = "transparent";
					objNewAnchor.style.color = "windowtext";
					var objSelector = objNewFolder.children("MSOWA_selected");
					if (null != objSelector)
					{
						objSelector.id = "MSOWA_unselected";
					}
				}
				var objChildContainer = objNewFolder.children("nodeChildrenContainer");
				if(objChildContainer.children.length > 0)
				{
					objNewFolder.children("expIndicator").src = m_szImagePath + m_szPlusIcon;
					objNewFolder.children("expIndicator").style.cursor = "hand";
					objChildContainer.innerHTML = "";
					objChildContainer.style.display = "none";
				}
				objNewFolder.expanded = "false";

				var objNewParentFolder = objAnchor.parentElement;
				var objNewContainer = objNewParentFolder.children("nodeChildrenContainer");

				if("true" === objNewParentFolder.expanded || 0 < objNewContainer.children.length)
				{
					objNewContainer.insertAdjacentElement("afterBegin",objNewFolder);
				}
				else
				{
					objNewParentFolder.children("expIndicator").src = m_szImagePath + m_szPlusIcon;
					objNewParentFolder.children("expIndicator").style.cursor = "hand";
				}
			}

			if(objContext.command == "MOVE")
			{
				f_RemoveFolder(objContext.folderURL);
			}
		}
		var szStatusText    = objXMLHTTP.statusText;
		mf_FireOnFolderOpComplete(objContext.command, iStatus, szStatusText, szLocation,objContext.contentType)
	}
	else
	{
		mf_FireOnError(iStatus, objXMLHTTP.statusText,objContext.command);
	}
}


function mf_InitSpecialFolders(objResponseXML)
{

	var xmlNodes = objResponseXML.selectNodes("a:multistatus/a:response/a:propstat/a:prop/*");
	var i;
	for(i=0;i < xmlNodes.length; i++)
	{
		var szNodeText = xmlNodes.item(i).text;
		if (szNodeText.charAt(szNodeText.length-1) != "/")
		{
			szNodeText += "/"
		}
		var szBaseName = xmlNodes.item(i).baseName;
		switch(szBaseName)
		{
			case "inbox":
			case "sentitems":
			case "outbox":
			case "deleteditems":
			case "msgfolderroot":
				if("" != szNodeText)
				{
					m_rgSpecialFolderURL[szBaseName] = szNodeText;
					mf_AlterXSLTests(szBaseName, szNodeText);
				}
				break;
		}
	}
	m_rgobjXSL[mf_GetXMLDom.version] = m_objTransformXSL;
}
/******************************************/
/************PRIVATE METHODS****************/
//szURL - URL url to folder or vroot
//This function returns true if the authentication was successful or if we are already authenticated.
function mf_Authenticate(szURL)
{
	var szServerName = mf_GetServerName(szURL);
	var iStatus = 0;
	var fReturnVal = true;
	if(m_szDocumentDomain.toLowerCase() != szServerName.toLowerCase())
	{
		//Check the cache to see if already authenticated
		if(null == m_rgAuthDomains[szServerName])
		{
			/*** Send an options to the server to cause authentication to the new domain */
			var objXMLHTTP = null;
			try
			{
				objXMLHTTP = new ActiveXObject("Microsoft.xmlhttp");
				//Note: This is operation is done synchronously.
				objXMLHTTP.open( "OPTIONS", szURL,false);
				objXMLHTTP.send();
			}
			catch(e)
			{
				alert(e.description + " " + e.number)
				return(false);
			}

			if(200 != objXMLHTTP.status)
			{
				mf_FireOnError(objXMLHTTP.status, objXMLHTTP.statusText, "Authenticate")
				fReturnVal = false;
			}
			else
			{
				//Set empty string to server name.  We only use this array as a look up.
				m_rgAuthDomains[szServerName] = "";
				fReturnVal = true;
			}
		}
		else
		{
			fReturnVal = true;
		}
	}
	return(fReturnVal)
}
//objFolderDIV is the nodeContainer DIV element
//fReset = true will remove the children so when expanded the children
//will be retrieved again
function mf_CollapseFolder(objFolderDIV,fReset)
{


	var objChildContainer = objFolderDIV.children("nodeChildrenContainer");
	var iChildCount = objChildContainer.children.length;
	var objPlusIcon = objFolderDIV.children("expIndicator");
	if(fReset)
		objChildContainer.innerHTML = "";
	if("false" == objFolderDIV.expanded)
		return;

	var szImageName = "";

	if(iChildCount > 0)
	{
		objPlusIcon.style.cursor = "hand";
		szImageName = m_szPlusIcon;
	}
	else
	{
		objPlusIcon.style.cursor = "auto";
		szImageName = m_szNoChildrenIcon;
	}
	objFolderDIV.children("expIndicator").src = m_szImagePath + szImageName;
	objChildContainer.style.display = "none";
	objFolderDIV.expanded = "false";

	if(null != objChildContainer.all("MSOWA_selected"))
	{
		mf_SelectNode(objFolderDIV.children(objFolderDIV.url), true);
	}
}

//objFolderDIV is the parent container
function mf_ExpandFolder(objFolderDIV, fRefresh)
{

	var objChildContainer = objFolderDIV.children("nodeChildrenContainer");

	if(null == objChildContainer) return;

	var iChildCount = objChildContainer.children.length;
	var objIMGPlus = objFolderDIV.children("expIndicator");
	if(fRefresh || 0 == iChildCount)
	{
		var objRequest = new requestFactory(objFolderDIV.url,"SEARCH",objFolderDIV,mfcb_ExpandFolder)
		var szSearchXML = '' +
			'<searchrequest xmlns="DAV:">' +
			'<sql> Select "DAV:displayname","DAV:href","http://schemas.microsoft.com/exchange/content-href", ' +
			'"DAV:hassubs","urn:schemas:httpmail:unreadcount","DAV:contentclass","http://schemas.microsoft.com/exchange/smallicon" ' +
			'FROM Scope(\'HIERARCHICAL TRAVERSAL OF ""\') ' +
			'WHERE "DAV:ishidden" = false</></>';

		var objXMLHTTP = objRequest.xmlhttp;

		if(null == objXMLHTTP) return;

		objXMLHTTP.setRequestHeader("Content-type", "text/xml");
		objXMLHTTP.setRequestHeader("Brief", "t");
		objXMLHTTP.setRequestHeader("Translate", "f");
		objIMGPlus.src = m_szImagePath + m_szHourglassIcon;
		objXMLHTTP.send(szSearchXML);

	}
	else
	{
		var objIMGPlus = objFolderDIV.children("expIndicator");
		if(iChildCount > 0)
		{
			objChildContainer.style.display = "";
			objFolderDIV.expanded = "true";
			objIMGPlus.style.cursor = "hand";
			objIMGPlus.src = m_szImagePath + m_szMinusIcon;
		}
		else
		{
			objChildContainer.style.display = "none";
			objFolderDIV.expanded = "false";
			objIMGPlus.style.cursor = "auto";
			objIMGPlus.src = m_szImagePath + m_szNoChildrenIcon;
		}
	}

}

function mfcb_ExpandFolder(objRequest)
{

	var objFolder = objRequest.context;
	var objChildContainer = objFolder.children("nodeChildrenContainer");
	if(null != objChildContainer)
	{
		var objXML = objRequest.xmlhttp.responseXML;
		var objXSL = mf_XSLDOC(objRequest.xmlVersion);
		objChildContainer.innerHTML = objXML.transformNode(objXSL.documentElement);
		if(objChildContainer.children.length > 0)
		{
			objChildContainer.style.display = "";
			objFolder.children("expIndicator").src = m_szImagePath + m_szMinusIcon;
			objFolder.expanded = "true";
		}
		else
		{
			objChildContainer.style.display = "none";
			objFolder.children("expIndicator").src = m_szImagePath + m_szNoChildrenIcon;
			objFolder.expanded = "false";
		}
		mf_FireOnFolderOpComplete("EXPAND",objRequest.xmlhttp.status,objRequest.xmlhttp.stausText,2);
	}
}

function mf_GetXMLDom()
{
	var obj = null;
	if(null != mf_GetXMLDom.progID)
	{
		obj = new ActiveXObject(mf_GetXMLDom.progID);
	}
	else
	{
		try
		{
			obj = new ActiveXObject("MSXML2.DOMDocument");
			mf_GetXMLDom.progID = "MSXML2.DOMDocument";
			mf_GetXMLDom.version = 2;
		}
		catch(e)
		{
			obj = new ActiveXObject("Microsoft.xmldom");
			mf_GetXMLDom.progID = "Microsoft.xmldom";
			mf_GetXMLDom.version = 1;
		}
	}
	return obj;
}
mf_GetXMLDom.progID = null;
mf_GetXMLDom.version = 0;

function mf_SelectNode(node, fFireSelectFolder)
{
	var objCurSelection = m_objAllElements("msOWA_selected");
	if(null != objCurSelection)
	{
		var objAnchor = objCurSelection.nextSibling;
		objAnchor.style.backgroundColor = "transparent";
		objAnchor.style.color = "windowtext";
		objCurSelection.id = "MSOWA_unselected";
	}

	node.style.backgroundColor = "highlight";
	node.style.color = "highlighttext";
	node.previousSibling.id = "MSOWA_selected"

	if(fFireSelectFolder) mf_FireOnSelectFolder(node);

	mf_UpdateCount(node.parentElement);
}

function mf_DeleteFolder(szURL)
{
		var objRequest = new requestFactory(szURL,"DELETE",null,mfcb_DeleteFolder)
		var objXMLHTTP = objRequest.xmlhttp;

		if(null == objXMLHTTP) return;

		objXMLHTTP.send();

}

function mf_GetServerName(szURL)
{
	var rgVals = mf_GetServerName.re.exec(szURL)
	return(rgVals[1])
}
mf_GetServerName.re =  new RegExp("^https?://([^/]+)","i")


function mf_IsIllegalFolderName(szName)
{
	szName = szName.replace(/^\s+|\s+$/g, "");
	return (szName.length ==0 || mf_IsIllegalFolderName.re.test(szName));
}
mf_IsIllegalFolderName.re = /[\/\\&~\?\*\|\<\>\"\#\;:\+]/;

function mf_XMLHTTPOpen(objXMLHTTP,szCommand,szURL,fisAsync, iOpenAttempts)
{
	var i;
	for(i= 0; i < iOpenAttempts; i++)
	{
		try
		{
			objXMLHTTP.open(szCommand, szURL, fisAsync);
			break;
		}
		catch(e)
		{
			if(E_FAIL != e.number || i == iOpenAttempts - 1)
				return(e.number);
		}
	}
	return(0);
}

function mf_TransformNode(objXML, objXSL)
{
	/*create a new temporary xmldom to
	avoid sychronization issues	*/
	var objTransform = mf_GetXMLDom();
	objTransform.loadXML(objXSL.xml);
	return objXML.transformNode(objTransform.documentElement);
}

//******** Request Object Implementation ****************
//Request Object is created by calling new requestFactory
//fnCallBack is called with the request object on the call stack
//Once the callback is called the request object is destroyed automatically
function requestFactory(szURL, szCommand, objContext, fnCallBack)
{
	var objXMLHTTP;
	var i=0;
	var iErrCode = 0;

	try
	{
		this.xmlhttp = new ActiveXObject("MSXML2.xmlhttp");
		this.xmlVersion = 2;
	}
	catch(e)
	{
		this.xmlhttp = new ActiveXObject("Microsoft.xmlhttp");
		this.xmlVersion = 1;
	}
	objXMLHTTP = this.xmlhttp;

	if(2 == this.xmlVersion)
	{
		iErrCode = mf_XMLHTTPOpen(objXMLHTTP,szCommand,szURL,true, 3);
	}

	if(E_FAIL == iErrCode) //Fall back to msxml version 1
	{
		this.xmlhttp = new ActiveXObject("Microsoft.xmlhttp");
		this.xmlVersion = 1;
		objXMLHTTP = this.xmlhttp;
	}

	if(1 == this.xmlVersion)
	{
		var iErrCode = mf_XMLHTTPOpen(objXMLHTTP,szCommand,szURL,true, 1);
	}

	if( 0 != iErrCode)
	{
		mf_FireOnError(iErrCode,"",szCommand);
		this.xmlhttp = null;
		return;
	}

	if(1 == this.xmlVersion)
	{
		//Auth using synchronous call for xml version 1.0 only
		if(!mf_Authenticate(szURL))
		{
			this.xmlhttp = null
			return;
		}
	}

	if("" == m_szAcceptLang)
		objXMLHTTP.setRequestHeader("Accept-Language",window.clientInformation.userLanguage);
	else
		objXMLHTTP.setRequestHeader("Accept-Language",m_szAcceptLang);

	this.url = szURL;
	this.context = objContext;
	this.index = requestFactory.index;
	this.expand = false;
	this.lockRequest = false;
	if(null != fnCallBack)
	{
		this.callBack = fnCallBack;
		this.xmlhttp.onreadystatechange = new Function("requestDispatch(" + (this.index) + ")");
	}
	g_rgRequestFactory[this.index] = this;
	requestFactory.index += 1;
}
requestFactory.index = 0;


function requestDispatch(iIndex)
{
	//handle readystate here
	var obj = g_rgRequestFactory[iIndex];
	if(null != obj && !obj.lockRequest && 4 == obj.xmlhttp.readystate)
	{
		obj.lockRequest = true;
		obj.callBack(obj);
		delete g_rgRequestFactory[iIndex];
	}
}
// **********************************
//returns all characters utf8 encoded
function toUTF8(szInput)
{
	var x,uch="",szRet="";

	for (x=0; x<szInput.length; x++)
	{
		var wch =szInput.charCodeAt(x);
		if (!wch)
		{
			break;  // Japanese-IE5 does not give us the correct length
		}
		if (!(wch & 0xFF80))
		{
			szRet += "%" + wch.toString(16);
		}
		else if (!(wch & 0xF800))
		{
			uch = "%" + (wch>>6 | 0xC0).toString(16) +
				  "%" + (wch & 0x3F | 0x80).toString(16);
			szRet += uch;
		}
		else
		{
			uch = "%" + (wch >> 12 | 0xE0).toString(16) +
				  "%" + (((wch >> 6) & 0x3F) | 0x80).toString(16) +
				  "%" + (wch & 0x3F | 0x80).toString(16);
			szRet += uch;
		}
	}
	return(szRet);
}

function coerceToBool(obj)
{
	switch(typeof(obj))
	{
		case "boolean":		return obj;
		case "string":		return ("1" == obj || "true" == obj.toLowerCase());
		case "number":		return (0 != obj);
		default:			return false;
	}
}
