// Copyright (c) 2000-2001 Microsoft Corporation.  All rights reserved.
//<script>
var m_objRowLastSelected = null;			// last TR selected
var m_objXML = null;						// XML object returned from mf_getxml
var m_icurGrpLevel = 1;						// current group level for groupby views
var m_iCurrentPage;							// current page in the view
var m_objXSLNodes = null;					// XSL used in ongetxmlcomplete to transform data
var m_objDefaultXSLNodes = null;			// default XSL used to render a page
var m_objMSHTTP_Request=null;				// global XMLHTTP request object
var m_objXSLRequest = null;					// global XSL request object
var m_objHTMLTarget = this;					// target used when ongetxmlcomplete fires
var m_objHTTPViewDescriptor;				// xmlhttp object used in mf_loadViewDescriptorFromURL
var m_objXMLRequestQueue = null;			// queue of outstanding async XMLHTTP request
var m_iXMLQueueLength = 0;					// size of queue
var m_objParentTR = null;					// used in expandGroup to create expandos to parent TR's
var m_objGroupIMG = null;					// used in expandGroup to change IMG to a -
var m_szURL="";								// URL of the folder whose contents the view displays
var m_szScope = null;
var m_szFilter = null;
var m_szImagePath = null;
var m_szBoldUnreadItems = null;
var m_szHighlightRowStyle = null;
var m_szShadowRowStyle = null;

var m_szContextHandle = "";					// target window for navigation; non-null value indicates remember selection should fire onNavigate
var m_fSelectionType = 2;					// read-only (0), single-item (1), multiple item (2)
var m_bViewHasFocus		= false;
var m_bTabKeyPressed	= false;
var m_bFireOnReady		= false;
var m_bEventsAttached	= false;
var m_bAllowDragDrop	= true;
var m_bBoldUnreadItems	= true;
var m_bDocumentReady	= false;			// global boolean used to determine if we are loaded
var m_bIsCardView		= false;			// boolean: true means we have a card view
var m_iOnErrorGotoPage  = null;
var m_iNumRowsSelected = 0;					// number of rows selected
var m_iCardViewColumns = 3;
var m_iSeekDir = 0;							// direction to seek for orig item
var LEFT = 37;
var UP   = 38;
var RIGHT= 39;
var DOWN = 40;
var ACTION_CLICK = 1;
var ACTION_DBLCLICK = 2;
var ACTION_ENTER = 3;
var ACTION_SEEK = 4;
var ACTION_CLOSE = 5;

//Paging variables
var m_iStartRange=0;
var m_iEndRange;
var m_iRowsPerPage=0;
var m_iMaxRows;
var m_objRowRange = null;
var m_rgSelectedItems = new Array(3);

//Set global prog id's for xmlhttp and xmldom
var m_szXMLDOMProgID  = "Microsoft.xmldom";
var m_szXMLHTTPProgID = "Microsoft.xmlhttp";

var m_objViewXML;			//Contains all xsl nodes for groups and content views
var m_objViewDescription;	//Contains main view description
var m_objQueries;
var m_gCallBack;

var m_szDefaultContentProps = '"urn:schemas:httpmail:read" as read, "http://schemas.microsoft.com/exchange/outlookmessageclass" as messageclass, "DAV:href" as davhref';
var m_szDefaultGroupByProps = '"DAV:visiblecount","urn:schemas:httpmail:unreadcount"';
var m_objTransFormXSL = null; //XSL for view class
var m_rgszPropertySynonyms = new Array();
var m_szNormalizedSubject = "urn:schemas:httpmail:normalizedsubject"
var m_szDateReceivedProp  = "urn:schemas:httpmail:datereceived";
m_rgszPropertySynonyms["urn:schemas:httpmail:subject"]  = m_szNormalizedSubject
m_rgszPropertySynonyms["urn:schemas:mailheader:subject"] = m_szNormalizedSubject
m_rgszPropertySynonyms["http://schemas.microsoft.com/mapi/subject"] = m_szNormalizedSubject


function RowRange(objStartRow, objEndRow)
{
	var iDelta = objStartRow.sourceIndex - objEndRow.sourceIndex;
	var objNextRow;

	this.rangeDirection = UP;

	if (0 == iDelta)
	{
		mf_selectRecord(objStartRow,true)
	}
	else
	{
		this.rangeDirection = (iDelta < 0)?DOWN:UP;
		mf_selectRecord(objStartRow,false)
		objNextRow = mf_getNextRow(objStartRow,this.rangeDirection)

		for( ;objNextRow.uniqueID != objEndRow.uniqueID &&
			  mf_selectRecord(objNextRow,false);)
		{
			objNextRow = mf_getNextRow(objNextRow,this.rangeDirection)
		}
		mf_selectRecord(objEndRow,false);
	}
	this.startRow = objStartRow;
	this.tempEndRow = objEndRow;
	this.endRow   = objEndRow;

	this.trimRange = mf_trimRowRange;
	this.expandRange = mf_expandRange;
	this.update =  mf_updateRowRange;

}

function coerceToBool(obj)
{
	switch(typeof(obj))
	{
		case "boolean":		return obj;
		case "string":		return ("1" == obj || "true" == obj.toLowerCase());
		case "number":		return (0 != obj);
		default:			return false;
	}
}

function mf_chooseValue(objViewDescNode, szHTMLAttributeValue, szDefaultValue)
{
	if(null != szHTMLAttributeValue && "" != szHTMLAttributeValue)
	{
		return szHTMLAttributeValue;
	}
	else if(null != objViewDescNode && "" != objViewDescNode.text)
	{
		return objViewDescNode.text;
	}
	return szDefaultValue;
}

function QueryCollection(xmlViewDescription)
{
	this.xmlDescription		= xmlViewDescription;
	this.queryCollection	= new Array();
	this.defaultRestriction	= m_szFilter;
	this.scope				= m_szScope;
	this.createQueryObjects	= createQueryObjects;
	return(this.createQueryObjects(this.xmlDescription));
}

function QueryObject(parentObj, szType, xmlObj)
{
	this.parentObject = parentObj;
	this.columnPropNodes = null;
	this.selectString  = "";
	this.groupByNodes  = null;
	this.groupByString = "";
	this.orderByPropNodes = null;
	this.orderByString = "";
	this.type = szType;
	this.restriction = "";
	switch(szType)
	{
		case "content":
			 //Set column prop
			var queryNodes			= xmlObj.selectNodes("view/column/prop");
			this.columnPropNodes	= queryNodes;
			this.selectString		= createSelectSQL(queryNodes);
			this.defaultProps		= m_szDefaultContentProps;
			//Set order by node
			var orderbyNodes		= xmlObj.selectNodes("view/orderby/order");
			this.orderByPropNodes	= orderbyNodes;
			this.orderByString		= createOrderBySQL(orderbyNodes,true);
			break;
		case "categorized":
			this.defaultProps		= m_szDefaultGroupByProps;
			var objPropNodes		= xmlObj.selectNodes("prop");
			var objPropNode			= objPropNodes(0);
			this.orderByString		= createOrderBySQL(xmlObj);
			objPropNode.text		= substituteNormalizedProp(objPropNode.text);
			this.groupByString		= '"' + objPropNode.text + '" ';
			this.selectString		= createSelectSQL(objPropNodes);
			break;

		default:
			break;
	}
	this.getXMLSearchRequest = createXMLSearchRequest;
	return(this)
}

// returns XML search request including default props
function createXMLSearchRequest(szRangeType, szRangeRows, szRangeContents)
{
	var szCRLF = "\r\n";
	var szSQL = "SELECT " + this.selectString + this.defaultProps + szCRLF +
				"FROM " + this.parentObject.scope + szCRLF;
	var szRestriction;
	var fRestriction=false;
	var szXML;
	var szRange = "";
	var szOrderBy = "";

	if(this.parentObject.defaultRestriction)
	{
		szRestriction = this.parentObject.defaultRestriction;
		fRestriction = true;
	}
	if (null != this.restriction && "" != this.restriction)
	{
		if (fRestriction)
		{
			szRestriction += " AND ";
		}
		szRestriction += this.restriction;
		fRestriction = true;
	}
	if(fRestriction)
	{
		szSQL += "WHERE " + szRestriction + szCRLF;
	}
	if("categorized" == this.type)
	{
		szSQL += "GROUP BY " + this.groupByString + szCRLF;
	}
	if (null != this.orderByPrefix && "" != this.orderByPrefix)
	{
		szOrderBy = this.orderByPrefix;
	}
	if (null != this.orderByString && "" != this.orderByString)
	{
		szOrderBy += ("" != szOrderBy ? ", " : "") + this.orderByString;
	}
	if ("" != szOrderBy)
	{
		szSQL += "ORDER BY " + szOrderBy + szCRLF;
	}
	if (null != szRangeType)
	{
		szRange =	'<range type = "' + szRangeType + '"' +
					((null != szRangeRows) ? ' rows="' + szRangeRows + '">' : '>') +
					'</range>';
	}
	szXML = '<searchrequest xmlns="DAV:" ><sql></sql>' + szRange + '</searchrequest>';
	var objSearchXML = new ActiveXObject(m_szXMLDOMProgID);
	objSearchXML.loadXML(szXML);
	var objNode = objSearchXML.selectSingleNode("searchrequest/sql");
	objNode.text = szSQL;
	objNode = objSearchXML.selectSingleNode("searchrequest/range");
	if (null != objNode)
	{
		objNode.text = ("find" == szRangeType ? "WHERE " : "" ) + szRangeContents;
	}
	return(objSearchXML.xml);
}

// returns SQL search request withOUT default props
function createSQLSearchRequest()
{
	var szCRLF = "\r\n";
	var szSQL = "";
	var szOrderByString = "";
	var fRestriction=false;
	var szSelectString = createNamedSelectSQL(m_objViewDescription.selectNodes("/view/column"));
	var objOrderByColl = m_objViewDescription.selectNodes("/view/groupby/order | /view/orderby/order");
	var objProp, objSort;
	var e = new Enumerator( objOrderByColl );
	for (;!e.atEnd();e.moveNext())
	{
		objProp	= e.item().selectSingleNode("prop");
		objSort	= e.item().selectSingleNode("sort");
		if(null != objProp && "" != objProp.text)
		{
			szOrderByString += '"' + substituteNormalizedProp(objProp.text) + '"' + ((null == objSort) ? " ASC" : (" " + objSort.text)) + ", ";
		}
	}
	// remember to remove last space & comma
	szOrderByString = szOrderByString.substring(0,szOrderByString.length-2);
	szSQL = "SELECT " + szSelectString + szCRLF +
			"FROM " + m_szScope + szCRLF +
			((null != m_szFilter) ? "WHERE " + m_szFilter : "") + szCRLF +
			(("" == szOrderByString) ? "" : "ORDER BY " + szOrderByString);
	return (szSQL);
}


function createQueryObjects(xmlViewObject)
{
	var objGroupByNodes = xmlViewObject.selectNodes("view/groupby/order");
	var objQueryObject;
	var szOrderByPrefix = "";
	var i = 0;
	if (objGroupByNodes)
	{
		var e = new Enumerator( objGroupByNodes );
		for (;!e.atEnd();e.moveNext())
		{
			this.queryCollection[i] = objQueryObject = new QueryObject(this, "categorized", e.item());
			szOrderByPrefix = objQueryObject.groupByString + " ASC";
			i++;
		}
	}
	objQueryObject = new QueryObject(this, "content", xmlViewObject);
	objQueryObject.orderByPrefix = szOrderByPrefix;
	this.queryCollection[i] = objQueryObject;
	return(this.queryCollection);
}


/*************************BEGIN PROPERTY ACCESS FUNCTIONS********************************/

function attachEvents(fAttach)
{
	var eventMethod = fAttach ? this.attachEvent : this.detachEvent;
	m_bEventsAttached = fAttach;
	eventMethod("onblur",onblur);
	eventMethod("onclick",onclick);
	eventMethod("ondblclick",ondblclick);
	eventMethod("ondragstart",ondragstart);
	eventMethod("onfocus",onfocus);
	eventMethod("onkeydown",onkeydown);
	eventMethod("onmousedown",onmousedown);
	eventMethod("onmouseup",onmouseup);
	eventMethod("onselectstart",onselectstart);
}

function put_selectionType(szString)
{
	m_fSelectionType = parseInt(szString,10);
}
function get_selectionType()
{
	return m_fSelectionType;
}
function get_rowsPerPage()
{
	return(m_iRowsPerPage)
}
function put_rowsPerPage(iNum)
{
	var num = parseInt(iNum,10);
	if(isNaN(num))
	{
		return false;
	}
	m_iRowsPerPage = num;
	return true;
}

function get_page()
{
	return (m_iCurrentPage);
}
function put_page(varPage)
{
	var iPage;
	if (isNaN(iPage = parseInt(varPage,10)) )
	{
		iPage = 1;
	}
	if(m_bDocumentReady)
	{
		f_gotoPage(iPage);
	}
	else
	{
		m_iCurrentPage = iPage;
	}
}
function get_query()
{
	return createSQLSearchRequest();
}

function put_url(szURL)
{
	m_szURL = szURL;
	if(m_bDocumentReady)
	{
		m_iCurrentPage = 1;
	}
}
function get_url()
{
	return m_szURL;
}

function put_dragDrop(obj)
{
	m_bAllowDragDrop = coerceToBool(obj);
}

function get_dragDrop()
{
	return m_bAllowDragDrop;
}
function put_boldUnreadItems(obj)
{
	m_bBoldUnreadItems = coerceToBool(obj);
}
function get_boldUnreadItems()
{
	return m_bBoldUnreadItems;
}
function get_startRange()
{
	return m_iStartRange + 1;
}
function put_startRange(varRow)
{
	// User items go from 1..n, NOT 0 .. n-1
	var iRow = parseInt(varRow,10) - 1;
	if (m_bDocumentReady && iRow >= m_iMaxRows)
	{
		iRow = m_iMaxRows - 1;
	}
	if (iRow < 0)
	{
		iRow = 0;
	}
	m_iStartRange = iRow;
}

function get_endRange()
{
	return m_iEndRange + 1;
}
function put_endRange(varRow)
{
	var iRow = parseInt(varRow,10) - 1;
	if (m_bDocumentReady && iRow < m_iStartRange)
	{
		iRow = m_iStartRange;
	}
	m_iEndRange = iRow;
}
/*************************END PROPERTY ACCESS FUNCTIONS********************************/

/*************************BEGIN EVENT HANDLER FUNCTIONS********************************/

function attachFocusEvents(obj)
{
	if(null != obj && !obj.fEventsAttached)
	{
		obj.attachEvent("onfocus",onfocus);
		obj.attachEvent("onblur",onblur);
		obj.fEventsAttached = true;
	}
}
function expandGroup(objElement)
{
	var objTR = objElement.parentElement;
	var objIMG = objElement.firstChild;
	var objNextTR = objTR.parentElement.rows(objTR.rowIndex + 1);
	objNextTR.style.display = ("" == objNextTR.style.display)?"none":"";
	if ("" == objNextTR.style.display)
	{
		if(objNextTR.firstChild.isCached != true)
		{
			m_objParentTR = objTR;
			m_objGroupIMG = objIMG;
			objIMG.src = m_szImagePath + "hourglass.gif";
			mf_getNodeData(objNextTR.firstChild,objElement);
			m_objGroupIMG = null;
		}
		else
		{
			objIMG.src = m_szImagePath + "view-minus.gif";
		}
		objTR.isExpanded = true;
	}
	else
	{
		objIMG.src = m_szImagePath + "view-plus.gif";
		objTR.isExpanded = false;
	}
}

function onselectstart()
{
	if("ignoreEvent" == event.returnValue)
	{
		return;
	}
	event.cancelBubble = true;
	event.returnValue = false;
}

function ondocumentready()
{
	m_objXMLRequestQueue = new Array();
	m_objHTMLTarget = this;
	m_iXMLQueueLength = 0;
	this.tabIndex=0;
	this.hideFocus = true;
	this.cachedViewDescriptor = null;
	//Get the xsl file - async op
	mf_loadXSL();
	//Get the view descriptor - async op
	mf_loadViewDescriptor();
	//Async ops will synchronise in mf_initializeQueries.  mf_initializeQueries will
	//query the web store
	m_bFireOnReady = true;
	if (m_fSelectionType >= 1 && !m_bEventsAttached)
	{
		attachEvents(true);
	}
	else if(m_fSelectionType < 1)
	{
		attachEvents(false);
	}
}

function onArrowKeyPress(iDirection)
{
	if(RIGHT == iDirection || LEFT == iDirection)
	{
		if (null != m_objRowLastSelected && "true" == m_objRowLastSelected.isGroupHeader)
		{
			if(null == m_objRowLastSelected.isExpanded)
			{
				m_objRowLastSelected.isExpanded = false;
			}
			if(m_objRowLastSelected.isExpanded == (LEFT == iDirection))
			{
				expandGroup(m_objRowLastSelected.firstChild);
				return;
			}
		}
		iDirection = (RIGHT == iDirection) ? DOWN : UP;
	}
	var objNextRow = mf_getNextRow(m_objRowLastSelected,iDirection);
	if(!objNextRow) return;
	if(!event.shiftKey || 1 == m_fSelectionType)
	{
		m_objRowRange = null;
		mf_unselectAll();
		mf_selectRecord(objNextRow, true);
		mf_scrollIntoView(objNextRow);
		m_objRowLastSelected = objNextRow;
		mf_fireOnSelectionChange(objNextRow,true);
	}
	else
	{
		var iNumSelected = m_iNumRowsSelected;
		if (null == m_objRowRange)
		{
			m_objRowLastSelected.id = "rowSelectedException";
			mf_unselectAll();
			m_objRowLastSelected.id = "selected";
			m_objRowRange = new RowRange(m_objRowLastSelected, objNextRow);
			mf_scrollIntoView(objNextRow);
			mf_fireOnSelectionChange(objNextRow,m_iNumRowsSelected > iNumSelected);
		}
		else
		{
			m_objRowRange.endRow = objNextRow;
			m_objRowRange.update();
			m_objRowLastSelected = objNextRow;
			mf_scrollIntoView(objNextRow);
			mf_fireOnSelectionChange(objNextRow,m_iNumRowsSelected > iNumSelected);
		}
	}
}

function onEnterKeyPress()
{
	var f_isGroupOp = false;
	var objAnchors = this.all("selected");
	if (null != objAnchors)
	{
		if (objAnchors.length)
		{
			var e = new Enumerator( objAnchors );
			for (;!e.atEnd();e.moveNext())
			{
				objRow = e.item();
				if(f_isGroupOp = (objRow.isGroupHeader == "true"))
				{
					break;
				}
			}
		}
		else
		{
			objRow = objAnchors;
			f_isGroupOp = (objRow.isGroupHeader == "true");
		}
	}
	if(f_isGroupOp)
	{
		mf_toggleSelectedGroups(!m_objRowLastSelected.isExpanded);
	}
	else if(null != m_objRowLastSelected)
	{
		mf_fireOnNavigate(m_objRowLastSelected,ACTION_ENTER);
	}
}

function onkeydown()
{
	if("ignoreEvent" == event.returnValue) return;
	var f_isMinus=null;
	switch(event.keyCode)
	{
		case 9: //tab
			m_bTabKeyPressed = true;
			break;
		case 13: //enter
			onEnterKeyPress();
			event.cancelBubble = true;
			event.returnValue = false;
			break;
		case 33: // page up
			f_previousPage();
			event.cancelBubble = true;
			event.returnValue = false;
			break;
		case 34: // page down
			f_nextPage();
			event.cancelBubble = true;
			event.returnValue = false;
			break;
		case 35: //end
			f_gotoPage(-1);
			break;
		case 36: //home
			f_gotoPage(1);
			break;
		case LEFT:
		case UP:
		case RIGHT:
		case DOWN:
			onArrowKeyPress(event.keyCode);
			event.cancelBubble = true;
			event.returnValue = false;
			break;
		case 107: //plus
			f_isMinus = false;
		case 109: //minus
			f_isMinus = (null == f_isMinus) ? true : f_isMinus;
			if(null != m_objRowLastSelected && "true" === m_objRowLastSelected.isGroupHeader && f_isMinus == m_objRowLastSelected.isExpanded)
			{
				expandGroup(m_objRowLastSelected.firstChild);
			}
			event.cancelBubble = true;
			event.returnValue = false;
			break;
	}
}

function onclick()
{
	var obj = event.returnValue;
	if(null == obj || "ignoreEvent" == event.returnValue) return;
	if("TD" == obj.tagName && "tdColumn" == obj.id && 1 == obj.sortable)
	{
		mf_changeSortOrder(obj, event.shiftKey);
	}
	event.cancelBubble = true;
	event.returnValue = false;
}

function ondblclick()
{
	var obj = event.returnValue;
	if(null == obj || "ignoreEvent" == event.returnValue) return;
	if("TR" == obj.tagName || (m_bIsCardView && "A" == obj.tagName))
	{
		mf_fireOnNavigate(obj,ACTION_DBLCLICK);
	}
	else if ("groupHeaderText" == obj.id)
	{
		expandGroup(obj);
	}
	event.cancelBubble = true;
	event.returnValue = false;
}

function onmousedown()
{
	var iNumRowsSelected = m_iNumRowsSelected;
	var obj = event.srcElement;
	if ("IMG" == event.srcElement.tagName)
	{
		obj = event.srcElement.parentElement;
	}
	attachFocusEvents(obj);
	obj = event.returnValue;
	if(null == obj || "ignoreEvent" == event.returnValue)
	{
		return;
	}
	if("groupHeaderActivator" == obj.id)
	{
		if (1 == event.button)
		{
			expandGroup(obj.parentElement);
			var objRow = obj.parentElement.parentElement;
			mf_unselectAll();
			mf_selectRecord(objRow,true);
			mf_scrollIntoView(objRow);
			m_objRowLastSelected = objRow;
			event.cancelBubble = true;
			event.returnValue = false;
			return;
		}
		else
		{
			obj = obj.parentElement.parentElement;
		}
	}
	if("selected" == obj.id && !event.shiftKey)
	{
		onmouseup.bCtrlKey = event.ctrlKey;
		onmouseup.objRow = obj;
		return;
	}
	else
	{
		onmouseup.objRow = null;
	}
	var objContentRow = obj;
	if(event.ctrlKey && 2 == m_fSelectionType)
	{
		m_objRowRange = null;
		if ("selected" == objContentRow.id)
		{
			mf_unselectRecord(objContentRow,true);
		}
		else if (mf_selectRecord(objContentRow, true))
		{
			m_objRowLastSelected = objContentRow;
		}
	}
	else if(event.shiftKey && 2 == m_fSelectionType)
	{
		if (m_objRowRange == null)
		{
			if (m_objRowLastSelected != null)
			{
				mf_unselectAll();
				m_objRowRange = new RowRange(m_objRowLastSelected, objContentRow);
			}
			else
			{
				m_objRowRange = new RowRange(objContentRow, objContentRow);
			}
		}
		else
		{
			m_objRowRange.endRow = objContentRow;
			m_objRowRange.update();
			m_objRowLastSelected = objContentRow;
		}
		mf_fireOnSelectionChange(objContentRow,m_iNumRowsSelected > iNumRowsSelected);
	}
	else
	{
		m_objRowRange = null;
		mf_unselectAll();
		mf_selectRecord(objContentRow,true);
	}
}
function onmouseup()
{
	if (null == onmouseup.objRow) return;
	if(onmouseup.bCtrlKey)
	{
		mf_unselectRecord(onmouseup.objRow,true);
	}
	else
	{
		m_objRowRange = null;
		mf_unselectAll();
		mf_selectRecord(onmouseup.objRow,true);
	}
	onmouseup.objRow = null;
}

onmouseup.bCtrlKey = false;
onmouseup.objRow = null;

function ondragstart()
{
	if(!m_bAllowDragDrop || "ignoreEvent" == event.returnValue)
	{
		event.cancelBubble = true;
		event.returnValue = false;
		return;
	}
	var dataString = f_getItems();
	if(dataString.length > 0)
	{
		window.event.dataTransfer.effectAllowed = "all";
		window.event.dataTransfer.setData("Text", dataString);
	}
}
function checkResponseData(szContentRange,objContentRangeXML,iStatus,szStatusText)
{
	if(416 == iStatus && m_objHTMLTarget.isOutermostTarget)
	{
		if(m_iCurrentPage > 1)
		{
			this.previousPage();
		}
		else
		{
			mf_updatePageInfo(szContentRange,objContentRangeXML);
			mf_fireOnRefresh();
		}
	}
	else if (iStatus < 400)
	{
		var objContentRange = m_objXML.selectSingleNode("//a:contentrange");
		if (null == objContentRange || objContentRange.getAttribute("a:status") < 400)
		{
			var szMatching = null;
			mf_updatePageInfo(szContentRange,objContentRangeXML);
			if (null != objContentRange)
			{
				szMatching = objContentRange.getAttribute("a:matching");
			}
			if (null != szMatching && "" != szMatching)
			{
				mf_restoreSelections.matchingRow = parseInt(szMatching,10);
				if (mf_restoreSelections.matchingRow >= m_iRowsPerPage)
				{
					mf_restoreSelections.matchingRow = m_iRowsPerPage - 1;
				}
			}
			m_gCallBack(iStatus);
		}
		else if (null != m_iOnErrorGotoPage)
		{
			mf_restoreSelections.matchingRow = (m_iOnErrorGotoPage  < 1 ? m_iRowsPerPage - 1 : 1);
			f_gotoPage(m_iOnErrorGotoPage);
			m_iOnErrorGotoPage = null;
		}
		else
		{
			mf_multiStatusError(szContentRange,objContentRangeXML,iStatus,szStatusText);
		}
	}
	else
	{
		mf_fireOnError(iStatus,szStatusText,m_objXML,"");
	}
	mf_fireOnReady();
}

function ongetxmlcomplete(queueIndex)
{
	var queueEntry = m_objXMLRequestQueue[queueIndex];
	if (null != queueEntry)
	{
		m_objMSHTTP_Request = queueEntry.XMLHTTPRequest;
		if (null != m_objMSHTTP_Request && 4 == m_objMSHTTP_Request.readyState && !queueEntry.lockRequest)
		{
			restoreContext(queueEntry);
			// delete this item from the queue
			delete(m_objXMLRequestQueue[queueIndex]);
			// delete the ready state function
			delete(m_objMSHTTP_Request.onreadystatechange);
			var objContentRangeXML = (null != m_objXML) ? m_objXML.selectSingleNode("/a:multistatus/a:contentrange") : null;
			m_objHTMLTarget.isCached = true;
			m_objHTMLTarget.isOutermostTarget = !("TD" == m_objHTMLTarget.tagName);
			checkResponseData(m_objMSHTTP_Request.getResponseHeader("content-range"),objContentRangeXML,m_objMSHTTP_Request.status,m_objMSHTTP_Request.statusText);
			m_objMSHTTP_Request = null;
		}
	}
}
function mf_selectFirstRow(objTarget)
{
	var objColl = objTarget.all("unSelected");
	var obj;
	if(null != objColl)
	{
		// highlight the first row without navigating!
		obj = (null != objColl.length) ? objColl(0) : objColl;
		mf_selectRecord(obj,true);
	}
	else if (null != (objColl = objTarget.all("groupHeaderRow")))
	{
		obj = (null != objColl.length) ? objColl(0) : objColl;
		mf_selectRecord(obj,true);
	}
}

function mf_selectRowByNumber(iRow, objTarget)
{
	if (null == iRow || null == objTarget)
	{
		return false;
	}
	var objUnselectedItems = objTarget.all("unSelected");
	if (null != objUnselectedItems)
	{
		if (0 == iRow || null == objUnselectedItems.length)
		{
			mf_selectFirstRow(objTarget);
		}
		else
		{
			iRow = (iRow < objUnselectedItems.length ? iRow : objUnselectedItems.length - 1);
			var objRow = objUnselectedItems(iRow);
			mf_selectRecord(objRow,true);
			objRow.scrollIntoView(true);
		}
		return true;
	}
	return false;
}

function onfocus()
{
	if(m_bViewHasFocus || !m_bDocumentReady) return;
	m_bViewHasFocus = true;		// we now have focus
	mf_changeSelectedRowsStyle(m_szHighlightRowStyle);
	if(null == this.all("selected"))
	{
		mf_selectFirstRow(this);
	}
	else if(null != m_objRowLastSelected)
	{
		mf_scrollIntoView(m_objRowLastSelected);
	}
}

function onblur()
{
	if(!m_bDocumentReady || !m_bViewHasFocus) return;
	if(!element.contains(element.document.elementFromPoint( event.clientX, event.clientY )) || m_bTabKeyPressed)
	{
		m_bViewHasFocus = false;
		m_bTabKeyPressed = false;
		mf_changeSelectedRowsStyle(m_szShadowRowStyle);
	}
}

function createSelectSQL(objColProps)
{
	var szSQL = "";
	var iPropNum = 1;
	objColProps.reset();
	for(var obj = objColProps.nextNode(); null != obj; obj = objColProps.nextNode() )
	{
		if( 0 == obj.text.length)
		{
			continue;
		}
		szSQL += ' "' + obj.text + '" as prop' + iPropNum + ",";
		iPropNum++;
	}
	return szSQL;
}

function createNamedSelectSQL(objColumns)
{
	var szSQL = "";
	var szHeading = "";
	var objProp, objHeading;
	for (i = 0; i < objColumns.length; i++)
	{
		objProp		= objColumns(i).selectSingleNode("prop");
		objHeading	= objColumns(i).selectSingleNode("heading");
		if(null != objProp && null != objHeading && 0 != objProp.text.length && 0 != objHeading.text.length)
		{
			szHeading = objHeading.text.replace(/ /g,"_");
			szHeading = szHeading.replace(/"/g,'""');
			szSQL += ' "' + objProp.text + '" as ' + '"' + szHeading + '",';
		}
	}
	// remember to remove last comma
	return(szSQL.substring(0,szSQL.length-1));
}

function substituteNormalizedProp(szPropText)
{
	return ((null == m_rgszPropertySynonyms[szPropText]) ? szPropText : m_rgszPropertySynonyms[szPropText]);
}
function createOrderByString(objOrderNode)
{
	var objProp = objOrderNode.selectSingleNode("prop");
	var objSort = objOrderNode.selectSingleNode("sort");
	var szSQLFragment = '"' + substituteNormalizedProp(objProp.text) + '" ';

	if(null == objSort)
	{
		objSort = objOrderNode.ownerDocument.createNode("1","sort","");
		objOrderNode.appendChild(objSort);
		var objType = objOrderNode.selectSingleNode("type");
		objSort.text = (null != objType && objType.text.substr(0,4).toUpperCase() == "DATE") ? 'DESC' : 'ASC';
	}
	return szSQLFragment + objSort.text;
}


function createOrderBySQL(objOrderNodes, bIsContentView)
{
	var szSQLFragment = "";
	if (null != objOrderNodes)
	{
		if (null != objOrderNodes.length)
		{
			var obj = objOrderNodes.nextNode();
			if( null != obj )
			{
				szSQLFragment = createOrderByString( obj );
			}
			while( null != (obj = objOrderNodes.nextNode()) )
			{
				szSQLFragment += ',' + createOrderByString(obj);
			}
		}
		else
		{
			szSQLFragment = createOrderByString(objOrderNodes);
		}
	}
	if ( bIsContentView && szSQLFragment.indexOf(m_szDateReceivedProp) < 0)
	{
		var szAppendix = '"' + m_szDateReceivedProp + '" DESC';
		szSQLFragment += ("" != szSQLFragment ? ", " : "") + szAppendix;
	}

	return(szSQLFragment);
}

function createViewXML(objViewXML, objTransFormXSL)
{
	var objXML = new ActiveXObject(m_szXMLDOMProgID);
	objViewXML.transformNodeToObject(objTransFormXSL.documentElement, objXML);
	if(0 != objXML.parseError.errorCode)
	{
		mf_handleParseError(objXML.parseError);
	}
	if(0 != objTransFormXSL.parseError.errorCode)
	{
		mf_handleParseError(objTransFormXSL.parseError);
	}
	return(objXML);
}

/*************************END EVENT HANDLER FUNCTIONS********************************/

/*************************BEGIN PUBLIC METHOD FUNCTIONS********************************/

function mf_createAnchorXML(objAnchor, objItemNode, objRootNode)
{
	var objItemCloneNode = objItemNode.cloneNode(true);
	var node = objItemCloneNode.selectSingleNode("content-class");
	node.text = objAnchor.messageClass;
	node = objItemCloneNode.selectSingleNode("a:href");
	node.text = objAnchor._href;
	objRootNode.appendChild(objItemCloneNode);
}

function f_getItems(bReturnXMLDOM,bUnboldRows)
{
	var szDataString="";
	var m_bstrXML = '<transferdata xmlns:a="DAV:">\n' +
					'	<item>\n' +
					'		<content-class></content-class>\n' +
					'		<a:href></a:href>\n' +
					'	</item>\n' +
					'</transferdata>';

	var objXML = new ActiveXObject(m_szXMLDOMProgID);
	objXML.loadXML(m_bstrXML);
	var objRootNode = objXML.documentElement;
	var objItemNode = objRootNode.selectSingleNode("item");
	var objSelectedItems = this.all("selected");
	var bHaveItems = false;
	if (null != objSelectedItems)
	{
		if (null != objSelectedItems.length)
		{
			var e = new Enumerator( objSelectedItems );
			for (;!e.atEnd();e.moveNext())
			{
				obj = e.item();
				// Add this row ONLY IF the row is NOT a group header
				if(!("true" == obj.isGroupHeader))
				{
					mf_createAnchorXML(obj,objItemNode,objRootNode);
					if (bUnboldRows) mf_unboldRow(obj);
					bHaveItems = true;
				}
			}
		}
		else if (!("true" == objSelectedItems.isGroupHeader))
		{
			mf_createAnchorXML(objSelectedItems, objItemNode, objRootNode);
			if (bUnboldRows) mf_unboldRow(objSelectedItems);
			bHaveItems = true;
		}
		objRootNode.removeChild(objItemNode);
		szDataString = (bHaveItems ? objRootNode.xml : "");
	}
	else
	{
		objXML = null;
	}
	return (bReturnXMLDOM ? objXML : szDataString);
}

function f_nextPage()
{
	var iStartRange = m_iStartRange + m_iRowsPerPage;
	if (iStartRange < m_iMaxRows)
	{
		f_changePage(iStartRange);
	}
}

function f_previousPage()
{
	var iStartRange = m_iStartRange - m_iRowsPerPage;
	iStartRange = (iStartRange < 0) ? 0 : iStartRange;
	if (iStartRange != m_iStartRange)
	{
		f_changePage(iStartRange);
	}
}

function f_gotoPage(iPage)
{
	var iStartRange;
	if (iPage < 1)
	{
		mf_restoreSelections.matchingRow = m_iRowsPerPage - 1;
		iStartRange = m_iMaxRows - m_iRowsPerPage;
		if (iStartRange < 0)
			iStartRange = 0;
	}
	else
	{
		if (1 == iPage)
		{
			mf_restoreSelections.matchingRow = 0;
		}
		iStartRange = (iPage - 1)* m_iRowsPerPage;
	}
	if (iStartRange < m_iMaxRows && iStartRange >= 0)
	{
		f_changePage(iStartRange);
	}
}

function f_changePage(iStartRange)
{
	var iEndRange = iStartRange + m_iRowsPerPage - 1;
	m_gCallBack = mf_fireOnSoftRefresh;
	m_szContextHandle = "";
	m_objHTMLTarget = this;
	m_icurGrpLevel = 1;
	m_objRowRange = null;
	m_objRowLastSelected = null;
	szSearchXML = m_objQueries[0].getXMLSearchRequest("row",null,iStartRange.toString(10) + "-" + iEndRange.toString(10));
	mf_rememberSelections();
	mf_getXML(m_szURL, szSearchXML);
}

function f_refresh(b_isHardRefresh)
{
	if (!m_bDocumentReady)
	{
		return;
	}
	if(null == b_isHardRefresh || false == b_isHardRefresh)
	{
		mf_softRefresh();
	}
	else
	{
		m_iCurrentPage = 1;
		m_iStartRange = 0;
		m_iEndRange = m_iStartRange + m_iRowsPerPage - 1;
		ondocumentready();
	}
}

function f_seekURL(szItemURL, iOffsetDir, szContextHandle)
{
	mf_unselectAll();
	var rgSelectedURLs = new Array();
	rgSelectedURLs[szItemURL] = true;
	m_rgSelectedItems[0] = null;
	m_rgSelectedItems[1] = null;
	m_rgSelectedItems[2] = rgSelectedURLs;
	m_szContextHandle = szContextHandle;
	m_iSeekDir = 0;
	if (iOffsetDir > 0)
		m_iSeekDir = 1;
	else if (iOffsetDir < 0)
		m_iSeekDir = -1;

	var iReturnState = mf_restoreSelections(iOffsetDir);
	// if orig & next found (2), navigate to page
	// if possibility of item on another page of non-groupby views [orig not found (0), orig found but not next (1)], refresh viewer
	// otherwise, close window
	if (2 == iReturnState)
	{
		mf_fireOnNavigate(m_objRowLastSelected,ACTION_SEEK);
	}
	else if (1 == m_objQueries.length && (0 == iReturnState || m_iSeekDir != 0))
	{
		m_rgSelectedItems[0] = null;
		m_rgSelectedItems[1] = null;
		m_rgSelectedItems[2] = rgSelectedURLs;
		m_objHTMLTarget = this;
		m_icurGrpLevel = 1;
		m_objRowRange = null;
		m_objRowLastSelected = null;
		m_gCallBack = mf_fireOnSoftRefresh;
		m_szContextHandle = szContextHandle;
		szSearchXML = m_objQueries[m_icurGrpLevel - 1].getXMLSearchRequest("url",m_iRowsPerPage.toString(10)*((m_iSeekDir > -1) ? 1 : -1),szItemURL);
		mf_getXML(m_szURL, szSearchXML);
	}
	else
	{
		mf_fireOnNavigate(m_objRowLastSelected,ACTION_CLOSE);
	}
}

function f_getSortOrderInfo()
{
	var objSortOrderInfo = new Object();
	objSortOrderInfo.prop = mf_getOrderByNode("prop");
	objSortOrderInfo.type = mf_getOrderByNode("type");
	objSortOrderInfo.dir  = mf_getOrderByNode("sort");
	objSortOrderInfo.heading = mf_getPrimarySortHeading();
	objSortOrderInfo.isSeekable = ("string" == objSortOrderInfo.type && m_objQueries.length < 2);
	return objSortOrderInfo;
}
/*************************END PUBLIC METHOD FUNCTIONS********************************/
/*************************BEGIN PRIVATE FUNCTIONS********************************/

function f_seekToItem(szItemText)
{
	var objSortInfo = f_getSortOrderInfo();
	if (!objSortInfo.isSeekable)
	{
		return false;
	}
	m_iNumRowsSelected = 0;
	m_objRowRange = null;
	m_objRowLastSelected = null;
	m_szContextHandle = "";
	var szRelOp = ("DESC" == objSortInfo.dir ? " <= " : " >= ");
	var szRangeText = '"' + substituteNormalizedProp(objSortInfo.prop) + '"' + szRelOp + "'" + szItemText + "'";
	var szSearchXML = m_objQueries[0].getXMLSearchRequest("find",m_iRowsPerPage.toString(),szRangeText);
	m_gCallBack = mf_fireOnSoftRefresh;
	mf_rememberSelections();
	m_iOnErrorGotoPage = ("DESC" == objSortInfo.dir ? 1 : -1);
	mf_getXML(m_szURL, szSearchXML);
	return true;
}


function mf_getOrderByNode(szSubnode)
{
	var objNode = m_objViewDescription.selectSingleNode("/view/orderby/order/" + szSubnode);
	return (null == objNode ? null : objNode.text);
}
function mf_getPrimarySortHeading()
{
	var objHeadingNode = null;
	var szPropText = mf_getOrderByNode("prop");
	if (null != szPropText)
	{
		 objHeadingNode = m_objViewDescription.selectSingleNode("/view/column[prop = '" + szPropText + "']/heading");
	}
	return (null == objHeadingNode ? "" : objHeadingNode.text);
}
function mf_setAttributes()
{
	if (m_szURL == null || "" == m_szURL)
	{
		m_szURL = window.location.protocol + "//" +  window.location.host + window.location.pathname;
	}
	m_iCurrentPage			= parseInt(mf_chooseValue(m_objViewDescription.selectSingleNode("view/page"),this.page,"1"),10);
	m_szScope				= mf_chooseValue(m_objViewDescription.selectSingleNode("view/scope"),this.scope,"Scope('SHALLOW TRAVERSAL OF \"\"')");
	m_szFilter				= mf_chooseValue(m_objViewDescription.selectSingleNode("view/filter"),this.filter,null);
	m_szImagePath			= mf_chooseValue(m_objViewDescription.selectSingleNode("view/imagePath"),this.imagePath,"/exchweb/img/");
	m_szBoldUnreadItems		= mf_chooseValue(m_objViewDescription.selectSingleNode("view/boldUnreadItems"),m_bBoldUnreadItems.toString(10),"true");
	m_szHighlightRowStyle	= mf_chooseValue(m_objViewDescription.selectSingleNode("view/highlightrowstyle"),null,"background-color:HIGHLIGHT;color:HIGHLIGHTTEXT");
	m_szShadowRowStyle		= mf_chooseValue(m_objViewDescription.selectSingleNode("view/shadowrowstyle"),null,"background-color:THREEDFACE");
	put_rowsPerPage(mf_chooseValue(m_objViewDescription.selectSingleNode("view/rowsPerPage"),this.rowsPerPage,"0"));

}

function mf_softRefresh()
{
	m_objHTMLTarget = this;
	m_objXSLNodes = m_objViewXML.selectNodes("view/group/xsl:template");
	m_objDefaultXSLNodes = m_objXSLNodes;
	m_icurGrpLevel = 1;
	m_iNumRowsSelected = 0;
	m_objRowRange = null;
	m_objRowLastSelected = null;
	m_iEndRange = m_iStartRange + m_iRowsPerPage - 1;
	var szRangeContents = m_iStartRange.toString(10) + "-" + m_iEndRange.toString(10);
	var szSearchXML = m_objQueries[0].getXMLSearchRequest("row",null,szRangeContents);
	m_gCallBack = mf_fireOnSoftRefresh;
	m_szContextHandle = "";
	mf_rememberSelections();
	mf_getXML(m_szURL, szSearchXML);
}
function mf_initializeQueries()
{
	if(mf_initializeQueries.viewDescriptorReadyState && mf_initializeQueries.viewClassReadyState)
	{
		m_bIsCardView = (m_objViewDescription.selectSingleNode("/view/card") != null);
		mf_setAttributes();
		mf_alterViewDescriptor();
		m_objQueries = new QueryCollection(m_objViewDescription);
		m_objViewXML = createViewXML(m_objViewDescription,m_objTransFormXSL);
		//********** Bail out if view descriptor is null *****
		if(null == m_objViewXML) return;

		if(0 == m_objViewXML.parseError.errorCode)
		{
			//Reset gate
			mf_initializeQueries.viewDescriptorReadyState = false;
			mf_initializeQueries.viewClassReadyState      = false;
			mf_softRefresh();
		}
		else
		{
			mf_handleParseError(m_objViewXML.parseError);
		}
	}
}
mf_initializeQueries.viewDescriptorReadyState = false;
mf_initializeQueries.viewClassReadyState      = false;

function mf_scrollIntoView(objRow)
{
	var objFocalPoint = null;
	if(!objRow)
	{
		return;
	}
	if("TD" == objRow.firstChild.tagName)
	{
		objFocalPoint = objRow.firstChild;
	}
	else
	{
		var objFocalPoint = objRow.firstChild.firstChild.children(0);
		while(null != objFocalPoint && ("none" == objFocalPoint.style.display || "hidden" == objFocalPoint.style.visibility))
		{
			objFocalPoint = objFocalPoint.nextSibling;
		}
	}
	attachFocusEvents(objFocalPoint);
	try
	{
		objFocalPoint.focus();
	}
	catch(e){}
}


function mf_getNodeData(objDest,objElement)
{
	var szRestriction = "";
	var szInnermostRestriction = "";
	m_icurGrpLevel = parseInt(objElement.groupLevel,10) + 1;
	var objQueryObject = m_objQueries[m_icurGrpLevel - 1];
	objQueryObject.restriction = "";
	objDest.groupLevel = m_icurGrpLevel;
	if(m_icurGrpLevel > 2)
	{
		var objParentGroup = objElement.parentGroup
		if (null == objParentGroup)
		{
			objParentGroup = objElement.parentElement.parentElement.parentElement.parentElement.parentGroup
			objElement.parentGroup = objParentGroup;
		}
		//get previous group criteria
		var objTemp = objElement;
		var icount = 0;
		while (null != objTemp)
		{
			szRestriction += (szRestriction.length > 0 ? " AND " : "") + mf_formatRestriction(objTemp.propValue, objTemp.dataType, objTemp.propName);
			if (0 == icount)
			{
				szInnermostRestriction = mf_formatRestriction(objTemp.propValue, objTemp.dataType, objTemp.propName, " >= ");
				if (m_icurGrpLevel == m_objQueries.length)
				{
					szRestriction = "";
				}
			}
			objTemp = objTemp.parentGroup;
			icount++;
		}
		objDest.parentGroup = objElement;
	}
	else
	{
		if (m_icurGrpLevel != m_objQueries.length)
		{
			szRestriction = mf_formatRestriction(objElement.propValue, objElement.dataType, objElement.propName);
		}
		szInnermostRestriction = mf_formatRestriction(objElement.propValue, objElement.dataType, objElement.propName, " >= ");
		objElement.parentGroup = null;
		objDest.parentGroup = objElement;
	}
	objQueryObject.restriction = objDest.restriction = szRestriction;
	if (m_icurGrpLevel == m_objQueries.length)
	{
		szRequestXML = objQueryObject.getXMLSearchRequest("find",objElement.parentElement.itemCount,szInnermostRestriction);
		objDest.innermostRestriction = szInnermostRestriction;
		objDest.itemCount = objElement.parentElement.itemCount;
	}
	else
	{
		szRequestXML = objQueryObject.getXMLSearchRequest();
	}
	m_objHTMLTarget = objDest;
	m_gCallBack = mf_renderHTML;
	m_szContextHandle = "";
	mf_getXML(m_szURL, szRequestXML);
}

function mf_formatRestriction(szPropValue, szDataType, szPropName, szRelOp)
{
	var szRestriction = "";
	szRelOp = (null == szRelOp || "" == szRelOp ? " = " : szRelOp);
	if (null != szPropValue || "boolean" == szDataType)
	{
		switch(szDataType)
		{
			case "string":
				var re = /'/g;
				szPropValue = szPropValue.replace(re, "''") //Escape single quotes
				szRestriction = '"' + szPropName + '"' + szRelOp + '\'' + szPropValue + '\'';
				break;
			case "boolean":
				szRestriction = '"' + szPropName + '"' + szRelOp + (szPropValue == "1");
				break;
			default:
				szRestriction = '"' + szPropName + '"' + szRelOp + 'CAST("' + szPropValue + '" AS "' + (("date" == szDataType) ? "dateTime.tz" : szDataType) + '")';
				break;
		}
	}
	else
	{
		szRestriction = '"' + szPropName + '" IS NULL ';
	}
	return (szRestriction);
}

function mf_unselectAll()
{
	var objRow;
	var objAnchorsSelected = this.all("selected");
	if (objAnchorsSelected)
	{
		if (objAnchorsSelected.length != null)
		{
			var e = new Enumerator( objAnchorsSelected );
			for (;!e.atEnd();e.moveNext())
			{
				mf_unselectRecord(e.item())
			}
		}
		else
		{
			mf_unselectRecord(objAnchorsSelected);
		}

	}
}

function mf_correctSelectedRowsCount(objTarget)
{
	var objSelectedItems = objTarget.all("selected");
	if (null == objSelectedItems)		 return 0;
	if (null == objSelectedItems.length) return 1;
	return objSelectedItems.length;
}

function createOrderNode(objViewDescriptor,objOrderByNode,szProp,szSortDir,szType)
{
	var objNewOrderNode = objViewDescriptor.createElement("order");
	var objNewPropNode  = objViewDescriptor.createElement("prop");
	var objNewSortNode  = objViewDescriptor.createElement("sort");
	var objNewTypeNode  = objViewDescriptor.createElement("type");
	objNewOrderNode = objOrderByNode.appendChild(objNewOrderNode);
	objNewPropNode = objNewOrderNode.appendChild(objNewPropNode);
	objNewSortNode = objNewOrderNode.appendChild(objNewSortNode);
	objNewTypeNode = objNewOrderNode.appendChild(objNewTypeNode);
	objNewPropNode.text = szProp;
	objNewSortNode.text = szSortDir;
	objNewTypeNode.text = szType;
}

function changeSortNode(objViewDescriptor,szProp,szSortDir,szType,bAppend)
{
	var objOrderByNode = objViewDescriptor.selectSingleNode("/view/orderby");
	if (null == objOrderByNode)
	{
		objOrderByNode = objViewDescriptor.createElement("orderby");
		objOrderByNode = objViewDescriptor.documentElement.appendChild(objOrderByNode);
	}
	var objOrderNodes = objOrderByNode.selectNodes("/view/orderby/order");
	if (!bAppend)
	{
		if (null != objOrderNodes)
		{
			for(var i = objOrderNodes.length -1; i >= 0; i--)
				objOrderByNode.removeChild(objOrderByNode.lastChild)
		}
		createOrderNode(objViewDescriptor,objOrderByNode,szProp,szSortDir,szType);
		return;
	}
	var objNode = objOrderByNode.selectSingleNode("order[prop = '" + szProp + "']");
	if (null == objNode)
	{
		createOrderNode(objViewDescriptor,objOrderByNode,szProp,szSortDir,szType);
		return;
	}
	var objSortNode = objNode.selectSingleNode("sort");
	if (null == objSortNode)
	{
		objSortNode = objViewDescriptor.createElement("sort");
		objNode.appendChild(objSortNode);
	}
	objSortNode.text = szSortDir;
}


function mf_changeSortOrder(objCol, bAppend)
{
	var szSortDir = ""
	var i;
	var szProp;
	var iEndRange;
	var objOrderByNode = null;
	var objViewDescriptor,objQueries;

	m_objHTMLTarget = objCol.parentElement.parentElement.parentElement.parentElement;
	m_objParentTR = (m_objHTMLTarget.isOutermostTarget ? null : m_objHTMLTarget.parentElement);
	m_iNumRowsSelected -= mf_correctSelectedRowsCount(m_objHTMLTarget);
	if(null != m_objParentTR)
	{
		m_objParentTR = m_objParentTR.previousSibling;
	}
	if(null == m_objHTMLTarget.cachedViewDescriptor)
	{
		m_objHTMLTarget.cachedViewDescriptor = m_objHTMLTarget.isOutermostTarget ? m_objViewDescription : m_objViewDescription.cloneNode(true);
	}
	objViewDescriptor = m_objHTMLTarget.cachedViewDescriptor;

	if(null != objCol.dataType && objCol.dataType.substr(0,4).toUpperCase() == "DATE")
	{
		//If the data type is date then Default is DESC
		szSortDir = (objCol.sortdir == "DESC")?"ASC":"DESC";
	}
	else
	{
		szSortDir = (objCol.sortdir == "ASC")?"DESC":"ASC";
	}
	mf_fireOnChangeSort(objCol,bAppend,szSortDir);
	changeSortNode(objViewDescriptor,objCol.prop,szSortDir,objCol.dataType,bAppend);
	// need to remove any indentation based on thread-index
	var objIndentColumnNode = objViewDescriptor.selectSingleNode("/view/column/indentcolumn[. = '1']");
	if (null != objIndentColumnNode)
	{
		objIndentColumnNode.text = "0";
	}
	var objViewXML = createViewXML(objViewDescriptor,m_objTransFormXSL);
	if(null == objViewXML)
	{
		return;
	}
	if(0 != objViewXML.parseError.errorCode)
	{
		mf_handleParseError(m_objViewXML.parseError);
		return;
	}
	//Check for parse errors in the result.
	m_objViewXML = objViewXML;
	m_objXSLNodes = objViewXML.selectNodes("view/group/xsl:template");
	m_objDefaultXSLNodes = m_objXSLNodes;
	m_objViewDescription = objViewDescriptor;
	objQueries = new QueryCollection(objViewDescriptor);
	m_objQueries = objQueries;
	var szRangeType = null;
	var szRangeRows = null;
	var szRangeContents = null;
	if(m_objHTMLTarget.isOutermostTarget)
	{
		if (null != m_objRowLastSelected)
		{
			szRangeType = "url";
			szRangeRows = m_iRowsPerPage.toString(10);
			szRangeContents = m_objRowLastSelected._href;
		}
		else
		{
			var iEndRange = m_iRowsPerPage - 1;
			szRangeType = "row";
			szRangeContents = "0-" + iEndRange.toString(10);
		}
	}
	else
	{
		szRangeType = "find";
		szRangeRows = m_objHTMLTarget.itemCount;
		szRangeContents = m_objHTMLTarget.innermostRestriction;
	}
	if(null != m_objRowLastSelected)
	{
		var objTable = m_objRowLastSelected.parentElement.parentElement;
		if(null != objTable && m_objHTMLTarget.firstChild == objTable)
		{
			m_objRowRange = null;
			m_objRowLastSelected = null;
		}
	}
	if(null != m_objHTMLTarget && null != m_objHTMLTarget.groupLevel)
	{
		m_icurGrpLevel = m_objHTMLTarget.groupLevel;
	}
	objQueries[m_icurGrpLevel - 1].restriction = m_objHTMLTarget.restriction;
	szSearchXML = objQueries[m_icurGrpLevel - 1].getXMLSearchRequest(szRangeType,szRangeRows,szRangeContents);
	m_szContextHandle = "";
	m_gCallBack = mf_fireOnSoftRefresh;
	mf_rememberSelections();
	mf_getXML(m_szURL, szSearchXML);
}

function mf_unselectRecord(objRecord, bFireEvent)
{
	if(objRecord && "unSelected" != objRecord.id)
	{
		objRecord.id =  "unSelected";
		mf_changeRowStyle (objRecord,"");
		m_iNumRowsSelected -= (!("true" == objRecord.isGroupHeader)) ? 1 : 0;
		if(bFireEvent)
		{
			mf_fireOnSelectionChange(objRecord,false);
		}
		return true;
	}
	return false;
}

function mf_selectRecord(objRecord, fFireEvent)
{
	if (objRecord && "selected" != objRecord.id)
	{
		objRecord.id = "selected";
		m_objRowLastSelected = objRecord;
		mf_changeRowStyle (objRecord,m_szHighlightRowStyle);
		m_iNumRowsSelected += (!("true" == objRecord.isGroupHeader)) ? 1 : 0;
		if(fFireEvent)
		{
			mf_fireOnSelectionChange(objRecord,true);
		}
		return true;
	}
	return false;
}

function mf_changeSelectedRowsStyle(szStyleText)
{
	var objSelectedRows = this.all("selected");
	if (null == objSelectedRows)
	{
		return;
	}
	if (null == objSelectedRows.length)
		mf_changeRowStyle(objSelectedRows,szStyleText);
	else
		for (var i = 0;i < objSelectedRows.length; i++)
			mf_changeRowStyle(objSelectedRows(i),szStyleText);
}

function mf_changeRowStyle(objRecord, newStyle)
{
	if(!("true" == objRecord.isGroupHeader))
	{
		if (m_bIsCardView)
		{
			objRecord.all("crdHeader1").runtimeStyle.cssText = newStyle;
			objRecord.all("crdHeader2").runtimeStyle.cssText = newStyle;
		}
		else
			objRecord.runtimeStyle.cssText = newStyle;
	}
	else
		objRecord.firstChild.runtimeStyle.cssText = newStyle;
}

function mf_loadXSL()
{
	if (null == this.viewClass)
	{
		this.viewClass = "/exchweb/controls/ctrl_View20.xsl";
	}
	if (mf_loadXSL.oldViewClass != this.viewClass)
	{
		m_objXSLRequest = new ActiveXObject(m_szXMLHTTPProgID);
		m_objXSLRequest.open("GET", this.viewClass, true);
		if(null != this.acceptLang && "" != this.acceptLang)
		{
			m_objXSLRequest.setRequestHeader("Accept-Language",this.acceptLang);
		}
		m_objXSLRequest.onreadystatechange = mf_onGetViewClass;
		mf_onGetViewClass.lockRequest = false;
		m_objXSLRequest.send();
	}
	else
	{
		mf_initializeQueries.viewClassReadyState = true;
		mf_initializeQueries();
	}
}

mf_loadXSL.oldViewClass = "";		// save old view class

function mf_onGetViewClass()
{
	if(null != m_objXSLRequest && 4 == m_objXSLRequest.readyState && !mf_onGetViewClass.lockRequest)
	{
		mf_onGetViewClass.lockRequest = true;
		if (m_objXSLRequest.status > 199 && m_objXSLRequest.status < 300)
		{
			m_objTransFormXSL = m_objXSLRequest.responseXML;
			mf_loadXSL.oldViewClass = this.viewClass;
			//Set state and call function
			mf_initializeQueries.viewClassReadyState = true;
			mf_initializeQueries();
		}
		else
		{
			try
			{
				mf_fireOnError(m_objXSLRequest.status,m_objXSLRequest.statusText,m_objXSLRequest.responseXML,"GET " + this.viewClass);
			}
			catch(e)
			{
				mf_fireOnError(900,"View Class Not Available",null,"GET " + this.viewClass);
			}
		}
		m_objXSLRequest = null;
	}
}

mf_onGetViewClass.lockRequest  = false;


function mf_setViewDescriptorNode(objViewNode,szNodeName,szNodeValue,fIsDefault)
{
	var objNode=objViewNode.selectSingleNode(szNodeName),fExistedAlready=true;
	if(null == objNode)
	{
		objNode = m_objViewDescription.createNode("1",szNodeName,"");
		objViewNode.appendChild(objNode);
		fExistedAlready = false;
	}
	objNode.text = (fIsDefault && fExistedAlready) ? objNode.text : szNodeValue;
}
function mf_alterViewDescriptor()
{
	var objViewNode = m_objViewDescription.selectSingleNode("view");
	if (null != objViewNode)
	{
		mf_setViewDescriptorNode(objViewNode,"imagepath", m_szImagePath, true);
		mf_setViewDescriptorNode(objViewNode,"boldUnreadItems",m_szBoldUnreadItems);
		// Check for conversation topic view.  If it exists, add a node to the first text column to indent it
		var objOrderByNode = m_objViewDescription.selectSingleNode("view/orderby/order[prop = 'urn:schemas:mailheader:thread-index' || prop = 'http://schemas.microsoft.com/mapi/proptag/x00710102']");
		if(null != objOrderByNode)
		{
			// find the first string property, add a node to that column
			var objColumnNode = m_objViewDescription.selectSingleNode("view/column[(not(bitmap) or bitmap = '0') and not(type = 'boolean' and format = 'boolicon')]");
			if(null != objColumnNode)
			{
				var objNode = objColumnNode.selectSingleNode("indentcolumn");
				if (null == objNode)
				{
					objNode = m_objViewDescription.createNode("1","indentcolumn","");
					objColumnNode.appendChild(objNode);
				}
				objNode.text = "1";
				m_szDefaultContentProps += ', "urn:schemas:mailheader:thread-index" as threadindex';
			}
		}
	}
	//Swap message class prop for the icon property
	var objCollMsgClass  = m_objViewDescription.selectNodes("view/column[bitmap = '1']/prop[.='http://schemas.microsoft.com/exchange/outlookmessageclass']");
	if (null != objCollMsgClass)
	{
		for(var x = 0; x < objCollMsgClass.length; x++)
		{
			objCollMsgClass.item(x).text = "http://schemas.microsoft.com/exchange/smallicon";
		}
	}
}

function mf_loadViewDescriptorFromURL(szXMLURL)
{

	m_objHTTPViewDescriptor = new ActiveXObject(m_szXMLHTTPProgID);
	m_objHTTPViewDescriptor.open("GET", szXMLURL,true);
	if(null != this.acceptLang && "" != this.acceptLang)
	{
		m_objHTTPViewDescriptor.setRequestHeader("Accept-Language",this.acceptLang);
	}
	m_objHTTPViewDescriptor.onreadystatechange = mf_onGetViewDescriptor;
	mf_onGetViewDescriptor.lockRequest = false;
	m_objHTTPViewDescriptor.send();
}

function mf_onGetViewDescriptor()
{
	var iStatus,objResponseXML;
	if(null != m_objHTTPViewDescriptor && m_objHTTPViewDescriptor.readyState == 4 && !mf_onGetViewDescriptor.lockRequest)
	{
		mf_onGetViewDescriptor.lockRequest = true;
		iStatus = m_objHTTPViewDescriptor.status;
		if(200 == iStatus)
		{
			m_objViewDescription = m_objHTTPViewDescriptor.responseXML;
		}
		if(null == m_objViewDescription || null == m_objViewDescription.parseError)
		{
			alert(this.viewDescriptorURL + ":  " + m_objHTTPViewDescriptor.status + " " +  m_objHTTPViewDescriptor.statusText);
		}
		else if(0 == m_objViewDescription.parseError.errorCode)
		{
			mf_initializeQueries.viewDescriptorReadyState = true;
			mf_initializeQueries();
		}
		else
		{
			mf_handleParseError(m_objViewDescription.parseError);
		}
		m_objHTTPViewDescriptor = null;
	}
}
mf_onGetViewDescriptor.lockRequest = false;

function mf_loadViewDescriptor()
{
	if(this.viewDescriptorURL)
	{
		mf_loadViewDescriptorFromURL(this.viewDescriptorURL);
	}
	else if(this.viewDescriptor)
	{
		//check to see if the string is an id to an xml data island
		var objXML = window.document.all(this.viewDescriptor);
		var objKnownXMLDOM = new ActiveXObject(m_szXMLDOMProgID);
		if(null == objXML && null != m_objViewDescription)
		{
			mf_initializeQueries.viewDescriptorReadyState = true;
			mf_initializeQueries();
		}
		else if(null != objXML && "XML" == objXML.tagName.toUpperCase())
		{
			if(null != objXML.documentElement)
			{
				objKnownXMLDOM.loadXML(objXML.xml);
				m_objViewDescription = objKnownXMLDOM;
			}
			else
			{
				objKnownXMLDOM.loadXML(objXML.innerHTML)
				m_objViewDescription = objKnownXMLDOM;
			}
			if(0 == m_objViewDescription.parseError.errorCode)
			{
				mf_initializeQueries.viewDescriptorReadyState = true;
				mf_initializeQueries();
			}
			else
			{
				mf_handleParseError(m_objViewDescription.parseError);
			}
		}
	}
}

function mf_unboldRow(objRow)
{
	if (null != objRow)
	{
		objRow.style.fontWeight = "normal";
	}
}

function mf_fireOnSoftRefresh()
{
	mf_renderHTML();
	mf_fireOnRefresh();
	if ("" != m_szContextHandle)
	{
		var navAction = (mf_restoreSelections(m_iSeekDir) == 2)? ACTION_SEEK : ACTION_CLOSE;
		mf_fireOnNavigate(m_objRowLastSelected, navAction);
	}
	else
	{
		mf_restoreSelections();
	}
}

function mf_multiStatusError(szContentRange,objContentRangeXML,iStatus,szStatusText)
{
	if ("" != m_szContextHandle)
		mf_fireOnNavigate(m_objRowLastSelected,ACTION_CLOSE);
}

function mf_handleParseError(objParseError)
{
	var szParseError  = " Error code: " +  objParseError.errorCode + "\n";
		szParseError += " Line: " +  objParseError.line + "\n";
		szParseError += " Line Position: " +  objParseError.linepos + "\n";
		szParseError += " Reason: " +  objParseError.reason + "\n";
		szParseError += " Source: " +  objParseError.srcText + "\n";
		//Clear out the client area
		this.innerHTML = "";
		//Display parse error info
		this.innerText = szParseError;
}
function mf_updatePageInfo(szRangeHeader,objContentRangeXML)
{
	if (!m_objHTMLTarget.isOutermostTarget) return;
	if (null != szRangeHeader && "" != szRangeHeader)
	{
		mf_updatePageInfo.reTotal.lastIndex=0;
		var arr = mf_updatePageInfo.reTotal.exec(szRangeHeader);
		if (null != arr)
		{
			m_iMaxRows = parseInt(arr[1],10);
		}
		mf_updatePageInfo.reRows.lastIndex=0;
		arr = mf_updatePageInfo.reRows.exec(szRangeHeader);
		if (null == arr)
		{
			mf_updatePageInfo.reRows.lastIndex=0;
			if (null != objContentRangeXML)
			{
				var szRange = objContentRangeXML.text;
				arr = mf_updatePageInfo.reRows.exec(szRange);
			}
			else
			{
				m_iCurrentPage = 0;
				this.pageCount = 0;
				this.itemCount = 0;
				return;
			}
		}
		m_iStartRange = parseInt(arr[1],10);
		m_iEndRange = parseInt(arr[2],10);
		m_iCurrentPage = Math.ceil((m_iStartRange + m_iRowsPerPage)/m_iRowsPerPage);
		this.pageCount = Math.ceil(m_iMaxRows/m_iRowsPerPage);
		this.itemCount = m_iMaxRows;
	}
	else
	{
		m_iCurrentPage = 0;
		this.pageCount = 0;
		this.itemCount = 0;
	}
}
mf_updatePageInfo.reRows = /[^\d]*(\d+)-(\d+)/i
mf_updatePageInfo.reTotal = /total=(\d+)/gi

function requestObject()
{
	this.XMLHTTPRequest = new ActiveXObject(m_szXMLHTTPProgID);
	this.target = m_objHTMLTarget;
	this.level  = m_icurGrpLevel;
	this.parentTR = m_objParentTR;
	this.XSLNodes = m_objXSLNodes;
	this.callback = m_gCallBack;
	this.contextHandle = m_szContextHandle;
	this.groupIMG = m_objGroupIMG;
	this.lockRequest = false;
	this.onErrorGotoLastPage = m_iOnErrorGotoPage;
	return this;
}

function restoreContext(queueEntry)
{
	queueEntry.lockRequest = true;
	m_objHTMLTarget	= queueEntry.target;
	m_icurGrpLevel	= queueEntry.level;
	m_objParentTR	= queueEntry.parentTR;
	m_objXSLNodes	= queueEntry.XSLNodes;
	m_gCallBack		= queueEntry.callback;
	m_szContextHandle = queueEntry.contextHandle;
	m_objGroupIMG	= queueEntry.groupIMG;
	m_objXML		= queueEntry.XMLHTTPRequest.responseXML;
	m_iOnErrorGotoPage = queueEntry.onErrorGotoLastPage;
}

function mf_getXML(szURL, szXMLSearch)
{
	m_objXMLRequestQueue[m_iXMLQueueLength] = new requestObject();
	m_objMSHTTP_Request = m_objXMLRequestQueue[m_iXMLQueueLength].XMLHTTPRequest;
	m_iXMLQueueLength += 1;
	m_objMSHTTP_Request.open("SEARCH", szURL, true);
	m_objMSHTTP_Request.setRequestHeader("Translate", "f");
	m_objMSHTTP_Request.setRequestHeader("Brief", "t");
	m_objMSHTTP_Request.setRequestHeader("content-type", "text/xml");
	if(null != this.acceptLang && "" != this.acceptLang)
	{
		m_objMSHTTP_Request.setRequestHeader("Accept-Language",this.acceptLang);
	}
	m_objMSHTTP_Request.onreadystatechange = new Function("ongetxmlcomplete(" + (m_iXMLQueueLength-1) + ")");
	m_objMSHTTP_Request.send(szXMLSearch);
}

function modifyCardViewHTML(szHTML)
{
	var i,j;
	var iRecsPerCol = Math.round(m_iRowsPerPage/m_iCardViewColumns);
	var iColumnWidth = Math.round(100 / m_iCardViewColumns);
	var szCellHTML = "";
	for(i = 0; i < m_iCardViewColumns; i++)
	{
		szCellHTML += '<TD id="col'+ i + '" style="vertical-align:top;width:'+ iColumnWidth + '%"></TD>';
	}
	m_objHTMLTarget.innerHTML = '<TABLE cols=' + m_iCardViewColumns +' border="1" style="border-collapse:collapse;table-layout:fixed;display:none;" width="100%"><TBODY><TR>' + szCellHTML + '</TR></TBODY></TABLE>';
	var objTable = this.children(0);
	var objCol = objTable.rows(0).cells(0);
	objCol.innerHTML = szHTML;

	var objItem = true;
	var objAllItems = objCol.children;
	for(i = 1; i < m_iCardViewColumns && objItem != null; i++)
	{
		objNewCol = objTable.rows(0).cells(i);
		for(j = 0; j <= iRecsPerCol; j++)
		{
			objItem = objAllItems(iRecsPerCol);
			if(objItem == null) break;
			objNewCol.insertAdjacentElement("beforeEnd", objItem);
		}
	}
	objTable.style.display = "";
}

function addTableExpandos(objTable)
{
	if(null == objTable) return;
	var objTBODY  = objTable.firstChild;
	if (null != objTBODY && "" == objTBODY.innerHTML)
	{
		// we have no data to work with
		m_objHTMLTarget.innerHTML = m_objXML.transformNode(m_objXSLNodes.item(m_objXSLNodes.length - 1));
		return;
	}
	var iFirstRow = ("true" == objTable.isTabularView) ? 1 : 0;
	var iLastRow  = objTBODY.children.length - (("true" == objTable.isTabularView) ? 1 : 2);
	var objFirstRow = objTBODY.children(iFirstRow);
	var objLastRow  = (iLastRow < 0) ? null : objTBODY.children(iLastRow);
	if(null != objFirstRow)
	{
		objFirstRow.parentTR = m_objParentTR;
		objFirstRow.isFirstRow = true;
	}
	if(null != objLastRow)
	{
		objLastRow.parentTR  = m_objParentTR;
		objLastRow.isLastRow = true;
	}
	if(null != m_objParentTR)
	{
		m_objParentTR.firstRow = objFirstRow;
		m_objParentTR.lastRow  = objLastRow;
		m_objParentTR = null;
	}
}
function mf_renderHTML()
{
	if(null != m_objXML)
	{
		//XML will strip leading and trailing whitepace if this property is not set to true
		m_objXML.preserveWhiteSpace = true;
		if(null != m_objGroupIMG)
		{
			m_objGroupIMG.src = m_szImagePath + "view-minus.gif";
			m_objGroupIMG = null;
		}
		var szHTML = m_objXML.transformNode(m_objXSLNodes.item(m_icurGrpLevel - 1));
		if (m_bIsCardView)
		{
			modifyCardViewHTML(szHTML);
		}
		else
		{
			m_objHTMLTarget.innerHTML = szHTML;
			addTableExpandos(m_objHTMLTarget.firstChild);
		}
		if(m_objHTMLTarget.contains(m_objRowLastSelected))
		{
			m_objRowLastSelected = null;
		}
		if(m_objHTMLTarget.isOutermostTarget)
		{
			m_iNumRowsSelected = 0;
		}
		m_objXSLNodes = m_objDefaultXSLNodes;
	}
	if (mf_renderHTML.bFirstRefresh)
	{
		element.focus();
		mf_renderHTML.bFirstRefresh = false;
	}
}
mf_renderHTML.bFirstRefresh = true;

//return values of this function:
// 0 = no items specified in m_rgSelectedItems[2] were found
// 1 = at least 1 items specified in m_rgSelectedItems[2] was found
// 2 = if iOffsetDir is specified and not 0, then 2 is returned if the desired object was found and selected.
function mf_restoreSelections(iOffsetDir)
{
	var szPreviousRowURL = m_rgSelectedItems[0];
	var szNextRowURL	 = m_rgSelectedItems[1];
	var rgSelectedURLs	 = m_rgSelectedItems[2];
	m_rgSelectedItems[0] = null;  // previous unselected item
	m_rgSelectedItems[1] = null;  // next unselected item
	m_rgSelectedItems[2] = null;  // selected urls
	var objUnselectedItems = (null == iOffsetDir) ? m_objHTMLTarget.all("unSelected") : element.all("unSelected");
	var objRow = null, objPreviousRow = null, objNextRow = null;
	var bFoundRows = false;
	var objLastSelected = null;
	var iRowToSelect = mf_restoreSelections.matchingRow;
	mf_restoreSelections.matchingRow = null;

	if (null == iOffsetDir && null !=iRowToSelect)
	{
		mf_selectRowByNumber(iRowToSelect,m_objHTMLTarget);
		return 0;
	}
	if (null == objUnselectedItems || null == rgSelectedURLs)
	{
		if (m_objHTMLTarget.isOutermostTarget && null == this.all("selected"))
		{
			mf_selectFirstRow(m_objHTMLTarget);
		}
		return 0;
	}
	var iLength = objUnselectedItems.length;
	if(null != iLength)
	{
		for(var i = iLength -1; i >= 0; i--)
		{
			objRow = objUnselectedItems(i);
			if(rgSelectedURLs[objRow._href])
			{
				mf_selectRecord(objRow,true);
				objLastSelected = objRow;
				bFoundRows = true;
			}
			else if(!bFoundRows && null == objPreviousRow && szPreviousRowURL == objRow._href)
			{
				objPreviousRow = objRow;
			}
			else if(!bFoundRows && null == objNextRow && szNextRowURL == objRow._href)
			{
				objNextRow = objRow;
			}
		}
	}
	else if(rgSelectedURLs[objUnselectedItems._href])
	{
		objLastSelected = objUnselectedItems;
		mf_selectRecord(objUnselectedItems,true);
		bFoundRows = true;
	}
	if(bFoundRows)
	{
		if (null != iOffsetDir && 0 != iOffsetDir)
		{
			var nextDir = (iOffsetDir>0)?DOWN:UP;
			var objNextRow = mf_getNextRow(objLastSelected,nextDir);
			while (false != objNextRow && objNextRow.isGroupHeader)
			{
				objNextRow = mf_getNextRow(objNextRow, nextDir);
			}
			if (false != objNextRow)
			{
				mf_unselectRecord(objLastSelected,false);
				mf_selectRecord(objNextRow,true);
				objLastSelected = objNextRow;
				objNextRow.scrollIntoView(false);
				return 2;
			}
		}
		return 1;
	}
	else if (null != iOffsetDir)
	{
		return 0;
	}
	if(null != objNextRow)
	{
		mf_selectRecord(objNextRow,true);
	}
	else if(null != objPreviousRow)
	{
		mf_selectRecord(objPreviousRow,true);
	}
	else mf_selectFirstRow(m_objHTMLTarget);
	return 0;
}
mf_restoreSelections.matchingRow = null;   // integer telling which row was matched previously

function mf_rememberSelections()
{
	var objSelectedItems = m_objHTMLTarget.all("selected");
	var rgSelectedURLs = new Array();
	var objFirstRow	= null;
	var objLastRow	= null;
	var objPreviousRow =  null;
	var objNextRow = null;
	var bFoundRows = false;
	var j=0,objRow;

	if (null == objSelectedItems)	return;
	if (null != objSelectedItems.length)
	{
		for (j=0;j<objSelectedItems.length;j++)
		{
			objRow = objSelectedItems(j);
			if(!("true" == objRow.isGroupHeader))
			{
				if(null == objFirstRow)
				{
					objFirstRow = objRow;
				}
				objLastRow = objRow;
				rgSelectedURLs[objRow._href] = true;
				bFoundRows = true;
			}
		}
	}
	else if (!("true" == objSelectedItems.isGroupHeader))
	{
		rgSelectedURLs[objSelectedItems._href] = true;
		objLastRow = objSelectedItems;
		objFirstRow = objSelectedItems;
		bFoundRows = true;
	}
	if (!bFoundRows)	return; // only group headers selected
	objPreviousRow		= mf_getNextRow(objFirstRow,UP);
	objNextRow			= mf_getNextRow(objLastRow,DOWN);
	m_rgSelectedItems[0] = (false == objPreviousRow || "true" == objPreviousRow.isGroupHeader) ? null : objPreviousRow._href;
	m_rgSelectedItems[1] = (false == objNextRow || "true" == objNextRow.isGroupHeader) ? null : objNextRow._href;
	m_rgSelectedItems[2] = rgSelectedURLs;

}

//***********   Private Row Range Method function  ********
//  Note:These function can only be use through the row range object

function mf_updateRowRange()
{
	var objNextRow;
	var iTempDir = 0;
	var iDelta = this.startRow.sourceIndex - this.endRow.sourceIndex;
	if(iDelta < 0)
	{
		iTempDir = DOWN;
	}
	else if(iDelta > 0)
	{
		iTempDir = UP;
	}
	else if(0 == iDelta)
	{
		mf_unselectAll();
		mf_selectRecord(this.startRow,true);
		this.tempEndRow = this.endRow
		this.rangeDirection = null;
		return(true)
	}
	if (this.rangeDirection == null)
	{
		this.rangeDirection = iTempDir
	}
	if(iTempDir == this.rangeDirection)
	{
		 //Either add or remove rows based on the endRow
		var iEndDelta = this.tempEndRow.sourceIndex - this.endRow.sourceIndex;
		if(iEndDelta > 0 )
		{
			if(this.rangeDirection == DOWN)
			{
				//remove rows
				this.trimRange(UP)
			}
			else
			{
				//add rows
				this.expandRange(this.tempEndRow);
			}
		}
		if(iEndDelta < 0)
		{
			if(this.rangeDirection == UP)
			{
				//remove rows
				this.trimRange(DOWN)
			}
			else
			{
				//add rows
				this.expandRange(this.tempEndRow);
			}
		}
	}
	else
	{
		//Unselect all rows except the start row
		this.rangeDirection = iTempDir
		var objSelector = this.startRow
		objSelector.id = "rowSelectedException"
		mf_unselectAll();
		objSelector.id = "selected"
		//add rows in range
		this.expandRange(this.startRow);
	}
}
function mf_expandRange(objStartRow)
{
	var objTempRow = mf_getNextRow(objStartRow, this.rangeDirection)
	while (objTempRow && objTempRow.uniqueID != this.endRow.uniqueID)
	{
		mf_selectRecord(objTempRow,false);
		objTempRow = mf_getNextRow(objTempRow, this.rangeDirection)
	}
	mf_selectRecord(this.endRow, true);
	this.tempEndRow = this.endRow;
}

function mf_trimRowRange(iDirection)
{
	//remove rows
	mf_unselectRecord(this.tempEndRow,false)
	var objTempRow;
	objTempRow = mf_getNextRow(this.tempEndRow, iDirection)
	if(objTempRow)
	{
		for(;objTempRow.uniqueID != this.endRow.uniqueID &&
			mf_unselectRecord(objTempRow);)
		{
			objTempRow = mf_getNextRow(objTempRow,iDirection)
		}
		this.tempEndRow = this.endRow;
	}
}

function mf_getNextRow(objRow,iDirection)
{
	var objTemp,objPrev;
	var retval = false;

	if (null == objRow)
	{
		return false;
	}
	if (iDirection == UP)
	{
		if (objRow.isFirstRow)
		{
			retval = objRow.parentTR;
		}
		else if ("true" == objRow.isGroupHeader)
		{
			objPrev = objRow.previousSibling;
			if (null != objPrev)
			{
				objTemp = objPrev.previousSibling;
				while (null != objTemp && objTemp.isExpanded)
				{
					objTemp = objTemp.lastRow;
				}
				retval = objTemp;
			}
		}
		else
		{
			retval = objRow.previousSibling;
		}
		if (null == retval && m_bIsCardView)
		{
			var objCol = objRow.parentElement.previousSibling;
			retval = (null == objCol) ? null : objCol.children[objCol.children.length - 1];
		}
	}
	else
	{
		if ("true" == objRow.isGroupHeader && (!objRow.isLastRow || objRow.isExpanded))
		{
			retval = (objRow.isExpanded ? objRow.firstRow : objRow.nextSibling.nextSibling);
		}
		else if (!objRow.isLastRow)
		{
			retval = objRow.nextSibling;
		}
		else
		{
			objTemp = objRow.parentTR;
			while(null != objTemp && objTemp.isLastRow)
			{
				objTemp	= objTemp.parentTR;
			}
			if(null != objTemp)
			{
				retval = objTemp.nextSibling.nextSibling;
			}
		}
		if (null == retval && m_bIsCardView)
		{
			var objCol = objRow.parentElement.nextSibling;
			retval = (null == objCol) ? null : objCol.children[0];
		}
	}
	return ((null == retval) ? false : retval);
}

function mf_fireOnNavigate(objRow,iType)
{
	var objEvent		= createEventObject();
	objEvent.type		= "OnNavigate";
	objEvent.action		= iType;
	if (ACTION_SEEK == iType || ACTION_CLOSE == iType)
		objEvent.contextHandle = m_szContextHandle;
	if (ACTION_CLOSE != iType)
		objEvent.url		= objRow._href;
	objEvent.srcElement	= this;
	_ideventonNavigate.fire(objEvent);
	return !(objEvent.returnValue == false);
}
function mf_fireOnError(statusCode, statusText, responseXML, szCommand)
{
	var objEvent		= createEventObject();
	objEvent.type		= "Error";
	objEvent.statusCode	= statusCode;
	objEvent.statusText	= statusText;
	objEvent.responseXML= responseXML;
	objEvent.command	= szCommand;
	_ideventonError.fire(objEvent);
}
function mf_fireOnReady()
{
	if(m_bFireOnReady)
	{
		m_bFireOnReady		= false;
		m_bDocumentReady	= true;
		var objEvent		= createEventObject();
		objEvent.type		= "Ready";
		objEvent.srcElement	= this;
		_ideventonReady.fire(objEvent);
	}
}
function mf_fireOnRefresh()
{
	var objEvent		= createEventObject();
	objEvent.type		= "Refresh";
	objEvent.srcElement	= this;
	_ideventonRefresh.fire(objEvent);
}
function mf_fireOnChangeSort(objCol, fAppend, szSortDir)
{
	var objEvent		= createEventObject();
	objEvent.type		= "ChangeSort";
	objEvent.srcElement	= this;
	objEvent.column		= objCol;
	objEvent.append		= fAppend;
	objEvent.sortDir	= szSortDir;
	_ideventonChangeSort.fire(objEvent);
}
function mf_fireOnSelectionChange(objRow, bIsSelected)
{
	if(null == objRow) return;
	var objEvent		 = createEventObject();
	objEvent.type		 = "SelectionChange";
	objEvent.rowType	 = ("true" == objRow.isGroupHeader ? "group" : "item");
	objEvent.srcElement	 = this;
	objEvent.item		 = objRow;
	objEvent.selectedURL = (null == objRow) ? null : objRow._href;
	objEvent.isSelected	 = bIsSelected;
	objEvent.numSelected = m_iNumRowsSelected;
	_ideventonSelectionChange.fire(objEvent);

}

function mf_toggleSelectedGroups(f_expand)
{
	var objGroupHeaders = this.all("selected");
	var obj;
	if (objGroupHeaders.length)
	{
		var e = new Enumerator( objGroupHeaders );
		for (;!e.atEnd();e.moveNext())
		{
			obj = e.item();
			if("true" == obj.isGroupHeader && obj.isExpanded != f_expand)
			{
				expandGroup(obj.firstChild);
			}
		}
	}
	else if(null != objGroupHeaders && "true" == objGroupHeaders.isGroupHeader && objGroupHeaders.isExpanded != f_expand)
	{
		expandGroup(objGroupHeaders.firstChild);
	}
}

/***************   End Private Row Range Function ****************************/
/*************************END PRIVATE FUNCTIONS********************************/
