<!--Copyright (c) 2000-2001 Microsoft Corporation.  All rights reserved. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl" default-space="strip">
<xsl:template match="@*"><xsl:attribute><xsl:value-of select="."/></xsl:attribute></xsl:template> 
<xsl:template match="@style"></xsl:template>
<xsl:template match="style">
	<xsl:value-of select="." />
</xsl:template>
<xsl:template match="/">
<xsl:element name="view">
	<xsl:choose>
		<xsl:when test="/view/card">
			<xsl:element name="group">
				<xsl:element name="xsl:template"><xsl:attribute name="xmlns:xsl">uri:xsl</xsl:attribute><xsl:attribute name="xmlns:a">DAV:</xsl:attribute>
					<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:multistatus/a:response</xsl:attribute>
						<a id="unSelected"  onmousedown="event.returnValue=this" ondblclick="event.returnValue=this" onmouseup="event.returnValue=this" onclick="return(false);" tabindex="-1"> 
							<xsl:element name="xsl:attribute"><xsl:attribute name="name">href</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:href</xsl:attribute></xsl:element></xsl:element>
							<xsl:element name="xsl:attribute"><xsl:attribute name="name">_href</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:href</xsl:attribute></xsl:element></xsl:element>
							<xsl:element name="xsl:attribute"><xsl:attribute name="name">contentClass</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/messageclass</xsl:attribute></xsl:element></xsl:element>
							<xsl:element name="xsl:for-each">
								<xsl:attribute name="select">a:propstat/a:prop</xsl:attribute>
								<table cols="2" width="100%" style="font-size:x-small;">
									<tr>
										<td>
											<table width="100%" style="table-layout:fixed" cellpadding="0" cellspacing="0"><tr>
												<td id="crdHeader1" NOWRAP="true" header="true" style="height:1.5em;font-weight:bold;cursor:hand;background-color:threedface;color:menutext;width:99%"><xsl:element name="xsl:value-of"><xsl:attribute name="select">prop1</xsl:attribute></xsl:element>&#160;</td>
												<td id="crdHeader2" align="center" header="true" style="height:1.5em;font-weight:bold;cursor:hand;background-color:threedface;color:menutext;width:18px">
													<xsl:element name="xsl:if">
														<xsl:attribute name="test">messageclass[. = 'IPM.DistList']</xsl:attribute>
														<IMG id="imgTD"><xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-cdl.gif</xsl:attribute></IMG>
													</xsl:element>
												</td>
											</tr></table>
										</td>
									</tr>
								</table>
								<table cols="2" width="100%" style="font-size:x-small;">
									<xsl:for-each select="view/column[index() $gt$ 0 and prop != 'http://schemas.microsoft.com/exchange/smallicon']">
										<xsl:element name="xsl:for-each">
											<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.!= '']</xsl:attribute>
											<xsl:if test="visible[. = '1']" >
												<tr>
													<td valign="top" style="padding-right:5px" NOWRAP="true"><xsl:value-of select="heading"/></td>
													<td width="100%"><xsl:element name="xsl:value-of"></xsl:element></td>
												</tr>
											</xsl:if>
										</xsl:element>
									</xsl:for-each>
								</table>
							</xsl:element>
						</a>
					</xsl:element>
				</xsl:element>
			</xsl:element>
		</xsl:when>
		<xsl:otherwise>
			<xsl:eval>var propNum=0;</xsl:eval>
			<xsl:for-each select="view/groupby/order">
			<xsl:eval>propNum++</xsl:eval>
			<xsl:element name="group">
				<xsl:element name="xsl:template"><xsl:attribute name="xmlns:xsl">uri:xsl</xsl:attribute>
				<xsl:attribute name="xmlns:a">DAV:</xsl:attribute>
				<xsl:attribute name="xmlns:b">urn:schemas:httpmail:</xsl:attribute>
				<xsl:attribute name="xmlns:c">urn:schemas:mailheader:</xsl:attribute>
				<TABLE tabindex="-1">
					<xsl:apply-templates select="/view/viewstyle/@*"/>
					<xsl:attribute name="style"><xsl:value-of select="/view/viewstyle"/></xsl:attribute>
					<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:multistatus/a:response</xsl:attribute>
					<TR id="groupHeaderRow" isGroupHeader="true" onmousedown="if(null == event.returnValue) event.returnValue=this;" style="cursor:default" ondragstart="event.cancelBubble=true;return(false);">
						<xsl:element name="xsl:attribute"><xsl:attribute name="name">itemCount</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/a:visiblecount</xsl:attribute></xsl:element></xsl:element>
						<TD nowrap="true" id="groupHeaderText" ondblclick="if(null == event.returnValue) event.returnValue=this;" ondragstart="event.cancelBubble=true;return(false);">
							<xsl:apply-templates select="style/@*"/>
							<xsl:attribute name="propName"><xsl:value-of select="prop" /></xsl:attribute>
							<xsl:attribute name="dataType"><xsl:value-of select="type" /></xsl:attribute>
							<xsl:attribute name="style"><xsl:value-of select="style" /></xsl:attribute>
							<xsl:attribute name="groupLevel"><xsl:eval>propNum</xsl:eval></xsl:attribute>
							<xsl:element name="xsl:for-each">
								<xsl:attribute name="select">a:propstat/a:prop/prop1</xsl:attribute>
								<xsl:element name="xsl:attribute"><xsl:attribute name="name">propValue</xsl:attribute><xsl:element name="xsl:eval">this.text</xsl:element></xsl:element>
							</xsl:element>
							<IMG onmousedown="if(null == event.returnValue) event.returnValue=this" id="groupHeaderActivator" style="cursor:hand;vertical-align:middle" ondragstart="event.cancelBubble=true;return(false);">
								<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-plus.gif</xsl:attribute> 
							</IMG>
							&#32;
							<SPAN id="groupHeaderSpan" ondragstart="event.cancelBubble=true;return(false);">
								<xsl:choose>
									<xsl:when test="/view/boldUnreadItems[. = 'true']">
										<xsl:element name="xsl:choose">
											<xsl:element name="xsl:when">
												<xsl:attribute name="test">a:propstat/a:prop/b:unreadcount[. $igt$ '0']</xsl:attribute>
												<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute>cursor:default;vertical-align:middle;overflow:hidden;font-weight:bold</xsl:element>
											</xsl:element>
											<xsl:element name="xsl:otherwise">
												<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute>cursor:default;vertical-align:middle;overflow:hidden</xsl:element>
											</xsl:element>
										</xsl:element>
									</xsl:when>
									<xsl:otherwise><xsl:attribute name="style">cursor:default;vertical-align:middle;overflow:hidden</xsl:attribute></xsl:otherwise>
								</xsl:choose>
								<xsl:value-of select="heading" />:&#32;<xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/prop1</xsl:attribute></xsl:element>&#32;
								<xsl:choose>
									<xsl:when test=".[countlabel and unreadlabel]">
										(<xsl:value-of select="countlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/a:visiblecount</xsl:attribute></xsl:element>
										<xsl:element name="xsl:if">
											<xsl:attribute name="test">a:propstat/a:prop/b:unreadcount[. $igt$ '0']</xsl:attribute>
											,&#32;<xsl:value-of select="unreadlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/b:unreadcount</xsl:attribute></xsl:element>
										</xsl:element>)
									</xsl:when>
									<xsl:when test="countlabel">
										(<xsl:value-of select="countlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/a:visiblecount</xsl:attribute></xsl:element>)
									</xsl:when>
									<xsl:when test="unreadlabel">
										<xsl:element name="xsl:if">
											<xsl:attribute name="test">a:propstat/a:prop/b:unreadcount[. $igt$ '0']</xsl:attribute>
											(<xsl:value-of select="unreadlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/b:unreadcount</xsl:attribute></xsl:element>)
										</xsl:element>
									</xsl:when>
								</xsl:choose>
							</SPAN>
						</TD>
					</TR>
					<TR id="groupContentRow" style="display:none;">
						<TD id="groupContentCell" nowrap="true" style="padding-left:20px"/>
					</TR>
					</xsl:element>
				</TABLE>
				</xsl:element>
			</xsl:element>
			</xsl:for-each>
			<xsl:element name="group">
				<xsl:element name="xsl:template">
				<xsl:attribute name="xmlns:xsl">uri:xsl</xsl:attribute>
				<xsl:attribute name="xmlns:a">DAV:</xsl:attribute>
				
				<xsl:element name="xsl:script">

				var re=/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}).\d{3}Z?$/;
				
				function getThreadIndexSpacing(szThreadIndex)
				{
					if(null == szThreadIndex || 0 == szThreadIndex.length) return "";
					var iTemp = szThreadIndex.length - 32;
					if (0 >= iTemp) return "3px";
					var iSpaces = (3 * Math.floor(iTemp/20));
					if (4 == (iTemp % 20)) iSpaces += 1;
					else if (12 == (iTemp % 20)) iSpaces += 2;
					iSpaces = (iSpaces * 16) + 3;
					return iSpaces.toString() + "px";
				}
				
				function formatMessageSize(szSize,szBAbbr,szKBAbbr,szMBAbbr)
				{
					if("" == szBAbbr)  szBAbbr  = "B";
					if("" == szKBAbbr) szKBAbbr = "KB";
					if("" == szMBAbbr) szMBAbbr = "MB";
					if("" == szSize)   szSize = "0";
					
					var iSize = parseInt(szSize,10);
					if (iSize > 0x100000)
					{
						iSize = Math.round(iSize/1048576);
						szSize  = iSize + " " + szMBAbbr;
					}
					else if(iSize > 0x400)
					{
						iSize = Math.round(iSize/1024);
						szSize  = iSize + " " + szKBAbbr;
					}
					else
					{
						szSize  = iSize + " " + szBAbbr;
					}
					return(szSize);
				}
				function formatDateTimeString(szISODate,szDateFormat,szTimeFormat)
				{
					re.lastIndex=0;
					var arr = re.exec( szISODate );
					if (null == arr) return "";
					var objDate = new Date(Date.UTC(arr[1],arr[2]-1,arr[3],arr[4],arr[5],arr[6],0));
					var szFormattedDate = formatDate(objDate.getVarDate(), szDateFormat);
					var szFormattedTime = formatTime(objDate.getVarDate(), szTimeFormat);
					//Check for null character and strip it off if present
					if(szFormattedDate.charCodeAt(szFormattedDate.length -1) == 0)
					{
						szFormattedDate = szFormattedDate.substring(0,szFormattedDate.length-1) 
					}
				     	if(szFormattedTime.charCodeAt(szFormattedTime.length -1) == 0)
     					{
						szFormattedTime = szFormattedTime.substring(0,szFormattedTime.length-1) 
     					}
					return szFormattedDate + " " + szFormattedTime;
				}
				</xsl:element>
				<TABLE isTabularView="true" >
				<xsl:apply-templates select="/view/viewstyle/@*"/>
				<xsl:attribute name="style"><xsl:value-of select="/view/viewstyle"/></xsl:attribute>
		<!-- ******	Start Column heading xsl *********************** -->
					<TR id="tblHeader">
						<xsl:apply-templates select="/view/headerstyle/@*"/>
						<xsl:attribute name="style"><xsl:value-of select="/view/headerstyle"/></xsl:attribute>
						<xsl:for-each select="/view/column">
							<TD id="tdColumn" onclick="if(null == event.returnValue) event.returnValue=this;">
								<xsl:choose>
									<xsl:when test="visible[. = '0']">
										<xsl:attribute name="style">display:none</xsl:attribute>
									</xsl:when>
									<xsl:otherwise>
										<xsl:apply-templates select="headerstyle/@*"/>
										<xsl:attribute name="style">
											<xsl:choose>
												<xsl:when test="headerstyle"><xsl:value-of select="headerstyle"/></xsl:when>
												<xsl:otherwise>text-align:center;vertical-align:middle;cursor:hand</xsl:otherwise>
											</xsl:choose>
										</xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:attribute name="prop"><xsl:value-of select="prop"/></xsl:attribute>
								<xsl:attribute name="dataType"><xsl:value-of select="type" /></xsl:attribute>
								<xsl:attribute name="colName"><xsl:value-of select="heading"/></xsl:attribute>
								<xsl:attribute name="sortdir"><xsl:value-of select="/view/orderby/order[prop = context()/prop]/sort"/></xsl:attribute>
								<xsl:attribute name="sortable"><xsl:choose><xsl:when test="sortable[. = '0']">0</xsl:when><xsl:otherwise>1</xsl:otherwise></xsl:choose></xsl:attribute>
								<xsl:choose>
									<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/x-priority-long']">
										<IMG id="imgCol" style="cursor:hand">
											<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-importance.gif</xsl:attribute>
										</IMG>
									</xsl:when>
									<xsl:when test="prop[. = 'urn:schemas:httpmail:hasattachment']">
										<IMG id="imgCol" style="cursor:hand" >
											<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-paperclip.gif</xsl:attribute>
										</IMG>
									</xsl:when>
									<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/smallicon']">
										<IMG id="imgCol" style="cursor:hand" >
											<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-document.gif</xsl:attribute>
										</IMG>
									</xsl:when>
									<!-- Flag status col -->
									<xsl:when test="prop[.  = 'http://schemas.microsoft.com/mapi/proptag/x10900003']">
										<IMG id="imgCol" style="cursor:hand">
											<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-flag.gif</xsl:attribute>
										</IMG>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="heading"/>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:choose>
									<xsl:when test="bitmap[. = '1']" />
									<xsl:when test="sortable[. = '0']"/>
									<xsl:when test="/view/orderby/order[prop = context()/prop]/sort[. = 'DESC']">
										<IMG id="imgSortIndicator">
											<xsl:choose>
												<xsl:when test="/view/sortdescicon">
													<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/><xsl:value-of select="/view/sortdescicon"/></xsl:attribute>
												</xsl:when>
												<xsl:otherwise>
													<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/>view-sortdown.gif</xsl:attribute>
												</xsl:otherwise>
											</xsl:choose>
										</IMG>
									</xsl:when>
									<xsl:when test="/view/orderby/order[prop = context()/prop]/sort[. = 'ASC']">
										<IMG id="imgSortIndicator">
											<xsl:choose>
												<xsl:when test="/view/sortascicon">
													<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/><xsl:value-of select="/view/sortascicon"/></xsl:attribute>
												</xsl:when>
												<xsl:otherwise>
													<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/>view-sortup.gif</xsl:attribute>
												</xsl:otherwise>
											</xsl:choose>
										</IMG>
									</xsl:when>
								</xsl:choose>
							</TD>
						</xsl:for-each>
						</TR>
		<!-- ****** End Column heading xsl *********************** -->
		<!-- ****** Start Property xsl     *********************** -->
				<xsl:element name="xsl:eval">
					var i=0;
				</xsl:element>
				<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:multistatus/a:response</xsl:attribute>
				<TR id="unSelected" onmousedown="if(null == event.returnValue) event.returnValue=this" onclick="if(null == event.returnValue) event.returnValue=this" ondblclick="if(null == event.returnValue) event.returnValue=this">
					<xsl:choose>
						<xsl:when test="view[rowstyle and altrowstyle]">
							<xsl:element name="xsl:choose">
								<xsl:element name="xsl:when">
									<xsl:attribute name="expr">i++ %2</xsl:attribute>
									<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute><xsl:value-of select="view/altrowstyle"/><xsl:if test="/view/boldUnreadItems[. = 'true']"><xsl:element name="xsl:if"><xsl:attribute name="test">a:propstat/a:prop/read[.='0']</xsl:attribute>;font-weight:bold;</xsl:element></xsl:if></xsl:element>
									<xsl:for-each select = "view/altrowstyle/@*[nodeName() != 'style']">
										<xsl:element name="xsl:attribute"><xsl:attribute name="name"><xsl:eval>this.nodeName</xsl:eval></xsl:attribute><xsl:value-of select="."/></xsl:element>
									</xsl:for-each>
								</xsl:element>
								<xsl:element name="xsl:otherwise">
									<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute><xsl:value-of select="view/rowstyle"/><xsl:if test="/view/boldUnreadItems[. = 'true']"><xsl:element name="xsl:if"><xsl:attribute name="test">a:propstat/a:prop/read[.='0']</xsl:attribute>;font-weight:bold;</xsl:element></xsl:if></xsl:element>
									<xsl:for-each select = "view/rowstyle/@*[nodeName() != 'style']">
										<xsl:element name="xsl:attribute"><xsl:attribute name="name"><xsl:eval>this.nodeName</xsl:eval></xsl:attribute><xsl:value-of select="."/></xsl:element>
									</xsl:for-each>
								</xsl:element>
							</xsl:element>
						</xsl:when>
						<xsl:when test="view/rowstyle">
							<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute><xsl:value-of select="view/rowstyle"/><xsl:if test="/view/boldUnreadItems[. = 'true']"><xsl:element name="xsl:if"><xsl:attribute name="test">a:propstat/a:prop/read[.='0']</xsl:attribute>;font-weight:bold;</xsl:element></xsl:if></xsl:element>
							<xsl:for-each select = "view/rowstyle/@*[nodeName() != 'style']">
								<xsl:element name="xsl:attribute"><xsl:attribute name="name"><xsl:eval>this.nodeName</xsl:eval></xsl:attribute><xsl:value-of select="."/></xsl:element>
							</xsl:for-each>
						</xsl:when>
					</xsl:choose>
					<!-- Add messageClass to expando prop on the row 
					** Note - Do not add CRLF's here or xsl will output them with value
					-->
					<xsl:element name="xsl:attribute"><xsl:attribute name="name">_href</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:href</xsl:attribute></xsl:element></xsl:element>
					<xsl:element name="xsl:attribute"><xsl:attribute name="name">_davhref</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/davhref</xsl:attribute></xsl:element></xsl:element>
					<xsl:element name="xsl:attribute"><xsl:attribute name="name">messageClass</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/messageclass</xsl:attribute></xsl:element></xsl:element>
					<A  onclick="return(false)" tabindex="-1">
					<xsl:element name="xsl:attribute"><xsl:attribute name="name">href</xsl:attribute>
					<xsl:element name="xsl:value-of"><xsl:attribute name="select">a:href</xsl:attribute></xsl:element></xsl:element>
					<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:propstat/a:prop</xsl:attribute>
						<xsl:for-each select="view/column">
							<TD id="tableTD">
								<xsl:choose>
									<xsl:when test="visible[. = '0']">
										<xsl:attribute name="style">display:none</xsl:attribute>
									</xsl:when>
									<xsl:otherwise>
										<xsl:apply-templates select="style/@*"/>
										<xsl:element name="xsl:attribute">
											<xsl:attribute name="name">style</xsl:attribute>
											<xsl:value-of select="style"/>
											<xsl:if test="indentcolumn[. = '1']">
												<xsl:element name="xsl:for-each">
													<xsl:attribute name="select">threadindex</xsl:attribute>
													;padding-left:<xsl:element name="xsl:eval">getThreadIndexSpacing(this.text)</xsl:element>
												</xsl:element>
											</xsl:if>
										</xsl:element>
									</xsl:otherwise>
								</xsl:choose>
							<xsl:choose>
				<!-- ****** Start Custom XSL Property    *********************** -->
								<xsl:when test="customxsl[. != '' and /view/xslpassthrough[@name = context()/customxsl]]">
									<xsl:for-each select="/view/xslpassthrough[@name = context()/customxsl]">
										<xsl:for-each><xsl:eval no-entities='t'>this.xml</xsl:eval></xsl:for-each>
									</xsl:for-each>
								</xsl:when>
				<!-- ****** End Custom XSL Property      *********************** -->
				<!-- ****** Start Content Length Property xsl   *********************** -->
								<xsl:when test="prop[.  = 'http://schemas.microsoft.com/mapi/proptag/x0e080003']">
									<xsl:element name="xsl:for-each">
										<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute>
										<xsl:element name="xsl:eval">formatMessageSize(this.text,"<xsl:value-of select='/view/byteabbreviation'/>","<xsl:value-of select='/view/kilobyteabbreviation'/>","<xsl:value-of select='/view/megabyteabbreviation'/>")</xsl:element>
									</xsl:element>
								</xsl:when>
				<!-- ****** End Content Length Property xsl     *********************** -->
				<!-- ****** Start Content Class Property xsl    *********************** -->
								<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/smallicon']">
									<IMG width="16" height="16">
										<xsl:element name="xsl:attribute"><xsl:attribute name="name">src</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute></xsl:element></xsl:element>
									</IMG>
								</xsl:when>
				<!-- ****** End Content Class Property xsl     *********************** -->
				<!-- ****** Start Importance Property xsl     *********************** -->
								<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/x-priority-long']">
									<xsl:element name="xsl:choose">
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='0']</xsl:attribute>
											<xsl:element name="IMG">
												<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-lowimportance.gif</xsl:attribute>
												<xsl:attribute name="style">cursor:hand</xsl:attribute>
											</xsl:element>
										</xsl:element>
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='2']</xsl:attribute>
											<xsl:element name="IMG">
												<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-highimportance.gif</xsl:attribute>
												<xsl:attribute name="style">cursor:hand</xsl:attribute>
											</xsl:element>
										</xsl:element>
									</xsl:element>
								</xsl:when>
				<!-- ****** End Importance Property xsl     *********************** -->
				<!-- *****  Start Flag Status Property xsl     *********************** -->  
								<xsl:when test="prop[. = 'http://schemas.microsoft.com/mapi/proptag/x10900003']">
									<xsl:element name="xsl:choose">
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='1']</xsl:attribute>
											<xsl:element name="IMG">
												<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-flag-complete.gif</xsl:attribute>
												<xsl:attribute name="style">cursor:hand</xsl:attribute>
											</xsl:element>
										</xsl:element>
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='2']</xsl:attribute>
											<xsl:element name="IMG">
												<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-flag.gif</xsl:attribute>
												<xsl:attribute name="style">cursor:hand</xsl:attribute>
											</xsl:element>
										</xsl:element>
									</xsl:element>
								</xsl:when>
				<!-- ****** End Flag Status Property xsl     *********************** -->
				<!-- ****** Start has attachment Property xsl     *********************** -->
								<xsl:when test="prop[. = 'urn:schemas:httpmail:hasattachment']">
									<xsl:element name="xsl:choose">
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='1']</xsl:attribute>
											<xsl:element name="IMG">
												<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-paperclip.gif</xsl:attribute>
												<xsl:attribute name="style">cursor:hand</xsl:attribute>
											</xsl:element>
										</xsl:element>
									</xsl:element>
								</xsl:when>
				<!-- ****** End has attachment Property xsl      *********************** -->
				<!-- ****** Start boolean properties xsl        *********************** -->
								<xsl:when test="type[. = 'boolean' and context()/format[. = 'boolicon']]">
									<xsl:choose>
										<xsl:when test=".[booltrueicon and boolfalseicon]">
											<xsl:element name="xsl:choose">
												<xsl:element name="xsl:when">
													<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '1']</xsl:attribute>
													<IMG><xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/><xsl:value-of select="booltrueicon"/></xsl:attribute></IMG>
												</xsl:element>
												<xsl:element name="xsl:when">
													<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '0']</xsl:attribute>
													<IMG><xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/><xsl:value-of select="boolfalseicon"/></xsl:attribute></IMG>
												</xsl:element>
											</xsl:element>
										</xsl:when>
										<xsl:when test="booltrueicon">
											<xsl:element name="xsl:if">
												<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '1']</xsl:attribute>
												<IMG><xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/><xsl:value-of select="booltrueicon"/></xsl:attribute></IMG>
											</xsl:element>
										</xsl:when>
										<xsl:when test="boolfalseicon">
											<xsl:element name="xsl:if">
												<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '0']</xsl:attribute>
												<IMG><xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/><xsl:value-of select="boolfalseicon"/></xsl:attribute></IMG>
											</xsl:element>
										</xsl:when>
										<xsl:otherwise>
											<xsl:element name="xsl:if">
												<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '1']</xsl:attribute>
												<IMG><xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/>view-check.gif</xsl:attribute></IMG>
											</xsl:element>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
				<!-- ****** End boolean properties xsl        *********************** -->
				<!-- ****** Start non special properties xsl   *********************** -->
								<xsl:otherwise>
									<xsl:element name="xsl:choose">
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[@b:dt = 'mv.string']</xsl:attribute>
											<xsl:element name="xsl:for-each">
												<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval>/*</xsl:attribute>
												<xsl:element name="xsl:value-of"><xsl:attribute name="select">.</xsl:attribute></xsl:element><xsl:element name="xsl:if"><xsl:attribute name="test">context()[not(end())]</xsl:attribute>, </xsl:element>
											</xsl:element>
										</xsl:element>
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[@b:dt = 'int' or @b:dt = 'float' or @b:dt = 'i1' or @b:dt = 'i2' or @b:dt = 'i4' or @b:dt = 'i8' or @b:dt = 'ui1' or @b:dt = 'ui2' or @b:dt = 'ui4' or @b:dt = 'ui8' or @b:dt = 'r4' or @b:dt = 'r8']</xsl:attribute>
											<xsl:element name="xsl:for-each">
												<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute>
												<xsl:element name="xsl:eval">formatNumber(new Number(this.text), "<xsl:value-of select='format' />")</xsl:element>
											</xsl:element>
										</xsl:element>
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[@b:dt = 'dateTime.tz' or @b:dt = 'dateTime']</xsl:attribute>
											<xsl:element name="xsl:for-each">
												<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute>
												<xsl:element name="xsl:eval">formatDateTimeString(this.text, "<xsl:value-of select='dateformat' />", "<xsl:value-of select='timeformat' />")</xsl:element>
											</xsl:element>
										</xsl:element>
										<xsl:element name="xsl:otherwise">
											<xsl:choose>
												<xsl:when test="bitmap[. = '1']">
													<xsl:element name="xsl:if">
														<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. != '']</xsl:attribute>
														<IMG>
															<xsl:element name="xsl:attribute"><xsl:attribute name="name">src</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute></xsl:element></xsl:element>
														</IMG>
													</xsl:element>
												</xsl:when>
												<xsl:otherwise>
													<xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute></xsl:element>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:element>
									</xsl:element>
								</xsl:otherwise>
				<!-- ****** End non special properties xsl        *********************** -->
							</xsl:choose>
						</TD>
						</xsl:for-each>
					</xsl:element>
				</A>
				</TR>
				</xsl:element>
				</TABLE>
		<!-- ****** End Property xsl     *********************** -->
				</xsl:element>
			</xsl:element>
		</xsl:otherwise>
	</xsl:choose>
</xsl:element>
</xsl:template>
</xsl:stylesheet>