//Copyright (c) 2000-2001 Microsoft Corporation.  All rights reserved.
//<script>

var m_dlgArgs =	window.dialogArguments;
var m_winDocAll	= null;
var m_objStartTime;
var m_objEndTime;
var m_objStartOnDate;
var m_objEndByDate;
var m_rgReturnCommands = m_dlgArgs["rgReturnCommands"]
var m_rgReturnValues = m_dlgArgs["rgReturnValues"]
var g_cExceptions = m_dlgArgs["cExceptions"]
var CONST_MS_IN_24HRS	= 86400000;
var CONST_MS_IN_1MIN	= 60000;
var CONST_MS_IN_1HR		= 3600000;
var m_iMsDuration;
var m_objMsgDataXML = null;

function SetWeekdayDropDown(ddDay, value)
{
	var iLength = ddDay.length;
	for (var iList = 0; iList < iLength; iList++)
	{
		if (ddDay[iList].value == value)
		{
			ddDay[iList].selected = true;
			return;
		}
	}
}

function setWeekdayInfo(iWeeklyPatternBitMask,iWeekDay,iByPosition,szDay, szEach)
{
	if (iWeeklyPatternBitMask != 0)
	{
		if (iWeeklyPatternBitMask == 0x7f)			iWeekDay = 7;
		else if (iWeeklyPatternBitMask == 0x3e)		iWeekDay = 8;
		else if (iWeeklyPatternBitMask == 0x41)		iWeekDay = 9;
		SetWeekdayDropDown(m_winDocAll[szDay], iWeekDay);
		m_winDocAll[szEach].selectedIndex = (-1 == iByPosition ? 4 : iByPosition - 1);
	}
	else
	{
		var WeekDaysMask = Number(m_objMsgDataXML.selectSingleNode("messagedata/weekdays").text);
		var Interval	 = WeekDaysMask & 0xFFFF;
		var WeekDays	 = (WeekDaysMask > 0xFFFF)?((WeekDaysMask & 0xFFFF0000) >> 16):0;
		SetWeekdayDropDown(m_winDocAll[szDay], WeekDays);
		m_winDocAll[szEach].selectedIndex = (0xFFFF == Interval ? 4 : Interval - 1);
	}
}


function loadDailyRecurrence()
{
	m_winDocAll['optMainPattern'][0].checked=true;
	showMainPattern(0);
	var iWeekPatternBitMask = Number(m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text);
	if (iWeekPatternBitMask != 0)
	{
		m_winDocAll['optDaily'][0].checked=false;
		m_winDocAll['optDaily'][1].checked=true;
	}
	else //default to "days"
	{
		m_winDocAll['optDaily'][0].checked=true;
		m_winDocAll['optDaily'][1].checked=false;
		m_winDocAll['txtDailyEvery'].value = m_objMsgDataXML.selectSingleNode("messagedata/interval").text;
	}
}

function loadWeeklyRecurrence()
{
	var iWeekPatternBitMask = Number(m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text);
	m_winDocAll['optMainPattern'][1].checked=true;
	m_winDocAll['txtWeeklyEvery'].value	= m_objMsgDataXML.selectSingleNode("messagedata/interval").text;
	m_winDocAll["chkDOW1"].checked	= (iWeekPatternBitMask&1)?true:false;
	m_winDocAll["chkDOW2"].checked	= (iWeekPatternBitMask&2)?true:false;
	m_winDocAll["chkDOW3"].checked	= (iWeekPatternBitMask&4)?true:false;
	m_winDocAll["chkDOW4"].checked	= (iWeekPatternBitMask&8)?true:false;
	m_winDocAll["chkDOW5"].checked	= (iWeekPatternBitMask&16)?true:false;
	m_winDocAll["chkDOW6"].checked	= (iWeekPatternBitMask&32)?true:false;
	m_winDocAll["chkDOW7"].checked	= (iWeekPatternBitMask&64)?true:false;
}

function loadMonthlyRecurrence(iDateNumber)
{
	m_winDocAll['optMainPattern'][2].checked=true;
	showMainPattern(2);

	var iInterval				=	Number(m_objMsgDataXML.selectSingleNode("messagedata/interval").text);
	var	iWeeklyPatternBitMask	=	Number(m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text);
	var iDayOfMonth				=	Number(m_objMsgDataXML.selectSingleNode("messagedata/dayofmonth").text);

	m_winDocAll['txtMonthlyMonth'].value =iInterval;
	m_winDocAll['txtMonthlyMonths'].value=iInterval;

	if (iDayOfMonth != 0)
	{
		m_winDocAll['idOM1'].checked=true;
		m_winDocAll['idOM2'].checked=false;
		m_winDocAll['txtMonthlyDays'].value=iDayOfMonth;
		return;
	}
	var iByPosition = Number(m_objMsgDataXML.selectSingleNode("messagedata/position").text);
	m_winDocAll['idOM1'].checked=false;
	m_winDocAll['idOM2'].checked=true;
	m_winDocAll['txtMonthlyDays'].value=iDateNumber;
	setWeekdayInfo(iWeeklyPatternBitMask,0,iByPosition,'listMonthlyDay', 'listMonthlyEach');
}

function loadYearlyRecurrence()
{
	m_winDocAll['optMainPattern'][3].checked=true;
	showMainPattern(3);
	var iMonthPatternBitMask= Number(m_objMsgDataXML.selectSingleNode("messagedata/moy_mask").text);
	var listMonthIndex		= (iMonthPatternBitMask.toString(2).length-1) - 1;
	var iDayOfMonth			= Number(m_objMsgDataXML.selectSingleNode("messagedata/dayofmonth").text);

	if (iDayOfMonth != 0)
	{
		m_winDocAll['optY1'].checked=true;
		m_winDocAll['txtYearlyDay'].value =	iDayOfMonth;
		m_winDocAll['listYearlyMonth'].selectedIndex = listMonthIndex;
		return;
	}
	var iByPosition				=	Number(m_objMsgDataXML.selectSingleNode("messagedata/position").text);
	var	iWeeklyPatternBitMask	=	Number(m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text);
	m_winDocAll['optY2'].checked=true;
	m_winDocAll['listYearlyMonth2'].selectedIndex = listMonthIndex;
	setWeekdayInfo(iWeeklyPatternBitMask,0,iByPosition,'listYearlyDay', 'listYearlyEach');
}

function loadRecurrenceWithoutEndDate()
{
	var objD = new Date(m_dlgArgs["vtStartDate"]);
	objD.setMonth(objD.getMonth()+3);
	idDatepickers.vtLocalEndCalDate = objD;
	m_winDocAll["optRangeEnd"][0].checked = true;
}

function loadRecurrenceByOccurrences()
{
	var objD = new Date(m_dlgArgs["vtStartDate"]);
	m_winDocAll["optRangeEnd"][1].checked = true;
	m_winDocAll['txtRangeOccurances'].value = m_objMsgDataXML.selectSingleNode("messagedata/occurences").text;
	objD.setMonth(objD.getMonth()+3);
	idDatepickers.vtLocalEndCalDate = objD;
}

function loadRecurrenceByEndDate()
{
	szTzDate = m_objMsgDataXML.selectSingleNode("messagedata/patternend").text;
	var objD = getLocalDateObjFromGMTTime(szTzDate);
	idDatepickers.vtLocalEndCalDate = objD;
	m_winDocAll["optRangeEnd"][2].checked=true;
}

function sizeDialogWindow()
{
	var oBody = window.document.body;
	var iPattern = getMainPattern();
	showMainPattern(2); // monthly requires the largest view
	var iHeight = oBody.scrollHeight + ( parseInt(window.dialogHeight, 10) - oBody.clientHeight) + 15;
	var iWidth = oBody.scrollWidth + ( parseInt(window.dialogWidth, 10) - oBody.clientWidth ) + 20;
	window.dialogHeight = iHeight + "px";
	window.dialogWidth = iWidth + "px";
	showMainPattern(iPattern);
}

function window.onload()
{
	m_winDocAll	= window.document.all;

	//+1ms seems to prevent random drops of a second (a JS rounding thing)
	m_objStartTime=new Date(m_dlgArgs["vtStartDate"]+1);//input from the current datepicker settings
	m_objEndTime=new Date(m_dlgArgs["vtEndDate"]+1);
	m_objStartOnDate=new Date(m_dlgArgs["vtStartDate"]+1);
	m_objEndByDate=new Date(m_dlgArgs["vtEndDate"]+1);
	m_objEndByDate.setMonth(m_objEndByDate.getMonth()+3);

	var oStyles = window.document.styleSheets[0];
	var szFont = "font-family:'" + window.document.body.currentStyle.fontFamily + "'";
	oStyles.addRule( "SELECT", szFont );
	oStyles.addRule( "INPUT", szFont );
	oStyles.addRule( "BUTTON", szFont );

	//now init all the fields to the given dates
	//this sets both the dates and times
	idDatepickers.vtLocalDate = m_objStartTime;
	idDatepickers.vtLocalEndDate = m_objEndByDate;
	//override the endtimepicker to show duration if true endtime is < 24hours
	if (m_objEndTime.getTime() - m_objStartTime.getTime() < CONST_MS_IN_24HRS)
	{
		idDatepickers.setEndtimePicker24hours = true;
	}
	m_iMsDuration	= m_objEndTime.getTime() - m_objStartTime.getTime();
	var	iDateNumber	= m_objStartTime.getDate();
	var	iWeekdayNumber = m_objStartTime.getDay();
	var	iMonthNumber = m_objStartTime.getMonth();

	chkDOW[iWeekdayNumber].checked = true;
	txtMonthlyDays.value = iDateNumber;
	SetWeekdayDropDown(listMonthlyDay, iWeekdayNumber);
	listYearlyMonth.selectedIndex =	iMonthNumber;
	txtYearlyDay.value = iDateNumber;
	//calc is this the first/second/third/fourth/last weekday of the month
	var	iR = parseInt(iDateNumber/7);
	listYearlyEach.selectedIndex = iR;
	SetWeekdayDropDown(listYearlyDay, iWeekdayNumber);
	listYearlyMonth2.selectedIndex = iMonthNumber;
	if (null != m_dlgArgs["iWeekdayStartsOn"])
	{
		idDatepickers.firstDayOfWeek = m_dlgArgs["iWeekdayStartsOn"];
	}

	m_objMsgDataXML =	m_dlgArgs["objMsgDataXml"];
	var	nodeRecurType =	m_objMsgDataXML.selectSingleNode("messagedata/recurtype");
	sizeDialogWindow();
	if (null == nodeRecurType || "" == nodeRecurType.text)
		return;
	switch(Number(nodeRecurType.text))
	{
		case 1:		loadDailyRecurrence();
					break;
		case 2:		loadWeeklyRecurrence();
					break;
		case 3:		loadMonthlyRecurrence(iDateNumber);
					break;
		case 4:		loadYearlyRecurrence();
					break;
	}
	// ********** Range of recurrence **********************
	if (m_objMsgDataXML.selectSingleNode("messagedata/patternstart") != null &&
		m_objMsgDataXML.selectSingleNode("messagedata/patternstart").text != "")
	{
		var szTzDate = m_objMsgDataXML.selectSingleNode("messagedata/patternstart").text
		idDatepickers.vtLocalCalDate = getLocalDateObjFromGMTTime(szTzDate);
	}
	else
	{
		idDatepickers.vtLocalCalDate = new Date(m_dlgArgs["vtStartDate"]);
	}

	// Pattern End
	var iType = parseInt(m_objMsgDataXML.selectSingleNode("messagedata/end_type").text,10);
	if (!isNaN(iType))
	{
		switch (iType)
		{
			case 0:		loadRecurrenceWithoutEndDate();
						break;
			case 1:		loadRecurrenceByOccurrences();
						break;
			default:	loadRecurrenceByEndDate();
		}
	}
}

function event_btnRemoveRecurrence_onclick()
{
	putReturnData("dtStart",m_objEndTime);
	putReturnData("dtEnd",m_objEndTime);
	putReturnData("recur_end","none");
	putReturnData("recur_type","0");
	m_objMsgDataXML.selectSingleNode("messagedata/recurtype").text = "";
	m_objMsgDataXML.selectSingleNode("messagedata/end_type").text = "0";
	m_objMsgDataXML.selectSingleNode("messagedata/occurences").text = "0";
	this.returnValue = 0; //indicates remove
	window.close();
}

function event_btnCancel_onclick()
{
	this.returnValue = -1; //indicates cancel
	window.close();
}

function putReturnData(szCommand,vData)
{
	var iX = m_rgReturnCommands.length;
	m_rgReturnCommands[iX] = szCommand;
	m_rgReturnValues[iX] = vData;
}

function saveDailyRecurrence(eParent)
{
	var eAllOptDaily = eParent.all['optDaily'];
	putReturnData("recur_type","1");
	for (var x=0; x < eAllOptDaily.length;x++)
	{
		if (eAllOptDaily[x].checked) break;
	}
	if (x==0)
	{
		putReturnData("daily_type","days");
		var iNumber = validateNumber(eParent.all['txtDailyEvery'].value)
		if (isNaN(iNumber))
		{
			eParent.all['txtDailyEvery'].focus();
			return L_idsRecurrencePatternNotValid_Text;
		}
		putReturnData("days",iNumber); //every x days
		m_objMsgDataXML.selectSingleNode("messagedata/interval").text = iNumber;
		m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text = 0;
	}
	else
	{
		putReturnData("daily_type","weekdays");
		var iBitMask = 0;
		iBitMask |= 1;
		iBitMask |= 2;
		iBitMask |= 4;
		iBitMask |= 8;
		iBitMask |= 16;
		iBitMask |= 32;
		iBitMask |= 64;
		m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text =iBitMask;
	}
	return "";
}

function saveWeeklyRecurrence(eParent)
{
	var szDOW="";
	var eAllChkDOW = eParent.all['chkDOW'];
	var iBitMask = 0;
	var iNumber;

	putReturnData("recur_type","2");
	iNumber = validateNumber(eParent.all['txtWeeklyEvery'].value);
	if (isNaN(iNumber))
	{
		eParent.all['txtWeeklyEvery'].focus();
		return L_idsRecurrencePatternNotValid_Text;
	}
	putReturnData("weeks",iNumber);
	m_objMsgDataXML.selectSingleNode("messagedata/interval").text = iNumber;
	iBitMask = (eParent.all["chkDOW1"].checked)?iBitMask|1:iBitMask;
	iBitMask = (eParent.all["chkDOW2"].checked)?iBitMask|2:iBitMask;
	iBitMask = (eParent.all["chkDOW3"].checked)?iBitMask|4:iBitMask;
	iBitMask = (eParent.all["chkDOW4"].checked)?iBitMask|8:iBitMask;
	iBitMask = (eParent.all["chkDOW5"].checked)?iBitMask|16:iBitMask;
	iBitMask = (eParent.all["chkDOW6"].checked)?iBitMask|32:iBitMask;
	iBitMask = (eParent.all["chkDOW7"].checked)?iBitMask|64:iBitMask;
	if (0 == iBitMask) // at least one day must be checked
	{
		eParent.all['chkDOW1'].focus();
		return L_idsRecurrencePatternNotValid_Text;
	}
	m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text = iBitMask;
	putReturnData("dow_mask",iBitMask);
	return "";
}

function saveMonthlyRecurrence(eParent)
{
	var iNumber;
	var iDOWMask = 0;
	var iMoDayVal;
	putReturnData("recur_type","3");
	if (eParent.all['optMonthly'][0].checked)//day X of every X months
	{
		var	iDays =  validateNumber(eParent.all['txtMonthlyDays'].value);
		var	iMonth = validateNumber(eParent.all['txtMonthlyMonth'].value);
		if (isNaN(iDays) ||	iDays >	31)
		{
			eParent.all['txtMonthlyDays'].focus();
			return L_idsRecurrencePatternNotValid_Text;
		}
		else if (isNaN(iMonth))
		{
			eParent.all['txtMonthlyMonth'].focus();
			return L_idsRecurrencePatternNotValid_Text;
		}
		m_objMsgDataXML.selectSingleNode("messagedata/dayofmonth").text = iDays;
		m_objMsgDataXML.selectSingleNode("messagedata/interval").text   = iMonth;
		m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text   = 0;
		putReturnData("monthly_type","day");
		putReturnData("month_day",iDays);
		putReturnData("month_number",iMonth);
		return "";
	}
	iNumber = validateNumber(eParent.all['txtMonthlyMonths'].value);
	if (isNaN(iNumber))
	{
		eParent.all['txtMonthlyMonths'].focus();
		return L_idsRecurrencePatternNotValid_Text;
	}
	iMoDayVal = eParent.all['listMonthlyDay' ].selectedIndex;
	switch(iMoDayVal)
	{
		case 0:	iDOWMask = 0x7f;	break;
		case 1:	iDOWMask = 0x3e;	break;
		case 2:	iDOWMask = 0x41;	break;
	}
	if(0 != iDOWMask)
	{
		m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text = iDOWMask;
		m_objMsgDataXML.selectSingleNode("messagedata/weekdays").text = 0;
	}
	else
	{
		var WeekDaysMask = (iMoDayVal-3|0xFFFF0000)<<16;
		var Interval = eParent.all['listMonthlyEach'].value;
		if(-1 == Interval)
		{
			Interval = 0xFFFF;
		}
		m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text = 0;
		m_objMsgDataXML.selectSingleNode("messagedata/weekdays").text = WeekDaysMask | Interval;
	}
	m_objMsgDataXML.selectSingleNode("messagedata/interval").text = iNumber;
	m_objMsgDataXML.selectSingleNode("messagedata/position").text = eParent.all['listMonthlyEach' ].value;
	putReturnData("monthly_type", "pattern");
	putReturnData("month_recur1", eParent.all['listMonthlyEach'].value);
	putReturnData("month_recur2", eParent.all['listMonthlyDay'].value);
	putReturnData("month_number2",iNumber);
	return "";
}

function saveYearlyRecurrence(eParent)
{
	var iNumber;

	putReturnData("recur_type","4");
	if (eParent.all['optYearly'][0].checked)
	{
		iNumber = validateNumber(m_winDocAll['txtYearlyDay'].value);
		if (isNaN(iNumber) || iNumber > 31)
		{
			eParent.all['txtYearlyDay'].focus();
			return L_idsRecurrencePatternNotValid_Text;
		}
		//validate not greater than the last day of selected month
		var objD = new Date();
		objD.setDate(1);
		objD.setMonth(eParent.all['listYearlyMonth'].selectedIndex + 1)
		objD.setDate(0);
		if (iNumber > objD.getDate())
		{
			eParent.all['txtYearlyDay'].focus();
			return L_idsRecurrencePatternNotValid_Text;
		}
		var res = Math.pow(2,m_winDocAll['listYearlyMonth'].selectedIndex + 1);
		m_objMsgDataXML.selectSingleNode("messagedata/moy_mask").text	= res;
		m_objMsgDataXML.selectSingleNode("messagedata/dayofmonth").text	= iNumber;
		m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text	= 0;
		putReturnData("yearly_type","every");
		putReturnData("year_recur1", eParent.all['listYearlyMonth'].selectedIndex + 1);
		putReturnData("month_day_number", iNumber);
		return "";
	}
	var iDOWMask = 0;
	var iMoDayVal = eParent.all['listYearlyDay' ].selectedIndex;
	var iMonthIndex = eParent.all['listYearlyMonth2'].selectedIndex;
	switch(iMoDayVal)
	{
		case 0:	iDOWMask = 0x7f;	break;
		case 1:	iDOWMask = 0x3e;	break;
		case 2:	iDOWMask = 0x41;	break;
	}
	if(0 != iDOWMask)
	{
		m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text = iDOWMask;
		m_objMsgDataXML.selectSingleNode("messagedata/weekdays").text = 0;
	}
	else
	{
		var WeekDaysMask = (iMoDayVal-3|0xFFFF0000)<<16;
		var Interval = eParent.all['listYearlyEach'].value;
		if(-1 == Interval)
		{
			Interval = 0xFFFF;
		}
		m_objMsgDataXML.selectSingleNode("messagedata/dow_mask").text = 0;
		m_objMsgDataXML.selectSingleNode("messagedata/weekdays").text = WeekDaysMask | Interval;
	}
	m_objMsgDataXML.selectSingleNode("messagedata/position").text = eParent.all['listYearlyEach' ].value;
	m_objMsgDataXML.selectSingleNode("messagedata/monthofyear").text = iMonthIndex+1;
	m_objMsgDataXML.selectSingleNode("messagedata/moy_mask").text = Math.pow(2,iMonthIndex+1);
	putReturnData("yearly_type", "pattern");
	putReturnData("year_recur2", eParent.all['listYearlyEach'].value);
	putReturnData("year_recur3", eParent.all['listYearlyDay'].value);
	putReturnData("year_recur4", iMonthIndex + 1);
	return "";
}
function saveRecurrenceWithoutEndDate()
{
	putReturnData("recur_end","none");
	m_objMsgDataXML.selectSingleNode("messagedata/end_type").text = "0";
	m_objMsgDataXML.selectSingleNode("messagedata/occurences").text = "0";
}

function saveRecurrenceByOccurrences(iRangeOccurrences)
{
	putReturnData("recur_end","occurrences");
	putReturnData("recur_end_occurrences", iRangeOccurrences);
	m_objMsgDataXML.selectSingleNode("messagedata/occurences").text = iRangeOccurrences;
	m_objMsgDataXML.selectSingleNode("messagedata/end_type").text = "1";
}

function saveRecurrenceByEndDate()
{
	putReturnData("recur_end","date");
	putReturnData("recur_end_month",idDatepickers.endMonth + 1);
	putReturnData("recur_end_day",	idDatepickers.endDate);
	putReturnData("recur_end_year",	idDatepickers.endFullYear);
	m_objMsgDataXML.selectSingleNode("messagedata/patternend").text	= idDatepickers.isoEndDateUTC;
	m_objMsgDataXML.selectSingleNode("messagedata/end_type").text = "2";
	m_objMsgDataXML.selectSingleNode("messagedata/occurences").text = "0";
}

function event_btnOk_onclick()
{
	var	szError="";
	var	iRangeOccurrences;

	if (g_cExceptions > 0 && confirm(L_idsConfirmRemoveExceptions_Text) == false)
	{
		return;
	}
	//first	validate Range entry is	a valid	number if they are selecting it
	if (m_winDocAll['optRangeEnd'][1].checked)
	{
		iRangeOccurrences = validateNumber(m_winDocAll['txtRangeOccurances'].value);
		if (isNaN(iRangeOccurrences))
		{
			m_winDocAll['txtRangeOccurances'].focus();
			alert(L_idsRecurrencePatternNotValid_Text);
			return;
		}
	}
	m_objMsgDataXML = m_dlgArgs["objMsgDataXml"];
	var	rgCommands = new Array();
	m_rgReturnCommands.length =	0;
	m_rgReturnValues.length	  =	0;

	putReturnData("dtStart",m_objStartTime.getVarDate());
	putReturnData("dtEnd", m_objEndTime.getVarDate());

	//Recurrence pattern
	var iMainPattern = getMainPattern();
	var eParent = window.document.all['divRecurPatterns'][iMainPattern];
	m_objMsgDataXML.selectSingleNode("messagedata/recurtype").text = iMainPattern + 1;
	switch (iMainPattern)
	{
		case 0:		szError = saveDailyRecurrence(eParent);
					break;
		case 1:		szError = saveWeeklyRecurrence(eParent);
					break;
		case 2:		szError = saveMonthlyRecurrence(eParent);
					break;
		case 3:		szError = saveYearlyRecurrence(eParent);
					break;
	}
	if ("" != szError)
	{
		alert(szError);
		return;
	}
	// ********** Range of recurrence **********************
	eParent = window.document.all['grpRangeRecurrence'];
	putReturnData("recur_start_month",(idDatepickers.startMonth ) + 1);
	putReturnData("recur_start_day",idDatepickers.startDate );
	putReturnData("recur_start_year",idDatepickers.startFullYear );
	m_objMsgDataXML.selectSingleNode("messagedata/patternstart").text = idDatepickers.isoDateUTC;
	var eEndRange = eParent.all['optRangeEnd'];
	if (eEndRange[0].checked)
	{
		saveRecurrenceWithoutEndDate();
	}
	else if (eEndRange[1].checked)
	{
		saveRecurrenceByOccurrences(iRangeOccurrences);
	}
	else
	{
		saveRecurrenceByEndDate();
	}
	this.returnValue = 1; //indicates setting recurrence
	window.close();
}

//Validates	number by returning	the	valid number or	NaN	(unicode is	converted to ansi number)
function validateNumber(inNum)
{
	var iEntry = Number(inNum);
	if(isNaN(iEntry))
	{
		//eval each	character looking for unicode and converting...
		var	iCh,chCode,szNewNumber="";
		for	(var x=0; x<inNum.length; x++)
		{
			//ASCII	  8	= 0000000000111000
			//UNICODE 8	= 1111111100011000
			//Need to mask off all but the last	5 bits (& 1F)

			iCh = inNum.charCodeAt(x);
			chCode = Number(iCh.toString(10));
			if (chCode > 0xFF) //unicode
			{
				chCode = (iCh &	0x001f)	| 0x20;
			}
			szNewNumber += String.fromCharCode(chCode);
		}
		iEntry = Number(szNewNumber);
	}
	return (iEntry)
}

//returns: 0=daily 1=weekly	2=monthly 3=yearly

function getMainPattern()
{
	var ePattern = window.document.all['optMainPattern'];
	for (var x=0;x<4;x++)
	{
		if (ePattern[x].checked) break;
	}
	return(x);
}

function showMainPattern(idx)
{
	var eAllPatterns = window.document.all['divRecurPatterns'];
	for(var x=0; x < eAllPatterns.length; x++)
	{
		eAllPatterns[x].style.display = "none";
	}
	window.document.all['divRecurPatterns'][idx].style.display="";
}

function onDateChanged(iWhich)
{
	switch (iWhich)
	{
		case 0:		//start
			var iMs1 = m_objStartOnDate.getTime();
			m_objStartOnDate.setFullYear( idDatepickers.startFullYear,idDatepickers.startMonth,idDatepickers.startDate );
			var msDiff = m_objStartOnDate.getTime()-iMs1;
			m_objStartTime.setTime(m_objStartTime.getTime()+msDiff);
			m_objEndTime.setTime(m_objEndTime.getTime()+msDiff);
			break;

		case 1:		//end
			m_objEndByDate.setFullYear( idDatepickers.endFullYear,idDatepickers.endMonth,idDatepickers.endDate );
			break;
	}
}

function onTimeChanged(iWhich)
{
	switch (iWhich)
	{
		case 0:		//start
			//adjust endtime to maintain duration
			m_objStartTime.setHours(idDatepickers.startHours,idDatepickers.startMinutes,0,0);
			idDatepickers.vtLocalEndTime = idDatepickers.vtLocalDate + m_iMsDuration;
			m_objEndTime.setHours(idDatepickers.endHours,idDatepickers.endMinutes,0,0);
			break;

		case 1:		//end
			m_iMsDuration = (idDatepickers.endHours*CONST_MS_IN_1HR  +  idDatepickers.endMinutes*CONST_MS_IN_1MIN) -
							(idDatepickers.startHours*CONST_MS_IN_1HR + idDatepickers.startMinutes*CONST_MS_IN_1MIN);
			if (m_iMsDuration < 0)
				m_iMsDuration += CONST_MS_IN_24HRS;
			m_objEndTime.setTime(m_objStartTime.getTime() + m_iMsDuration);
			break;
	}
}
