//Copyright (c) 2000-2001 Microsoft Corporation.  All rights reserved.
//<script>

var m_objRowLastSelected = null;			// last TR selected
var m_objXML = null;						// XML object returned from mf_getxml
var m_icurGrpLevel = 1;						// current group level for groupby views
var m_iCurrentPage;							// current page in the view
var m_objXSLNodes = null;					// XSL used in ongetxmlcomplete to transform data
var m_objDefaultXSLNodes = null;			// default XSL used to render a page
var m_objMSHTTP_Request=null;				// global XMLHTTP request object
var m_objXSLRequest = null;					// global XSL request object
var m_objHTMLTarget = this;					// target used when ongetxmlcomplete fires
var m_objAnchor  = null;					// Anchor to implement linkSpec functionality
var m_objHTTPViewDescriptor;				// xmlhttp object used in mf_loadViewDescriptorFromURL
var m_objXMLRequestQueue = null;			// queue of outstanding async XMLHTTP request
var m_iXMLQueueLength = 0;					// size of queue
var m_objParentTR = null;					// used in expandGroup to create expandos to parent TR's
var m_szURL="";								// URL of the folder whose contents the view displays
var m_szHighlightRowStyle
var m_szShadowRowStyle;
var m_fSelectionType = null;				// read-only (0), single-item (1), multiple item (2)
var m_bViewHasFocus = false;
var m_bTabKeyPressed = false;
var m_bFireOnReady = false;
var m_bDocumentReady = false;				// global boolean used to determine if we are loaded
var m_fEnterKeyNavigation = 1;				// none (0), single-click (1), double-click (2)
var m_fArrowKeyNavigation = 0;				// none (0), single-click (1), double-click (2)
var LEFT = 37;
var UP   = 38;
var RIGHT= 39;
var DOWN = 40;

//Paging variables
var m_iCurrentStartRange=0;
var m_iCurrentRowsNumber=0;
var m_imaxRows;
var m_objRowRange = null;

var m_objViewXML;			//Contains all xsl nodes for groups and content views
var m_objViewDescription;	//Contains main view description
var m_objQueries;
var m_objAnchorsSelected = null;
var m_gCallBack;

var m_objTransFormXSL = null; //XSL for view class
var m_rgszPropertySynonyms = new Array();
var m_szNormalizedSubject = "http://schemas.microsoft.com/mapi/proptag/x0e1d001f"
m_rgszPropertySynonyms["urn:schemas:httpmail:subject"]  = m_szNormalizedSubject
m_rgszPropertySynonyms["urn:schemas:mailheader:subject"] = m_szNormalizedSubject
m_rgszPropertySynonyms["http://schemas.microsoft.com/mapi/subject"] = m_szNormalizedSubject



this.viewReadyState = "initializing";

function RowRange(objStartRow, objEndRow)
{
	var iDelta = objStartRow.sourceIndex - objEndRow.sourceIndex;
	var objNextRow;
	
	this.rangeDirection = 0;
	
	if (iDelta == 0)
	{
		mf_selectRecord(objStartRow,true)
	}
	else
	{
		this.rangeDirection = (iDelta < 0)?DOWN:UP;
		mf_selectRecord(objStartRow,false)
		objNextRow = mf_getNextRow(objStartRow,this.rangeDirection)

		for( ;objNextRow.uniqueID != objEndRow.uniqueID &&
			  mf_selectRecord(objNextRow,false);)
		{
			objNextRow = mf_getNextRow(objNextRow,this.rangeDirection)
		}
		mf_selectRecord(objEndRow,true);
	}
	this.startRow = objStartRow;
	this.tempEndRow = objEndRow;
	this.endRow   = objEndRow;

	this.trimRange = mf_trimRowRange;
	this.expandRange = mf_expandRange;
	this.update =  mf_updateRowRange;

}
function mf_chooseValue(objViewDescNode, szHTMLAttributeValue, szDefaultValue)
{
	if(null != szHTMLAttributeValue && "" != szHTMLAttributeValue)
	{
		return szHTMLAttributeValue;
	}
	else if(null != objViewDescNode && "" != objViewDescNode.text)
	{
		return objViewDescNode.text;
	}
	return szDefaultValue;
}

function QueryCollection(xmlViewDescription)
{
	this.xmlDescription  = xmlViewDescription;
	this.queryCollection = new Array();
	
	var szSearchSubfolders	= mf_chooseValue(xmlViewDescription.selectSingleNode("view/searchSubfolders"),element.searchSubfolders,"");
	this.defaultRestriction = mf_chooseValue(xmlViewDescription.selectSingleNode("view/filter"),element.filter,"");
	this.scope				= mf_chooseValue(xmlViewDescription.selectSingleNode("view/scope"),element.scope,"");
	if("" == this.scope)
	{
		this.scope = "Scope('" + (("1" == szSearchSubfolders) ? "DEEP" : "SHALLOW") + " TRAVERSAL OF \"\"')";
	}
	if(null != element.filterAppend && "" != element.filterAppend)
	{
		if("" != this.defaultRestriction)
		{
			this.defaultRestriction = '(' + this.defaultRestriction + ') AND ' + element.filterAppend;
		}
		else
		{
			this.defaultRestriction = element.filterAppend;
		}
	}
	this.createQueryObjects = createQueryObjects;
	return(this.createQueryObjects(this.xmlDescription));
}

function QueryObject(parentObj, szType, xmlObj, iChildNumber,xmlViewDescriptor)
{
	this.parentObject = parentObj;
	this.columnPropNodes = null;
	this.selectString  = "";
	this.groupByNodes  = null;
	this.groupByString = "";
	this.orderByPropNodes = null;
	this.orderByString = "";
	this.type = szType;
	this.restriction = "";
	switch(szType)
	{
		case "content":
			 //Set column prop
			var queryNodes        = xmlObj.selectNodes("view/column/prop");
			this.columnPropNodes  = queryNodes;
			this.selectString     = createSelectSQL(queryNodes);
			this.defaultProps     = '"urn:schemas:httpmail:read" as read, "http://schemas.microsoft.com/exchange/outlookmessageclass" as messageclass';
			//Set order by node
			var orderbyNodes      = xmlObj.selectNodes("view/orderby/order");
			this.orderByPropNodes = orderbyNodes;
			this.orderByString    = createOrderBySQL(orderbyNodes);
			break;

		case "categorized":
			this.defaultProps	= '"DAV:visiblecount","urn:schemas:httpmail:unreadcount"';
			var objPropNodes	= xmlObj.selectNodes("prop");
			var objPropNode		= objPropNodes(0);
			this.orderByString	= createOrderBySQL(xmlObj);
			if (null != m_rgszPropertySynonyms[objPropNode.text])
			{
				this.groupByString = '"' + m_rgszPropertySynonyms[objPropNode.text] + '" ';
				objPropNode.text = m_rgszPropertySynonyms[objPropNode.text];
			}
			else
			{
				this.groupByString = '"' + objPropNode.text + '" ';
			}
			this.selectString = createSelectSQL(objPropNodes, iChildNumber);
			break;
			
		default:
			break;
	}
	this.getXMLSearchRequest = createXMLSearchRequest;
	return(this)
}

// returns XML search request including default props
function createXMLSearchRequest()
{
	var szCRLF = "\r\n";
	var szSQL = "SELECT " + this.selectString + this.defaultProps + szCRLF +
				"FROM " + this.parentObject.scope + szCRLF;
	var szRestriction;
	var fRestriction=false;

	if(null != this.parentObject.defaultRestriction && "" != this.parentObject.defaultRestriction)
	{
		szRestriction = this.parentObject.defaultRestriction;
		fRestriction = true;
	}
	if (null != this.restriction && "" != this.restriction)
	{
		if (fRestriction == true)
		{
			szRestriction += " AND ";
		}
		szRestriction += this.restriction;
		fRestriction = true;
	}
	if(fRestriction && "" != szRestriction && " " != szRestriction)
	{
		szSQL += "WHERE " + szRestriction + szCRLF;
	}
	if(this.type == "categorized")
	{
		szSQL += "GROUP BY " + this.groupByString + szCRLF;
	}
	if (this.orderByString != "")
	{
		szSQL += "ORDER BY " + this.orderByString;  
	}
	var szxml = '<searchrequest xmlns="DAV:" ><sql></sql></searchrequest>';
	var objSearchXML = new ActiveXObject("Microsoft.xmldom");
	objSearchXML.loadXML(szxml);
	var objNode = objSearchXML.selectSingleNode("searchrequest/sql");
	objNode.text = szSQL;
	return(objSearchXML.xml);
}

// returns SQL search request withOUT default props
function createSQLSearchRequest()
{
	var szCRLF = "\r\n";
	var szSQL = "", szSelectString = "", szFromString = "", szWhereString = "", szOrderByString = "";
	var fRestriction=false;

	szSelectString = createNamedSelectSQL(m_objViewDescription.selectNodes("/view/column | /view/groupbycolumn"));
	szFromString = (null != this.scope) ? "Scope('" + this.scope + "')" : "Scope('SHALLOW TRAVERSAL OF \"\"')";	

	var filterNode = m_objViewDescription.selectSingleNode("view/filter");
	szWhereString = mf_chooseValue(filterNode,this.filter,"");
	if(null != this.filterAppend && "" != this.filterAppend)
	{
		if("" != szWhereString)
		{
			szWhereString = '(' + szWhereString + ') AND ' + this.filterAppend;
		}
		else
		{
			szWhereString = this.filterAppend;
		}
	}
	var scopeNode  = m_objViewDescription.selectSingleNode("view/scope");
	szFromString = mf_chooseValue(scopeNode,this.scope,"");
	if("" == szFromString)
	{
		szFromString = "Scope('" + (("1" == this.searchSubfolders) ? "DEEP" : "SHALLOW") + " TRAVERSAL OF \"\"')";
	}
	
	var objGroupByColl = m_objViewDescription.selectNodes("/view/groupby/order");
	var objOrderByColl = m_objViewDescription.selectNodes("/view/orderby/order");
	var objProp, objSort;
	var e = new Enumerator( objGroupByColl );
	for (;!e.atEnd();e.moveNext())
	{
		objProp	= e.item().selectSingleNode("prop");
		objSort	= e.item().selectSingleNode("sort");
		if(null != objProp && "" != objProp.text)
		{
			szOrderByString += '"' + objProp.text + '"' + ((null == objSort) ? " ASC" : (" " + objSort.text)) + ", ";
		}
	}
	e = new Enumerator( objOrderByColl );
	for (;!e.atEnd();e.moveNext())
	{
		objProp	= e.item().selectSingleNode("prop");
		objSort	= e.item().selectSingleNode("sort");
		if(null != objProp && "" != objProp.text)
		{
			szOrderByString += '"' + objProp.text + '"' + ((null == objSort) ? " ASC" : (" " + objSort.text)) + ", ";
		}
	}
	// remember to remove last space & comma	
	szOrderByString = szOrderByString.substring(0,szOrderByString.length-2);
	szSQL = "SELECT " + szSelectString + szCRLF + 
			"FROM " + szFromString + szCRLF + 
			(("" == szWhereString) ?   "" : "WHERE " + szWhereString) + szCRLF + 
			(("" == szOrderByString) ? "" : "ORDER BY " + szOrderByString);
	return (szSQL);
}


function createQueryObjects(xmlViewObject)
{
	var objGroupByNodes = xmlViewObject.selectNodes("view/groupby/order");
	if (objGroupByNodes)
	{
		var e = new Enumerator( objGroupByNodes );
		var i = 0;
		for (;!e.atEnd();e.moveNext())
		{
			this.queryCollection[i] = new QueryObject(this, "categorized", e.item(), i + 1, xmlViewObject);
			i++;
		}
	}
	var contentQueryObject = new QueryObject(this, "content", xmlViewObject)
	this.queryCollection[i] = contentQueryObject;
	return(this.queryCollection);
}


/*************************BEGIN PROPERTY ACCESS FUNCTIONS********************************/

function coerceStringToInt(szString)
{
	switch(String(szString).toUpperCase())
	{
		case "0":
		case "NONE":			
		case "READONLY":	return 0;
		
		case "1":			
		case "SINGLE":		return 1;
		
		case "2":
		case "DOUBLE":
		case "MULTIPLE":	return 2;
		
		default:			return -1;
	}
}
function put_selectionType(szString)
{	
	var iTemp = coerceStringToInt(szString);
	m_fSelectionType = (iTemp < 0) ? m_fSelectionType : iTemp;
	var eventMethod = (0 == m_fSelectionType) ? this.detachEvent : this.attachEvent;
	eventMethod("onblur",onblur);
	eventMethod("onclick",onclick);
	eventMethod("ondblclick",ondblclick);
	eventMethod("ondragstart",ondragstart);
	eventMethod("onfocus",onfocus);
	eventMethod("onkeydown",onkeydown);
	eventMethod("onmousedown",onmousedown);
	eventMethod("onselectstart",onselectstart);
}
function get_selectionType()
{
	return m_fSelectionType;
}
function put_enterKeyNavigation(szString)
{
	var iTemp = coerceStringToInt(szString);
	m_fEnterKeyNavigation = (iTemp < 0) ? m_fEnterKeyNavigation : iTemp;
}
function get_enterKeyNavigation()
{
	return m_fEnterKeyNavigation;
}
function put_arrowKeyNavigation(szString)
{
	var iTemp = coerceStringToInt(szString);
	m_fArrowKeyNavigation = (iTemp < 0) ? m_fArrowKeyNavigation : iTemp;
}
function get_arrowKeyNavigation()
{
	return m_fArrowKeyNavigation;
}
function get_rowsPerPage()
{
	return(m_iCurrentRowsNumber)
}
function put_rowsPerPage(iNum)
{
	var num = parseInt(iNum,10);
	if(isNaN(num))
	{
		return false;
	}
	m_iCurrentRowsNumber = num;
	return true;
}

function get_page()
{
	return (m_iCurrentPage);
}
function put_page(varPage)
{
	var iPage;
	if (isNaN(iPage = parseInt(varPage,10)) )
	{
		iPage = 1;
	}
	if(m_bDocumentReady)
	{
		f_gotoPage(iPage);
	}
	else
	{
		m_iCurrentPage = iPage;
	}
}
function get_query()
{
	return createSQLSearchRequest();
}

function put_url(szURL)
{
	m_szURL = szURL;
	if(m_bDocumentReady)
	{
		m_iCurrentPage = 1;
	}
}

function get_url()
{
	return m_szURL;
}

/*************************END PROPERTY ACCESS FUNCTIONS********************************/

/*************************BEGIN EVENT HANDLER FUNCTIONS********************************/


function expandGroup(objElement)
{
	var objTR = objElement.parentElement;
	var objTBODY = objTR.parentElement;
	var objIMGColl = objElement.all.tags("IMG");
	if(objIMGColl != null)
	{
		var objIMG = objIMGColl(0);
		var szTempStr = objIMG.src;
		objIMG.src = objIMG.altsrc;
		objIMG.altsrc = szTempStr;
	}
	objNextTR = objTBODY.rows(objTR.rowIndex + 1);
	objNextTR.style.display = ( objNextTR.style.display=="")?"none":"";
	if (objNextTR.style.display == "")
	{
		if(objNextTR.firstChild.isCached != true) 
		{
			m_objParentTR = objTR;
			mf_getNodeData(objNextTR.firstChild,objElement);
		}
		objTR.isExpanded = true;
	}
	else
	{
		objTR.isExpanded = false;
	}
}

function onselectstart()
{
	if("ignoreEvent" == event.returnValue)
	{
		return;
	}
	event.cancelBubble = true;
	event.returnValue = false;
}

function ondocumentready()
{
	m_objXMLRequestQueue = new Array();
	m_bDocumentReady = true;
	this.tabIndex=0;
	this.hideFocus = true;
	//Get the xsl file - async op
	mf_loadXSL();
	//Get the view descriptor - async op
	mf_loadViewDescriptor();	
	//Async ops will synchronise in mf_initializeQueries.  mf_initializeQueries will
	//query the web store	
	m_bFireOnReady = true;
	if(null == m_fSelectionType) this.selectionType = 2;
}

function onArrowKeyPress(iDirection)
{
	if(RIGHT == iDirection || LEFT == iDirection)
	{
		if (null != m_objRowLastSelected && "true" == m_objRowLastSelected.isGroupHeader)
		{
			if(null == m_objRowLastSelected.isExpanded)
			{
				m_objRowLastSelected.isExpanded = false;
			}
			if(m_objRowLastSelected.isExpanded == (LEFT == iDirection))
			{
				expandGroup(m_objRowLastSelected.firstChild);
				return;
			}
		}
		iDirection = (RIGHT == iDirection) ? DOWN : UP;
	}
	var objNextRow = mf_getNextRow(m_objRowLastSelected,iDirection);
	if(!event.shiftKey || 1 == m_fSelectionType)
	{
		m_objRowRange = null;
		if (objNextRow != false)
		{
			mf_unselectAll();
			mf_selectRecord(objNextRow, true);
			mf_scrollIntoView(objNextRow);
			m_objRowLastSelected = objNextRow;
			switch(m_fArrowKeyNavigation)
			{
				case 1:		mf_navigateToRow(objNextRow,this.targetSingleClick,this.linkSpecSingleClick); break;
				case 2:		mf_navigateToRow(objNextRow,this.target,this.linkSpec); break;
				default:	break;
			}
		}
	}
	else
	{
		if (m_objRowRange == null)
		{
			m_objRowLastSelected.id = "rowSelectedException";
			mf_unselectAll();
			m_objRowLastSelected.id = "selected";
			if(objNextRow)
			{
				m_objRowRange = new RowRange(m_objRowLastSelected, objNextRow);
			}
			mf_scrollIntoView(objNextRow);
		}
		else if(objNextRow)
		{
			m_objRowRange.endRow = objNextRow;
			m_objRowRange.update();
			m_objRowLastSelected = objNextRow;
			mf_scrollIntoView(objNextRow);
		}
	}
}

function onEnterKeyPress()
{
	var i,objAnchors,f_isGroupOp = false, objRow = m_objRowLastSelected;
	
	if(null != m_objRowLastSelected && "true" == m_objRowLastSelected.isGroupHeader && m_objRowLastSelected.id == "selected")
	{
		f_isGroupOp = true;
	}
	objAnchors = this.all("selected");
	if (objAnchors != null && typeof(objAnchors) == "object" && !f_isGroupOp)
	{
		if (objAnchors.length)
		{
			var e = new Enumerator( objAnchors );
			for (;!e.atEnd();e.moveNext())
			{
				objRow = e.item();
				if(f_isGroupOp = (objRow.isGroupHeader == "true"))
				{
					break;
				}
			}
		}
		else
		{
			objRow = objAnchors;
			f_isGroupOp = (objRow.isGroupHeader == "true");
		}
	}
	if(f_isGroupOp)
	{
		mf_toggleSelectedGroups(!objRow.isExpanded);
	}
	switch(m_fEnterKeyNavigation)
	{
		case 1:		f_openItems(this.targetSingleClick,this.linkSpecSingleClick); break;
		case 2:		f_openItems(this.target,this.linkSpec); break;
		default:	break;
	}
}

function onkeydown()
{
	if("ignoreEvent" == event.returnValue) return;
	var f_isMinus=null;
	switch(event.keyCode)
	{
		
		case LEFT:
		case UP:
		case RIGHT:
		case DOWN:
			onArrowKeyPress(event.keyCode);
			event.cancelBubble = true;
			event.returnValue = false;
			break;
		case 107: //plus
					f_isMinus = false;
		case 109: //minus
			f_isMinus = (null == f_isMinus) ? true : f_isMinus;
			if(null != m_objRowLastSelected && "true" === m_objRowLastSelected.isGroupHeader && f_isMinus == m_objRowLastSelected.isExpanded)
			{
				expandGroup(m_objRowLastSelected.firstChild);
			}
			event.cancelBubble = true;
			event.returnValue = false;
			break;
		case 13: //enter
			onEnterKeyPress();
			event.cancelBubble = true;
			event.returnValue = false;
			break;
		case 46://delete
			f_deleteItems();
			event.cancelBubble = true;
			event.returnValue = false;
			break;
		 case 9: // tab
			m_bTabKeyPressed = true;
			break;
	}
}

function onclick()
{
	var obj = event.returnValue;
	if(null == obj || "ignoreEvent" == event.returnValue) return;
	switch(obj.tagName)
	{
		case "TD":
			if(obj.ischeckbox == "true")
			{
				mf_toggleCheckBox(obj);  // checkbox cell was clicked
			}
			else if(obj.id == "tdColumn" && obj.sortable == 1)
			{
				mf_changeSortOrder(obj, event.shiftKey);
			}
			break;
		case "TR":
			if(null != this.targetSingleClick && "" != this.targetSingleClick)
			{
				mf_navigateToRow(obj,this.targetSingleClick,this.linkSpecSingleClick);
			}
			break;
		default: break;
	}
	event.cancelBubble = true;
	event.returnValue = false;
}

function ondblclick()
{
	var obj = event.returnValue;
	if(null == obj || "ignoreEvent" == event.returnValue) return;
	if("TR" == obj.tagName && null != this.target)
	{
		event.cancelBubble = true;
		event.returnValue = false;
		mf_navigateToRow(obj,this.target,this.linkSpec);
	}
	else if ("groupHeaderText" == obj.id)
	{
		event.cancelBubble = true;
		event.returnValue = false;
		expandGroup(obj);
	}
}

function onmousedown()
{
	var obj = null;
	switch(event.srcElement.id)
	{
		case "tableTD":
		case "groupHeaderSpan":
		case "groupHeaderText":
		case "groupContentCell":		obj = event.srcElement; break;
		case "checkImage":
		case "groupHeaderActivator":	obj = event.srcElement.parentElement; break;
	}
	if(null != obj)
	{
		obj.attachEvent("onfocus",onfocus);
		obj.attachEvent("onblur",onblur);
	}
	obj = event.returnValue;
	if(null == obj || "ignoreEvent" == event.returnValue) return;
	if("groupHeaderActivator" == obj.id)
	{
		expandGroup(obj.parentElement);
		var objRow = obj.parentElement.parentElement;
		mf_unselectAll();
		mf_selectRecord(objRow, false);
		mf_scrollIntoView(objRow);
		m_objRowLastSelected = objRow;
		event.cancelBubble = true;
		event.returnValue = false;
		return;
	}
	var objContentRow = obj;
	if(event.ctrlKey && 2 == m_fSelectionType)
	{
		m_objRowRange = null;
		if (objContentRow.id == "selected")
		{
			mf_unselectRecord(objContentRow,true);
		}
		else if (mf_selectRecord(objContentRow, true))
		{
			m_objRowLastSelected = objContentRow;
		}
	}
	else if(event.shiftKey && 2 == m_fSelectionType)
	{
		if (m_objRowRange == null)
		{
			if (m_objRowLastSelected != null)
			{
				mf_unselectAll();
				m_objRowRange = new RowRange(m_objRowLastSelected, objContentRow)
			}
			else
			{
				m_objRowRange = new RowRange(objContentRow, objContentRow)
			}
		}
		else
		{
			m_objRowRange.endRow = objContentRow;
			m_objRowRange.update();
			m_objRowLastSelected = objContentRow;
		}
	}
	else
	{
		m_objRowRange = null;
		mf_unselectAll();
		mf_selectRecord(objContentRow,true);
	}
}

function ondragstart()
{
	if(false == this.allowDragAndDrop || "false" == this.allowDragAndDrop || "ignoreEvent" == event.returnValue)
	{
		event.cancelBubble = true;
		event.returnValue = false;
		return;
	}
	var dataString = f_getItems();
	if(dataString.length > 0)
	{
		window.event.dataTransfer.effectAllowed = "all";
		window.event.dataTransfer.setData("Text", dataString);
	}
}

function ongetxmlcomplete(queueIndex)
{
	var queueEntry = m_objXMLRequestQueue[queueIndex];
	if (null != queueEntry)
	{
		m_objMSHTTP_Request = queueEntry.XMLHTTPRequest;
		if (m_objMSHTTP_Request != null && m_objMSHTTP_Request.readyState == 4)
		{
			m_objHTMLTarget = m_objXMLRequestQueue[queueIndex].target;
			m_objXSLNodes = m_objXMLRequestQueue[queueIndex].XSLNodes;
			m_icurGrpLevel = m_objXMLRequestQueue[queueIndex].level;
			m_objParentTR = m_objXMLRequestQueue[queueIndex].parentTR;
			m_gCallBack = m_objXMLRequestQueue[queueIndex].callback;
			// delete this item from the queue
			delete(m_objXMLRequestQueue[queueIndex]);
			// delete the ready state function
			delete(m_objMSHTTP_Request.onreadystatechange);
			m_objXML =  m_objMSHTTP_Request.responseXML;
			m_objHTMLTarget.isCached = true;
			m_objHTMLTarget.isOutermostTarget = (m_objHTMLTarget.tagName == "TD") ? false : true;
			var szContentRange = m_objMSHTTP_Request.getResponseHeader("content-range");
			var iStatus = m_objMSHTTP_Request.status;
			var szStatusText = m_objMSHTTP_Request.statusText;
			m_objMSHTTP_Request = null;
			if (mf_checkStatus(iStatus))
			{
				if(m_objHTMLTarget.isOutermostTarget)
				{
					mf_updatePageInfo(szContentRange);
				}
				try
				{
					m_gCallBack(iStatus);
					this.viewReadyState = "complete";
				}
				catch(e)
				{
					m_gCallBack = null;
				}
			}
			else
			{
				mf_fireOnError(iStatus,szStatusText,m_objXML,"");
			}
		}
	}
}


function onfocus()
{
	if(true == m_bViewHasFocus || 0 == m_fSelectionType) return;
	m_bViewHasFocus = true;		// we now have focus
	mf_changeSelectedRowsStyle(m_szHighlightRowStyle);
	if(null == this.all("selected"))
	{
		objColl = this.all("unSelected");
		if(null != objColl)
		{
			// highlight the first row without navigating!
			(null != objColl.length) ? mf_selectRecord(objColl(0),true) : mf_selectRecord(objColl,true);
		}
		else if (null != (objColl = this.all("groupHeaderRow")))
		{
			(null != objColl.length) ? mf_selectRecord(objColl(0),true) : mf_selectRecord(objColl,true);
		}
	}
	else if(null != m_objRowLastSelected)
	{
		mf_scrollIntoView(m_objRowLastSelected);
	}
}

function onblur()
{
	if(m_fSelectionType == 0) return;
	if(!element.contains(element.document.elementFromPoint( event.clientX, event.clientY )) || m_bTabKeyPressed)
	{
		m_bViewHasFocus = false;
		m_bTabKeyPressed = false;
		mf_changeSelectedRowsStyle(m_szShadowRowStyle);
	}
}

function createSelectSQL(objColProps, iChildNumber)
{
	var szSQL = "";
	var PropNum = ((null != iChildNumber) ? iChildNumber : 1) ;
	objColProps.reset();
	for(var obj = objColProps.nextNode(); null != obj; obj = objColProps.nextNode() )
	{
		if( 0 == obj.text.length)
		{
			continue;
		}
		szSQL += ' "' + obj.text + '" as prop' + PropNum + ",";
		PropNum++;
	}
	return szSQL;
}

function createNamedSelectSQL(objColumns)
{
	var szSQL = "";
	var szHeading = "";
	var objProp, objHeading;
	for (i = 0; i < objColumns.length; i++)
	{
		objProp		= objColumns(i).selectSingleNode("prop");
		objHeading	= objColumns(i).selectSingleNode("heading");
		if(null != objProp && null != objHeading && "" != objProp.text && "" != objHeading.text)
		{
			szHeading = objHeading.text.replace(/ /g,"_");
			szHeading = szHeading.replace(/"/g,'""');
			szSQL += ' "' + objProp.text + '" as ' + '"' + szHeading + '",';
		}
	}
	// remember to remove last comma
	return(szSQL.substring(0,szSQL.length-1));
}

function createOrderByString(objOrderNode)
{
	var objProp = objOrderNode.selectSingleNode("prop");
	var objSort = objOrderNode.selectSingleNode("sort");
	var szProp = objProp.text, szSQLFragment = "";
	if (m_rgszPropertySynonyms[szProp] != null)
	{
		szSQLFragment = '"' + m_rgszPropertySynonyms[szProp] + '" ';
	}
	else
	{
		szSQLFragment = '"' +  szProp + '" ';
	}
	if(null == objSort)
	{
		objSort = objOrderNode.ownerDocument.createNode("1","sort","");
		objOrderNode.appendChild(objSort);
		var objType = objOrderNode.selectSingleNode("type");
		objSort.text = (null != objType && objType.text.substr(0,4).toUpperCase() == "DATE") ? 'DESC' : 'ASC';
	}
	return szSQLFragment + objSort.text;
}


function createOrderBySQL(objOrderNodes)
{
	var szSQLFragment = "";
	if (null != objOrderNodes)
	{
		if (null != objOrderNodes.length)
		{
			var obj = objOrderNodes.nextNode();
			if( null != obj )
			{
				szSQLFragment = createOrderByString( obj );
			}
			while( null != (obj = objOrderNodes.nextNode()) )
			{
				szSQLFragment += ',' + createOrderByString(obj);
			}
		}
		else
		{
			szSQLFragment = createOrderByString(objOrderNodes);
		}
	}
	return(szSQLFragment);
}

function createViewXML(objViewXML, objTransFormXSL)
{
	var objXML = new ActiveXObject("Microsoft.xmldom");
	objViewXML.transformNodeToObject(objTransFormXSL.documentElement, objXML);
	if(objXML.parseError.errorCode != 0)
	{
		mf_handleParseError(objXML.parseError);
	}
	if(objTransFormXSL.parseError.errorCode != 0)
	{
		mf_handleParseError(objTransFormXSL.parseError);
	}
	if(objXML.parseError.errorCode != 0)
	{
		mf_handleParseError(objXML.parseError);
	}
	return(objXML);
}

function ondeleterequest()
{
	if(m_objMSHTTP_Request != null && m_objMSHTTP_Request.readyState == 4)
	{
		var szStatus = m_objMSHTTP_Request.status;
		var szStatusText = m_objMSHTTP_Request.statusText;
		var responseXML = m_objMSHTTP_Request.responseXML;
		
		m_objMSHTTP_Request = null
		switch(szStatus)
		{
			case 207:
				var nodeStatus = responseXML.selectSingleNode("a:multistatus/a:response[a:status $ge$ 'HTTP/1.1 4']");
				if (nodeStatus != null)
				{
					mf_fireOnError(szStatus, szStatusText,  responseXML, ondeleterequest.szCommand);
				}
			case 200:
			case 201:
			case 204:
				break;
			default:
				mf_fireOnError(szStatus, szStatusText,  responseXML, ondeleterequest.szCommand);
		}
		this.refresh();
	}
}
//Function property
ondeleterequest.szCommand;

/*************************END EVENT HANDLER FUNCTIONS********************************/

/*************************BEGIN PUBLIC METHOD FUNCTIONS********************************/
function mf_update()
{
	m_objHTMLTarget = this;
	//Reset subsequent gates 
	mf_initializeQueries.viewDescriptorReadyState = "";
	mf_initializeQueries.viewClassReadyState      = "";
	
	//Get the xsl file - async op
	mf_loadXSL();
	
	//Get the view descriptor - async op
	mf_loadViewDescriptor();	

	//Async ops will synchronize in mf_initializeQueries.  mf_initializeQueries will 
	//query the web store.
}


function mf_createAnchorXML(objAnchor, objItemNode, objRootNode)
{
	var objItemCloneNode = objItemNode.cloneNode(true);
	var node = objItemCloneNode.selectSingleNode("a:content-class");
	node.text = objAnchor.messageClass;
	node = objItemCloneNode.selectSingleNode("a:href");
	node.text = objAnchor._href;
	objRootNode.appendChild(objItemCloneNode);
}

function f_getItems()
{
	var szDataString="";
	var m_bstrXML = '<selections xmlns:a="DAV:">\n' +
					'	<item>\n' +
					'		<a:content-class></a:content-class>\n' +
					'		<a:href></a:href>\n' +
					'	</item>\n' +
					'</selections>';

	var objXML = new ActiveXObject("Microsoft.xmldom");
	objXML.loadXML(m_bstrXML);
	var objRootNode = objXML.documentElement;
	var objItemNode = objRootNode.selectSingleNode("item");
	var bSelectionWithChecks = true;
	var objSelectedItems = this.all("checkInput");
	if(null == objSelectedItems || 0 == objSelectedItems.length)
	{
		objSelectedItems = this.all("selected");
		bSelectionWithChecks = false;
	}
	
	if (null != objSelectedItems)
	{
		if (objSelectedItems.length != null)
		{
			var e = new Enumerator( objSelectedItems );
			for (;!e.atEnd();e.moveNext())
			{
				obj = e.item();
				// Add this row ONLY IF the row is NOT a group header and:
				// 
				// We are not using check boxes for selecting OR
				// We ARE using checkboxes AND this row is checked.
				if(!("true" == obj.isGroupHeader) && (!bSelectionWithChecks || (bSelectionWithChecks && obj.checked)))
				{
					mf_createAnchorXML(obj,objItemNode,objRootNode);
				}
			}
		}
		else  if (!("true" == objSelectedItems.isGroupHeader) && (!bSelectionWithChecks || (bSelectionWithChecks && objSelectedItems.checked)))
		{
			mf_createAnchorXML(objSelectedItems, objItemNode, objRootNode);
		}
		objRootNode.removeChild(objItemNode);
		szDataString = objRootNode.xml;
	}
	return szDataString;
}

function f_openItems(szTarget,szLinkSpec)
{
	var objSelectedRows = this.all("selected"),obj;
	if ( objSelectedRows == null )
	{
		return;
	}
	if(null == szTarget && null == szLinkSpec)
	{
		szTarget = this.target;
		szLinkSpec = this.linkSpec;
	}
	if(objSelectedRows.length != null)
	{
		var e = new Enumerator( objSelectedRows );
		for (;!e.atEnd();e.moveNext())
		{
			obj = e.item();
			if(!(obj.isGroupHeader == "true"))
			{
				mf_navigateToRow(obj,szTarget,szLinkSpec);
			}
		}
	}
	else
	{
		mf_navigateToRow(objSelectedRows,szTarget,szLinkSpec);
	}
}

function f_nextPage()
{
	var iPageNum = m_iCurrentPage + 1;
	if(iPageNum <= this.pageCount)
	{
		f_gotoPage(iPageNum);
	}
}

function f_previousPage()
{
	var iPageNum = m_iCurrentPage - 1;
	if(iPageNum > 0)
	{
		f_gotoPage(iPageNum);
	}
}

function f_gotoPage(varPage)
{
	var iTemp = (varPage - 1)* m_iCurrentRowsNumber;
	if (iTemp < m_imaxRows && iTemp >= 0)
	{
		m_iCurrentStartRange = iTemp;
		iEndRange  = m_iCurrentStartRange + m_iCurrentRowsNumber - 1;
		m_gCallBack = mf_fireOnPageRefresh;
		m_objHTMLTarget = this;
		m_icurGrpLevel = 1;
		m_objRowRange = null;
		m_objRowLastSelected = null;
		szSearchXML = m_objQueries[0].getXMLSearchRequest();
		mf_getXML( m_szURL,  szSearchXML, m_iCurrentStartRange, iEndRange );
	}
}
function f_deleteItems(szDeletedItemsURL)
{
	var szSelectedItems = f_getItems();
	if(!mf_fireOnBeforeDelete(szSelectedItems))
	{
		return (false);
	}
	m_objRowRange = null;
	var szOpenURL = m_szURL;
	var szCommand, szXMLCommand, szXMLBatchString = "",objURLSplit,objXML;
	
	if(null == m_objMSHTTP_Request)
	{
		m_objMSHTTP_Request = new ActiveXObject("Microsoft.XMLHTTP");
	}
	if(null != szDeletedItemsURL && "" != szDeletedItemsURL)
	{
		szCommmand = "BMOVE";
		szXMLCommand = "move";
	}
	else
	{
		szCommand = "BDELETE";
		szXMLCommand = "delete";
	}
	objXML = new ActiveXObject("Microsoft.xmldom");
	objXML.loadXML(szSelectedItems);
	objItems = objXML.selectNodes("//a:href");

	szXMLBatchString = "<?xml version='1.0'?><D:" + szXMLCommand + " xmlns:D='DAV:'><D:target>";
	for(var i = 0; i < objItems.length; i++)
	{
		objURLSplit = objItems(i).text.split("/");
		szXMLBatchString += "<D:href>" + objURLSplit[objURLSplit.length - 1] + "</D:href>";
	}
	szXMLBatchString += "</D:target></D:" + szXMLCommand + ">";
		
	szOpenURL = mf_addEndWhack(szOpenURL);
	m_objMSHTTP_Request.open(szCommand, szOpenURL, true);
	m_objMSHTTP_Request.setRequestHeader("Content-type", "text/xml");
	m_objMSHTTP_Request.setRequestHeader("Translate", "f");
	if (szCommand != "BDELETE")
	{
		m_objMSHTTP_Request.setRequestHeader("Allow-rename", "t");
		m_objMSHTTP_Request.setRequestHeader("Overwrite", "f");
		m_objMSHTTP_Request.setRequestHeader("Destination", szDeletedItemsURL);
	}
	m_objMSHTTP_Request.onreadystatechange = ondeleterequest;
	ondeleterequest.szCommand = szCommand;
	m_objMSHTTP_Request.send(szXMLBatchString);
	return(true);
}	

function f_refresh(f_isSoftRefresh)
{
	if(null == f_isSoftRefresh || false == f_isSoftRefresh)
	{
		mf_update();
		return;
	}
	szSearchXML = m_objQueries[0].getXMLSearchRequest();
	m_objHTMLTarget = this;
	m_icurGrpLevel  = 1;
	m_gCallBack = mf_fireOnPageRefresh;
	m_objRowRange = null;
	m_objRowLastSelected = null;
	m_objAnchorsSelected = null;
	mf_getXML( m_szURL,  szSearchXML, m_iCurrentStartRange, m_iCurrentStartRange + m_iCurrentRowsNumber -1);
}
/*************************END PUBLIC METHOD FUNCTIONS********************************/
/*************************BEGIN PRIVATE FUNCTIONS********************************/

function mf_setAttributes()
{
	if (m_szURL == null || m_szURL == "")
	{
		m_szURL = window.location.protocol + "//" +  window.location.host + window.location.pathname;
	}
	m_iCurrentPage				= parseInt(mf_chooseValue(m_objViewDescription.selectSingleNode("view/page"),this.page,"1"),10);
	this.target					= mf_chooseValue(m_objViewDescription.selectSingleNode("view/target"),this.target,null);
	this.linkSpec				= mf_chooseValue(m_objViewDescription.selectSingleNode("view/linkSpec"),this.linkSpec,"%dataurl%?cmd=open");
	this.targetSingleClick		= mf_chooseValue(m_objViewDescription.selectSingleNode("view/targetSingleClick"),this.targetSingleClick,null);
	this.linkSpecSingleClick	= mf_chooseValue(m_objViewDescription.selectSingleNode("view/linkSpecSingleClick"),this.linkSpecSingleClick,"%dataurl%?cmd=open");
	this.rowsPerPage			= mf_chooseValue(m_objViewDescription.selectSingleNode("view/rowsPerPage"),this.rowsPerPage,"0");
	this.searchSubfolders		= mf_chooseValue(m_objViewDescription.selectSingleNode("view/searchSubfolders"),this.searchSubFolders,"");
	this.boldUnreadItems		= mf_chooseValue(m_objViewDescription.selectSingleNode("view/boldUnreadItems"),this.boldUnreadItems,"true");
	m_szHighlightRowStyle		= mf_chooseValue(m_objViewDescription.selectSingleNode("view/highlightrowstyle"),null,"background-color:HIGHLIGHT;color:HIGHLIGHTTEXT");
	m_szShadowRowStyle			= mf_chooseValue(m_objViewDescription.selectSingleNode("view/shadowrowstyle"),null,"background-color:THREEDFACE");
}

function mf_initializeQueries()
{
	if("complete" == mf_initializeQueries.viewDescriptorReadyState && "complete" == mf_initializeQueries.viewClassReadyState)
	{
		mf_setAttributes();
		mf_alterViewDescriptor();
		m_objQueries = new QueryCollection(m_objViewDescription);
		m_objViewXML = createViewXML(m_objViewDescription,m_objTransFormXSL);
		//********** Bail out if view descriptor is null *****
		if(null == m_objViewXML) return;
		
		if(0 == m_objViewXML.parseError.errorCode)
		{
			m_objXSLNodes = m_objViewXML.selectNodes("view/group/xsl:template");
			m_objDefaultXSLNodes = m_objXSLNodes;
			m_icurGrpLevel = 1;
			m_objRowRange = null;
			m_objRowLastSelected = null;
			var iPage = (m_iCurrentPage < 1) ? 1 : m_iCurrentPage;
			m_iCurrentStartRange = (iPage - 1)* m_iCurrentRowsNumber;
			iEndRange = m_iCurrentStartRange + m_iCurrentRowsNumber - 1;
			szSearchXML = m_objQueries[0].getXMLSearchRequest();
			m_gCallBack = mf_fireOnPageRefresh;
			mf_getXML(m_szURL, szSearchXML,m_iCurrentStartRange, iEndRange);
			//Reset gate
			mf_initializeQueries.viewDescriptorReadyState = "";
			mf_initializeQueries.viewClassReadyState      = "";
		}
		else
		{
			mf_handleParseError(m_objViewXML.parseError);
		}
	}
}
mf_initializeQueries.viewDescriptorReadyState = "";
mf_initializeQueries.viewClassReadyState      = "";

function mf_scrollIntoView(objRow)
{
	var objFocalPoint = null;
	if(null == objRow) return;
	if("TD" == objRow.firstChild.tagName)
	{
		objFocalPoint = objRow.firstChild;
	}
	else
	{
		var objFocalPoint = objRow.firstChild.firstChild.children(0);
		while(null != objFocalPoint && ("none" == objFocalPoint.style.display || "hidden" == objFocalPoint.style.visibility))
		{
			objFocalPoint = objFocalPoint.nextSibling;
		}	
	}
	if(null != objFocalPoint)
	{
		objFocalPoint.attachEvent("onfocus",onfocus);
		objFocalPoint.attachEvent("onblur",onblur);
		objFocalPoint.focus();
	}
}

function mf_getNodeData(objDest,objElement)
{
	m_icurGrpLevel = parseInt(objElement.groupLevel,10) + 1;
	objDest.groupLevel = m_icurGrpLevel;
	if(m_icurGrpLevel > 2)
	{
		var objParentGroup = objElement.parentGroup
		if (objParentGroup == null)
		{
			objParentGroup = objElement.parentElement.parentElement.parentElement.parentElement.parentGroup
			objElement.parentGroup = objParentGroup;
		}
		//get previous group criteria
		var objQueryObject = m_objQueries[m_icurGrpLevel -1];
		var objTemp = objElement;
		objQueryObject.restriction = "";
		var icount = 0;
		while (objTemp != null)
		{
			if(icount > 0)
			{
				objQueryObject.restriction += ' AND '
			}
			objQueryObject.restriction += mf_formatRestriction(objTemp.propValue, objTemp.dataType, objTemp.propName)
			objTemp = objTemp.parentGroup;
			icount ++;
		}
		objDest.parentGroup = objElement;
	}
	else
	{
		var objQueryObject = m_objQueries[m_icurGrpLevel - 1]
		objQueryObject.restriction = mf_formatRestriction(objElement.propValue, objElement.dataType, objElement.propName);
		objElement.parentGroup = null;
		objDest.parentGroup = objElement
	}
	objDest.restriction = objQueryObject.restriction;
	szRequestXML = objQueryObject.getXMLSearchRequest();
	m_objHTMLTarget = objDest;
	m_gCallBack = mf_renderHTML;
	mf_getXML(m_szURL,  szRequestXML);

}

function mf_formatRestriction(szPropValue,  szDataType, szPropName)
{
	var szRestriction = "";
	switch(szDataType)
	{
		case "string":
			if (szPropValue != null)
			{
				var re = /'/g;
				szPropValue = szPropValue.replace(re, "''") //Escape single quotes
				szRestriction = '"' + szPropName + '" = ' + '\'' + szPropValue + '\'';
			}
			else
			{
				szRestriction = '"' + szPropName + '" IS NULL ';
			}
			break;
		case "boolean":
			szRestriction = '"' + szPropName + '" = ' + (szPropValue == "1");
			break;
		default:
			szRestriction = '"' + szPropName + '" = ' + 'CAST("' + szPropValue + '" AS "' + szDataType   + '")';
			break;
	}
	return(szRestriction)
}

function mf_addEndWhack(szURL)
{
	if(szURL.charAt(szURL.length - 1) != "/")
	{
		return(szURL + "/");
	}
	else
	{
		return(szURL);
	}
}

function mf_unselectAll()
{
	var objTemp
	var objRow;
	
	m_objAnchorsSelected = this.all("selected");
	if (m_objAnchorsSelected)
	{
		if (m_objAnchorsSelected.length != null)
		{
			var e = new Enumerator( m_objAnchorsSelected );
			for (;!e.atEnd();e.moveNext())
			{
				mf_unselectRecord(e.item())
			}
		}
		else
		{
			mf_unselectRecord(m_objAnchorsSelected);
		}
		
	}
}

function mf_changeSortOrder(objCol, fAppend)
{
	var szsortDir = ""
	var i, szProp;
	var objOrderByNode = null;
	var objViewDescriptor,objQueries;
		
	m_objHTMLTarget = objCol.parentElement.parentElement.parentElement.parentElement;
	m_objParentTR = (m_objHTMLTarget.isOutermostTarget ? null : m_objHTMLTarget.parentElement);
	if(null != m_objParentTR)
	{
		m_objParentTR = m_objParentTR.previousSibling;
	}
	if(null == m_objHTMLTarget.cachedViewDescriptor)
	{
		if(m_objHTMLTarget.isOutermostTarget)
		{
			m_objHTMLTarget.cachedViewDescriptor = m_objViewDescription;
		}
		else
		{
			m_objHTMLTarget.cachedViewDescriptor = m_objViewDescription.cloneNode(true);
		}
	}
	objViewDescriptor = m_objHTMLTarget.cachedViewDescriptor;
	
	if(null != objCol.dataType && objCol.dataType.substr(0,4).toUpperCase() == "DATE")
	{
		//If the data type is date then Default is DESC
		szsortDir = (objCol.sortdir == "DESC")?"ASC":"DESC";
	}
	else
	{
		szsortDir = (objCol.sortdir == "ASC")?"DESC":"ASC";
	}
	var objOrderNodes = objViewDescriptor.selectNodes("view/orderby/order");
	objOrderByNode = objViewDescriptor.selectSingleNode("view/orderby");
	//If no order nodes exist then we'll have to create it from scratch
	if (objOrderByNode == null)
	{
		objOrderByNode = objViewDescriptor.createElement("orderby");
		objOrderByNode = objViewDescriptor.documentElement.appendChild(objOrderByNode);
	}
	szProp = objCol.prop;
		
	var objNode,objPropNode,objSortNode;
	var fFound = false;
	for (i=0;i < objOrderNodes.length ; i++ )
	{
		objNode = objOrderNodes.item(i) 
		objPropNode = objNode.selectSingleNode("prop")
		if (objPropNode.text == szProp)
		{
			objSortNode = objNode.selectSingleNode("sort");
			if(null == objSortNode)
			{
				objSortNode = objViewDescriptor.createElement("sort");
				objNode.appendChild(objSortNode);
				objSortNode.text = (objCol.dataType.substr(0,4).toUpperCase() == "DATE") ? "ASC" : "DESC";
			}
			else
			{
				objSortNode.text = szsortDir;
			}
			fFound = true;
		}
		else if(fAppend == false)
		{
			objOrderByNode.removeChild(objNode);
		}
	}
	
	if (fFound == false)
	{
		//Create node and append
		var objNewOrderNode = objViewDescriptor.createElement("order");
		var objNewPropNode  = objViewDescriptor.createElement("prop");
		var objNewSortNode  = objViewDescriptor.createElement("sort");
		objNewOrderNode = objOrderByNode.appendChild(objNewOrderNode)
		objNewPropNode = objNewOrderNode.appendChild(objNewPropNode);
		objNewSortNode = objNewOrderNode.appendChild(objNewSortNode);
		objNewPropNode.text = szProp;
		objNewSortNode.text = szsortDir;
	}
		
	var objViewXML = createViewXML(objViewDescriptor,m_objTransFormXSL);
	if(null != objViewXML)
	{
		if(0 == objViewXML.parseError.errorCode)
		{
			//Check for parse errors in the result.
			m_objXSLNodes = objViewXML.selectNodes("view/group/xsl:template");
			objQueries = new QueryCollection(objViewDescriptor);
			if(m_objHTMLTarget.isOutermostTarget) 
			{
				m_objDefaultXSLNodes = m_objXSLNodes;
				m_objQueries = objQueries;
				m_iCurrentStartRange = 0;
				iEndRange  = m_iCurrentStartRange + m_iCurrentRowsNumber - 1;
			}
			else
			{
				m_iCurrentStartRange = null;
				iEndRange = null;
			}
			if(null != m_objRowLastSelected)
			{
				var objTable = m_objRowLastSelected.parentElement.parentElement;
				if(null != objTable && m_objHTMLTarget.firstChild == objTable)
				{
					m_objRowRange = null;
					m_objRowLastSelected = null;
				}
			}
			if(null != m_objHTMLTarget && null != m_objHTMLTarget.groupLevel)
			{
				m_icurGrpLevel = m_objHTMLTarget.groupLevel;
			}
			objQueries[m_icurGrpLevel - 1].restriction = m_objHTMLTarget.restriction;
			szSearchXML = objQueries[m_icurGrpLevel - 1].getXMLSearchRequest();
			m_gCallBack = mf_fireOnPageRefresh;
			mf_getXML(m_szURL, szSearchXML,m_iCurrentStartRange, iEndRange);
		}
		else
		{
			mf_handleParseError(m_objViewXML.parseError);
		}
	}		
}

function mf_changeCheckbox(objInputTags,bChecked)
{
	if(null != objInputTags)
	{
		// if this checkbox is hidden (<visible>0</visible>) then we need to update it manually
		// each time a row is selected / unselected
		if(objInputTags.length > 0 && "NONE" == objInputTags(0).parentElement.style.display)
		{
			objInputTags(0).checked = bChecked;
		}
		else if(null == objInputTags.length && "NONE" == objInputTags.parentElement.style.display)
		{
			objInputTags.checked = bChecked;
		}
	}
}
function mf_unselectRecord(objRecord, fFireEvent)
{
	var retval = false;
	if(objRecord != null)
	{
		objRecord.id =  "unSelected"
		mf_changeCheckbox(objRecord.all("checkInput"),false);
		objRecord.runtimeStyle.cssText = objRecord.oldStyle;
		if(fFireEvent)
		{
			mf_fireOnSelectionChange(objRecord,false);
		}
		retval = true;
	}
	return(retval);
}


function mf_selectRecord(objRecord, fFireEvent)
{
	if (objRecord)
	{
		if (objRecord.id != "selected")
		{
			m_objRowLastSelected = objRecord;
			objRecord.id =  "selected";
			mf_changeCheckbox(objRecord.all("checkInput"),true);
			objRecord.oldStyle = objRecord.runtimeStyle.cssText;
			objRecord.runtimeStyle.cssText = m_szHighlightRowStyle;
			if(fFireEvent)
			{
				mf_fireOnSelectionChange(objRecord,true);
			}
		}
		return true;
	}
	return false;
}

function mf_loadXSL()
{
	if(null == this.viewClass)
	{
		this.viewClass = "/exchweb/views/wfview.xsl";
	}

	m_objXSLRequest = new ActiveXObject("Microsoft.XMLHTTP");
	m_objXSLRequest.open("GET", this.viewClass, true);
	if(null != this.acceptLang && "" != this.acceptLang)
	{
		m_objXSLRequest.setRequestHeader("Accept-Language",this.acceptLang);
	}
	m_objXSLRequest.onreadystatechange = mf_onGetViewClass;
	m_objXSLRequest.send();
}

function mf_onGetViewClass()
{
	if(null != m_objXSLRequest && 4 == m_objXSLRequest.readyState)
	{
		m_objTransFormXSL = m_objXSLRequest.responseXML;
		m_objXSLRequest = null;	

		//Set state and call function
		mf_initializeQueries.viewClassReadyState = "complete";
		mf_initializeQueries();
	}

}

function mf_changeOrderByXML(szOrderText,fPrepend)
{
	var objOrderByNode = m_objViewDescription.selectSingleNode("view/orderby");
	if(null == objOrderByNode)
	{
		var objViewNode = m_objViewDescription.selectSingleNode("view");
		objOrderByNode  = m_objViewDescription.createNode("1","orderby","");
		objViewNode.appendChild(objOrderByNode);
	}	
	var objOrderNodes  = objOrderByNode.selectNodes("order");	
	if(!fPrepend && null != objOrderNodes)
	{
		for(i=0; i < objOrderNodes.length; i++)
		{
			objOrderByNode.removeChild(objOrderNodes.item(i));
		}		
	}
	var objNode,arrPropSort,arrSortStrings = szOrderText.split(",")
	var regExp=/\"([^\"]*)\"\s*(\w*)\s*/
	
	for(i=0; i<arrSortStrings.length; i++)
	{
		arrPropSort = regExp.exec(arrSortStrings[i]);
		var orderNode = m_objViewDescription.createNode("1","order","");
		var propNode  = m_objViewDescription.createNode("1","prop","");
		var sortNode  = m_objViewDescription.createNode("1","sort","");
		propNode.text = arrPropSort[1];
		sortNode.text = ("" == arrPropSort[2]) ? "ASC" : arrPropSort[2];
		orderNode.appendChild(propNode);
		orderNode.appendChild(sortNode);
		objOrderByNode.appendChild(orderNode);		
	}
}

function mf_setViewDescriptorNode(objViewNode,szNodeName,szNodeValue,fIsDefault)
{
	var objNode=objViewNode.selectSingleNode(szNodeName),fExistedAlready=true;
	if(null == objNode)
	{
		objNode = m_objViewDescription.createNode("1",szNodeName,"");
		objViewNode.appendChild(objNode);
		fExistedAlready = false;
	}
	objNode.text = (fIsDefault && fExistedAlready) ? objNode.text : szNodeValue;
}
function mf_alterViewDescriptor()
{
	var objViewNode = m_objViewDescription.selectSingleNode("view");
	if (objViewNode != null)
	{
		mf_setViewDescriptorNode(objViewNode,"imagepath","/exchweb/img/",true);
		mf_setViewDescriptorNode(objViewNode,"customimagepath","/exchweb/img/",true);
		mf_setViewDescriptorNode(objViewNode,"boldUnreadItems",this.boldUnreadItems);
		mf_setViewDescriptorNode(objViewNode,"viewcontainerid",(null == this.id) ? "" : this.id);
	}
	if(null != this.sort)
	{
		mf_changeOrderByXML(this.sort,false);
	}
	//Swap message class prop for the icon property
	var objCollMsgClass  = m_objViewDescription.selectNodes("view/column[bitmap = '1']/prop[.='http://schemas.microsoft.com/exchange/outlookmessageclass']");
	if(objCollMsgClass != null)
	{
		for(var x = 0; x < objCollMsgClass.length; x++)
		{
			objCollMsgClass.item(x).text = "http://schemas.microsoft.com/exchange/smallicon";
		}
	}
}

function mf_loadViewDescriptorFromURL(szXMLURL)
{

	m_objHTTPViewDescriptor = new ActiveXObject("Microsoft.XMLHTTP");
	m_objHTTPViewDescriptor.open("GET", szXMLURL,true);
	if(null != this.acceptLang && "" != this.acceptLang)
	{
		m_objHTTPViewDescriptor.setRequestHeader("Accept-Language",this.acceptLang);
	}
	m_objHTTPViewDescriptor.onreadystatechange = mf_onGetViewDescriptor;	
	m_objHTTPViewDescriptor.send();
}

function mf_onGetViewDescriptor()
{
	var iStatus;
	if(null != m_objHTTPViewDescriptor && m_objHTTPViewDescriptor.readyState == 4)
	{
		iStatus = m_objHTTPViewDescriptor.status;
		if(200 == iStatus)
		{
			if(null != m_objHTTPViewDescriptor.responseXML && "" != m_objHTTPViewDescriptor.responseXML.xml)
			{
				m_objViewDescription = m_objHTTPViewDescriptor.responseXML;
			}
			else if("" != m_objHTTPViewDescriptor.responseText)
			{
				m_objViewDescription = new ActiveXObject("Microsoft.XMLDOM");
				m_objViewDescription.loadXML(m_objHTTPViewDescriptor.responseText);
			}
		}
		if(null == m_objViewDescription || null == m_objViewDescription.parseError)
		{
			alert(this.viewDescriptorURL + ":  " + m_objHTTPViewDescriptor.status + " " +  m_objHTTPViewDescriptor.statusText);
		}
		else if(0 == m_objViewDescription.parseError.errorCode)
		{
			mf_initializeQueries.viewDescriptorReadyState = "complete";
			mf_initializeQueries();
		}
		else
		{
			mf_handleParseError(m_objViewDescription.parseError);
		}
		m_objHTTPViewDescriptor = null;
	}
}
function mf_loadViewDescriptor()
{
	if(this.viewDescriptorURL)
	{
		mf_loadViewDescriptorFromURL(this.viewDescriptorURL);
	}
	else if(this.viewDescriptor)
	{
		//check to see if the string is an id to an xml data island
		var objXML = window.document.all(this.viewDescriptor);
		if(null == objXML && null != m_objViewDescription)
		{
			mf_initializeQueries.viewDescriptorReadyState = "complete";
			mf_initializeQueries();
		}
		else if(null != objXML && "XML" == objXML.tagName.toUpperCase())
		{
			if(objXML.documentElement != null)
			{
				m_objViewDescription = objXML;
			}
			else
			{
				objXML.loadXML(objXML.innerHTML)
				m_objViewDescription = objXML;
			}
			if(0 == m_objViewDescription.parseError.errorCode)
			{
				mf_initializeQueries.viewDescriptorReadyState = "complete";
				mf_initializeQueries();
			}
			else
			{
				mf_handleParseError(m_objViewDescription.parseError);
			}
		}
	}
}

function mf_unboldRow(objRow)
{
	var retval =false;
	if (objRow != null)
	{
		objRow.style.fontWeight = "normal"
		retval = true
	}
	return(retval)
}

function mf_fireOnPageRefresh(iStatus)
{
	mf_renderHTML();
	mf_fireOnRefresh();
}

function mf_handleParseError(objParseError)
{
	var szParseError  = " Error code: " +  objParseError.errorCode + "\n";
		szParseError += " Line: " +  objParseError.line + "\n";
		szParseError += " Line Position: " +  objParseError.linepos + "\n";
		szParseError += " Reason: " +  objParseError.reason + "\n";
		szParseError += " Source: " +  objParseError.srcText + "\n";
		//Clear out the client area
		this.innerHTML = "";
		//Display parse error info
		this.innerText = szParseError;
}
function mf_updatePageInfo(szRangeHeader)
{
	if (null == szRangeHeader || "" == szRangeHeader)
	{
		m_iCurrentPage = 0;
		this.pageCount = 0;
		this.itemCount = 0;
	}
	else
	{
		mf_updatePageInfo.re.lastIndex=0;
		var arr = mf_updatePageInfo.re.exec(szRangeHeader);
		m_iStartRange = parseInt(arr[1],10);
		m_iEndRange = parseInt(arr[2],10);
		m_imaxRows = parseInt(arr[3],10);
		m_iCurrentPage = Math.ceil((m_iStartRange + m_iCurrentRowsNumber)/m_iCurrentRowsNumber);
		this.pageCount = Math.ceil(m_imaxRows/m_iCurrentRowsNumber);
		this.itemCount = m_imaxRows;
	}
}
mf_updatePageInfo.re = /rows (\d+)-(\d+); total=(\d+)/i

function mf_checkStatus(iStatus)
{
	var retval = false;
	switch(iStatus)
	{
		case 500:
		case 501:
		case 502:
		case 503:
			break;
		
		default:
				retval = true;
		break;
	}
	return(retval)
}

function requestObject()
{
	this.XMLHTTPRequest = new ActiveXObject("Microsoft.XMLhttp");
	this.target = m_objHTMLTarget;
	this.level = m_icurGrpLevel;
	this.parentTR = m_objParentTR;
	this.XSLNodes = m_objXSLNodes;
	this.callback = m_gCallBack;
	return this;
}

function mf_getXML(szURL, szXMLSearch,  iStartRange, iEndRange)
{
	var szRowRange = "";
	m_objXMLRequestQueue[m_iXMLQueueLength] = new requestObject();
	m_objMSHTTP_Request = m_objXMLRequestQueue[m_iXMLQueueLength].XMLHTTPRequest;
	m_iXMLQueueLength += 1;
	if (iStartRange != null && iEndRange != null && m_iCurrentRowsNumber != 0)
	{
		szRowRange = "rows=" + iStartRange.toString() + "-" +  iEndRange.toString()
	}
	m_objMSHTTP_Request.open("SEARCH", szURL, true);
	m_objMSHTTP_Request.setRequestHeader("Translate", "f");
	m_objMSHTTP_Request.setRequestHeader("content-type", "text/xml");
	if(null != this.acceptLang && "" != this.acceptLang)
	{
		m_objMSHTTP_Request.setRequestHeader("Accept-Language",this.acceptLang);
	}	
	m_objMSHTTP_Request.setRequestHeader("Brief", "t")
	if (szRowRange != "")
	{
		m_objMSHTTP_Request.setRequestHeader("range", szRowRange);
	}
	this.viewReadyState = "loading";
	m_objMSHTTP_Request.onreadystatechange = new Function("ongetxmlcomplete(" + (m_iXMLQueueLength-1) + ")");
	m_objMSHTTP_Request.send(szXMLSearch);
}
function mf_renderHTML()
{
	var szHTML = "";
	if(null != m_objXML)
	{
		//XML will strip leading and trailing whitepace if this property is not set to true
		m_objXML.preserveWhiteSpace = true;
		szHTML = m_objXML.transformNode(m_objXSLNodes.item(m_icurGrpLevel - 1));
		if(m_objHTMLTarget.contains(m_objRowLastSelected))
		{
			m_objRowLastSelected = null;
		}
		m_objHTMLTarget.innerHTML = szHTML;
		var objTable, objFirstTR, objLastTR;
		objTable = m_objHTMLTarget.firstChild;
		if(null != objTable)
		{
			var objTBODY  = objTable.firstChild;
			var iFirstRow = ("true" == objTable.isTabularView) ? 1 : 0;
			var iLastRow  = objTBODY.children.length - (("true" == objTable.isTabularView) ? 1 : 2);
			var objFirstRow = objTBODY.children(iFirstRow);
			var objLastRow  = objTBODY.children(iLastRow);
			if(null != objFirstRow)
			{
				objFirstRow.parentTR = m_objParentTR;
				objFirstRow.isFirstRow = true;
			}
			if(null != objLastRow)
			{
				objLastRow.parentTR  = m_objParentTR;
				objLastRow.isLastRow = true;
			}
			if(null != m_objParentTR)
			{
				m_objParentTR.firstRow = objFirstRow;
				m_objParentTR.lastRow  = objLastRow;
				m_objParentTR = null;
			}
		} 
		m_objXSLNodes = m_objDefaultXSLNodes;
	}
	if(m_bFireOnReady)
	{
		m_bFireOnReady = false;
		mf_fireOnReady();
	}
}
//***********   Private Row Range Method function  ********
//  Note:These function can only be use through the row range object

function mf_updateRowRange()
{
	var objNextRow;
	var iTempDir = 0;
	var iDelta = this.startRow.sourceIndex - this.endRow.sourceIndex;
	if(iDelta < 0)
	{
		iTempDir = DOWN;
	}
	else if(iDelta > 0)
	{
		iTempDir = UP;
	}
	else if(iDelta == 0)
	{
		mf_unselectRecord(this.tempEndRow,true)
		this.tempEndRow = this.endRow
		this.rangeDirection = null;
		return(true)
	}
	if (this.rangeDirection == null)
	{
		this.rangeDirection = iTempDir
	}
	if(iTempDir == this.rangeDirection)
	{
		 //Either add or remove rows based on the endRow
		var iEndDelta = this.tempEndRow.sourceIndex - this.endRow.sourceIndex;
		if(iEndDelta > 0 )
		{
			if(this.rangeDirection == DOWN)
			{
				//remove rows
				this.trimRange(UP)
			}
			else
			{
				//add rows
				this.expandRange(this.tempEndRow);
			}
		}
		if(iEndDelta < 0)
		{
			if(this.rangeDirection == UP)
			{
				//remove rows
				this.trimRange(DOWN)
			}
			else
			{
				//add rows
				this.expandRange(this.tempEndRow);
			}
		}
	}
	else
	{
		//Unselect all rows except the start row
		this.rangeDirection = iTempDir
		var objSelector = this.startRow
		objSelector.id = "rowSelectedException"
		mf_unselectAll()
		objSelector.id = "selected"
		//add rows in range
		this.expandRange(this.startRow);
	}
}
function mf_expandRange(objStartRow)
{
	var objTempRow;
	objTempRow = mf_getNextRow(objStartRow, this.rangeDirection)
	mf_selectRecord(this.endRow, true);
	if (mf_selectRecord(objTempRow))
	{
		for(;objTempRow.uniqueID != this.endRow.uniqueID &&
			mf_selectRecord(objTempRow, false) ;)
		{
			objTempRow = mf_getNextRow(objTempRow,  this.rangeDirection)
		}
		this.tempEndRow = this.endRow;
	}
}

function mf_trimRowRange(iDirection)
{
	//remove rows
	mf_unselectRecord(this.tempEndRow,true)
	var objTempRow;
	objTempRow = mf_getNextRow(this.tempEndRow, iDirection)
	if(objTempRow)
	{
		for(;objTempRow.uniqueID != this.endRow.uniqueID &&
			mf_unselectRecord(objTempRow);)
		{
			objTempRow = mf_getNextRow(objTempRow,iDirection)
		}
		this.tempEndRow = this.endRow;
	}
}

function mf_getNextRow(objRow,iDirection)
{
	var objTemp,objPrev;
	var retval = false;

	if (null == objRow) 
	{
		return false;
	}
	if (iDirection == UP)
	{
		if (objRow.isFirstRow) 
		{
			retval = objRow.parentTR;
		}
		else if ("true" == objRow.isGroupHeader)
		{
			objPrev = objRow.previousSibling;
			if (null != objPrev)
			{
				objTemp = objPrev.previousSibling;
				while (null != objTemp && objTemp.isExpanded)
				{
					objTemp = objTemp.lastRow;
				}
				retval = objTemp;
			}
		}
		else 
		{
			retval = objRow.previousSibling;
		}
	}
	else
	{
		if ("true" == objRow.isGroupHeader && (!objRow.isLastRow || objRow.isExpanded))
		{
			retval = (objRow.isExpanded ? objRow.firstRow : objRow.nextSibling.nextSibling);
		}
		else if (!objRow.isLastRow) 
		{
			retval = objRow.nextSibling;
		}
		else
		{
			objTemp = objRow.parentTR;
			while(null != objTemp && objTemp.isLastRow)
			{
				objTemp	= objTemp.parentTR;
			}
			if(null != objTemp)
			{
				retval = objTemp.nextSibling.nextSibling;
			}
		}
	}
	return ((null == retval) ? false : retval);
}

function mf_fireOnBeforeDelete(objItems)
{
	var objEvent		= createEventObject();
	objEvent.type		= "BeforeDelete";
	objEvent.items		= objItems;
	objEvent.srcElement	= this;
	_ideventonBeforeDelete.fire(objEvent);
	return !(objEvent.returnValue == false);
}
function mf_fireOnBeforeNavigate(objRow)
{
	var objEvent		= createEventObject();
	objEvent.type		= "BeforeNavigate";
	objEvent.url		= objRow._href;
	objEvent.srcElement	= this;
	_ideventonBeforeNavigate.fire(objEvent);
	return !(objEvent.returnValue == false);
}
function mf_fireOnError(statusCode, statusText, responseXML, szCommand)
{
	var objEvent		= createEventObject();
	objEvent.type		= "Error";
	objEvent.statusCode	= statusCode;
	objEvent.statusText	= statusText;
	objEvent.responseXML= responseXML;
	objEvent.command	= szCommand;
	_ideventonError.fire(objEvent);
}
function mf_fireOnReady()
{
	var objEvent		= createEventObject();
	objEvent.type		= "Ready";
	objEvent.srcElement	= this;
	_ideventonReady.fire(objEvent);
}
function mf_fireOnRefresh()
{
	var objEvent		= createEventObject();
	objEvent.type		= "Refresh";
	objEvent.srcElement	= this;
	_ideventonRefresh.fire(objEvent);
}
function mf_fireOnSelectionChange(objRow, b_wasSelected)
{
	var f_MultipleItems = "NONE";
	if(null != objRow && "true" == objRow.isGroupHeader)
	{
		return;
	}
	var objSelectedItems = this.all("selected");
	if (null != objSelectedItems)
	{
		if(null != objSelectedItems.length)
		{
			switch(objSelectedItems.length)
			{
				case 0:	 f_MultipleItems = "NONE"; break; 
				case 1:	 f_MultipleItems = "SINGLE"; break; 
				default: f_MultipleItems = "MULTIPLE"; break; 
			}
		}
		else
		{
			f_MultipleItems = "SINGLE";
		}
	}
	var objEvent = createEventObject();
	objEvent.type		= "SelectionChange";
	objEvent.srcElement	= this;
	objEvent.selectedURL= (null == objRow) ? null : objRow._href;
	objEvent.selected	= b_wasSelected;
	objEvent.multipleItems = f_MultipleItems;
	_ideventonSelectionChange.fire(objEvent);
	
}
function mf_toggleCheckBox(objTD)
{
	var objInput = objTD.all("checkInput");
	var objIMG = objTD.all("checkImage");
	if(null != objInput && null != objIMG)
	{
		objInput.checked = !objInput.checked;
		if(objInput.checked)
		{
			objIMG.src = objIMG.checkedimage;
			objIMG.style.visibility = "";
			mf_fireOnSelectionChange(objTD.parentElement,objInput.checked);
		}
		else
		{
			if(null != objIMG.uncheckedimage)
			{
				objIMG.src = objIMG.uncheckedimage;
			}
			else
			{
				objIMG.style.visibility = "hidden";
			}
		}
	}
}

function mf_toggleSelectedGroups(f_expand)
{
	var objGroupHeaders = this.all("selected");
	var obj;
	if (objGroupHeaders.length)
	{
		var e = new Enumerator( objGroupHeaders );
		for (;!e.atEnd();e.moveNext())
		{
			obj = e.item();
			if("true" == obj.isGroupHeader && obj.isExpanded != f_expand)
			{
				expandGroup(obj.firstChild);
			}
		}
	}
	else if(null != objGroupHeaders && "true" == objGroupHeaders.isGroupHeader && objGroupHeaders.isExpanded != f_expand)
	{
		expandGroup(objGroupHeaders.firstChild);
	}
}

function mf_changeSelectedRowsStyle(szStyleText)
{
	var objSelectedRows = this.all("selected");
	if (null == objSelectedRows)
	{
		return;
	}
	
	if (null == objSelectedRows.length)
	{
		objSelectedRows.runtimeStyle.cssText=szStyleText;
	}
	else
	{
		var e = new Enumerator( objSelectedRows );
		for (;!e.atEnd();e.moveNext())
		{
			e.item().runtimeStyle.cssText=szStyleText;;
		}
	}
}

function mf_doLinkAction(objRow,szTarget,szLinkSpec)
{
	if(null == szTarget || null == objRow)
	{
		return;
	}
	if(null == szLinkSpec)
	{
		szLinkSpec = "%dataurl%?cmd=open";
	}
	if(m_objAnchor == null)
	{
		m_objAnchor = document.createElement("A");
		m_objAnchor.style.display = "none";
		this.insertAdjacentElement("afterEnd", m_objAnchor) ;
	}
	if("true" == this.boldUnreadItems) 
	{
		objRow.style.fontWeight = 'normal';
	}
	m_objAnchor.href = szLinkSpec.replace(/%DataUrl%/gi,objRow._href);
	m_objAnchor.target = szTarget;
	m_objAnchor.click();
}

function mf_navigateToRow(objRow,szTarget,szLinkSpec)
{
	if(null != szTarget && null != szLinkSpec)
	{
		if(mf_fireOnBeforeNavigate(objRow))
		{
			m_objRowRange = null;
			mf_unselectAll();
			mf_selectRecord(objRow,false);
			mf_doLinkAction(objRow,szTarget,szLinkSpec);
		}
	}
}

/***************   End Private Row Range Function ****************************/
/*************************END PRIVATE FUNCTIONS********************************/