<!--Copyright (c) 2000-2001 Microsoft Corporation.  All rights reserved. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">
<xsl:template match="/">
<xsl:script>
	var g_iColumnCount = 0;
	var g_iGroupCount  = 0;
	g_rgSortByProps = new Array();
	
	function SetColumnCount(iCount)
	{
		g_iColumnCount = iCount + 1;    
	}
	function SetGroupCount(iCount)
	{
		g_iGroupCount   = iCount; 
	}
	function getPaddedWidth()
	{
		return("20px")
	}
	function SetOrderByProps(objNode)
	{
		var objPropNode;
		var objSortNode
		objPropNode = objNode.selectSingleNode("prop")
		objSortNode = objNode.selectSingleNode("sort")
		g_rgSortByProps[objPropNode.text] = objSortNode.text
	
	}
</xsl:script>    
<xsl:element name="view">
	<xsl:for-each select="view/column[end()]">
		<xsl:eval>SetColumnCount(childNumber(this))</xsl:eval>
	</xsl:for-each>
	<xsl:for-each select="view/groupby[end()]">
		<xsl:eval>SetGroupCount(childNumber(this))</xsl:eval>
	</xsl:for-each>
	<xsl:for-each select="view/orderby/order">
		<xsl:eval>SetOrderByProps(this)</xsl:eval>
	</xsl:for-each>
	<xsl:for-each select="view/groupby">
	<xsl:element name="group">
		<xsl:element name="xsl:template"><xsl:attribute name="xmlns:xsl">uri:xsl</xsl:attribute>
		<xsl:attribute name="xmlns:a">DAV:</xsl:attribute>
		<xsl:attribute name="xmlns:b">urn:schemas:httpmail:</xsl:attribute>
		<xsl:attribute name="xmlns:c">urn:schemas:mailheader:</xsl:attribute>
		<TABLE cellpadding="0" cellspacing="0">
			<xsl:attribute name="style">
				<xsl:value-of select="//view/viewstyle" />
			</xsl:attribute> 
			<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:multistatus/a:response</xsl:attribute>
			<TR id="tblHeader">
				<TD id="grpHdr" nowrap="true">

				<xsl:attribute name="propName"><xsl:value-of    select="order/prop" /></xsl:attribute>
				<xsl:attribute name="dataType"><xsl:value-of    select="order/prop/@d:dt" /></xsl:attribute>
				<xsl:attribute name="style"><xsl:value-of select="order/style" /></xsl:attribute>
				<xsl:attribute name="colspan"><xsl:eval>g_iColumnCount</xsl:eval> 
				</xsl:attribute>
	
				<xsl:attribute name="groupLevel"><xsl:eval>childNumber(this)</xsl:eval></xsl:attribute> 
				<xsl:element    name="xsl:for-each"><xsl:attribute name="select"><xsl:eval>"a:propstat/a:prop/prop" + childNumber(this)</xsl:eval></xsl:attribute>
			<xsl:element name="xsl:attribute"><xsl:attribute name="name">propValue</xsl:attribute><xsl:element name="xsl:eval">this.text</xsl:element></xsl:element>
			</xsl:element>
				
				<img id="grpHdrActivator" style="cursor:hand">
						<xsl:attribute name="src">
							<xsl:value-of select="//view/baseroot"></xsl:value-of>tree-splus.gif
						</xsl:attribute> 
				</img>
				&#32;
				<a href="#" onclick="return(false)" style="width:100%;text-decoration:none;color:windowtext;">
					<xsl:element name="xsl:choose">
							<xsl:element name="xsl:when">
								<xsl:attribute name="test">
									a:propstat/a:prop/b:unreadcount[. $igt$ '0']
								</xsl:attribute>
								<B><xsl:value-of select="order/heading"/>: 
								<xsl:element name="xsl:value-of">
									<xsl:attribute name="select">
									<xsl:eval>"a:propstat/a:prop/prop" + childNumber(this)</xsl:eval>
									</xsl:attribute>
								</xsl:element>&#32;
						 (<xsl:value-of select="countlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/a:visiblecount</xsl:attribute>
								 </xsl:element>,&#32;
						 <xsl:value-of select="unreadlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/b:unreadcount</xsl:attribute>
								 </xsl:element> )
								</B>
							</xsl:element>
							<xsl:element name="xsl:otherwise">
							
							<xsl:value-of select="order/heading"/>:
								<xsl:element name="xsl:value-of">
									<xsl:attribute name="select">
									<xsl:eval>"a:propstat/a:prop/prop" + childNumber(this)</xsl:eval>
									</xsl:attribute>
								</xsl:element>
						 (<xsl:value-of select="countlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/a:visiblecount</xsl:attribute>
								 </xsl:element> )
							
							</xsl:element>    
					</xsl:element>
					</a>
				</TD>
			</TR>
			<TR style="display:none;">
				<TD nowrap="true" style="padding-left:20px">
				<xsl:attribute name="colspan">
					<xsl:eval>g_iColumnCount</xsl:eval> 
				</xsl:attribute>
				
				</TD>
			  </TR>
			</xsl:element>
	
		</TABLE>
		</xsl:element>
	</xsl:element>
	</xsl:for-each>
	<xsl:element name="group">    
		<xsl:element name="xsl:template">
		<xsl:attribute name="xmlns:xsl">
		uri:xsl
		</xsl:attribute>
		<xsl:attribute name="xmlns:a">
		DAV:
		</xsl:attribute>
		
		<xsl:element name="xsl:script">
			
		var m_objDate = new Date();
		var m_x=0;
		var gszDateString = "";
		
		function formatMessageSize(szSize)
		{
			var iSize;
					
			if(szSize == "") 
			{
				szSize =    "0";
			}
			else 
			{
				iSize = parseInt(szSize);
				if( iSize &lt; 1000 )
				{
					szSize  = iSize + " B";    
				}
				else    
				{
					iSize = Math.round(iSize/1024);
					szSize  = iSize + " KB";
				}
			}
			return(szSize);
		}
	function getMyDate(objThis, szDateFormatString, szTimeFormatSTring) 
	{
		var szDate   = objThis.text;
		var szSubStr = szDate.substring(5,7);
		
		if(szSubStr.charAt(0) == "0")
		{
			szSubStr = szSubStr.charAt(1);
		}
		m_objDate.setUTCFullYear(szDate.substring(0,4));               //Set Year
		m_objDate.setUTCMonth(Number(szSubStr)-1); //Set    Month
		m_objDate.setUTCDate(szDate.substring(8,10));              //Set Date
		m_objDate.setUTCHours(szDate.substring(11,13));            //Set Hours
		m_objDate.setUTCMinutes(szDate.substring(14,16));          //Set Minutes
		m_objDate.setUTCSeconds(szDate.substring(17,19));          //Set Seconds
		m_objDate.setUTCMilliseconds(0);        
				 
		var iNumHours = m_objDate.getHours();
		var szFormattedTime = formatTime(m_objDate.getVarDate(), szTimeFormatSTring);
		var szFormattedDate = formatDate(m_objDate.getVarDate(), szDateFormatString);
		
		
		//Check for null character and strip it off if present
		if(szFormattedDate.charCodeAt(szFormattedDate.length -1) == 0)
		{
			szFormattedDate = szFormattedDate.substring(0,szFormattedDate.length-1) 
		}	
			
		gszDateString = szFormattedDate + " " + szFormattedTime;
		return (gszDateString);
		
		
		}
		</xsl:element>

		<table onselectstart="return(false);" cellpadding="0" cellspacing="0">
		<xsl:attribute name="style">
			<xsl:value-of select="//view/viewstyle"/>
		</xsl:attribute>
<!-- ******	Start Column heading xsl *********************** -->
			<tr id="tblHeader">
				<xsl:attribute name="style">
					<xsl:value-of select="//view/headerstyle"/>
				</xsl:attribute>       
			 
				<xsl:for-each select="//view/column">
				<xsl:choose>
					<xsl:when test="visible[. $eq$ '0']" ></xsl:when>
					<xsl:otherwise>
					<td id="tdColumn" nowrap="1" onmouseup="event.returnValue=this;" >
						<xsl:choose >
								<xsl:when test="bitmap[. = '1']">
								<xsl:attribute name="width">18</xsl:attribute>
								<xsl:attribute name="align">center</xsl:attribute>
								<xsl:attribute name="valign">center</xsl:attribute>
								</xsl:when>
								<xsl:otherwise>
								<xsl:attribute name="style">width:<xsl:value-of select="width"/>;cursor:hand;<xsl:value-of select="style"/></xsl:attribute>    
								</xsl:otherwise>
						</xsl:choose>
						
						<xsl:attribute name="prop"><xsl:value-of select="prop"/></xsl:attribute>
						<xsl:attribute name="dataType"><xsl:value-of select="prop/@d:dt" /></xsl:attribute>
						<xsl:attribute name="colName"><xsl:value-of select="heading"/></xsl:attribute>
						<xsl:attribute name="sortable"><xsl:value-of select="sortable"/></xsl:attribute>
						<xsl:for-each select="prop">
							<xsl:attribute name="sortdir"><xsl:eval>g_rgSortByProps[this.text]</xsl:eval></xsl:attribute>
						</xsl:for-each>
						
						<xsl:choose>
							<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/x-priority-long']">
								<IMG id="imgCol" style="cursor:hand" >
									<xsl:attribute name="src">
										<xsl:value-of select="//view/baseroot"></xsl:value-of>view-importance.gif
									</xsl:attribute>
								</IMG>
							</xsl:when>
							<xsl:when test="prop[. = 'urn:schemas:httpmail:hasattachment']">
								<IMG id="imgCol" style="cursor:hand" >
									<xsl:attribute name="src">
										<xsl:value-of select="//view/baseroot"></xsl:value-of>view-paperclip.gif
									</xsl:attribute>
								</IMG>
							</xsl:when>
							<xsl:when test="prop[. =	'http://schemas.microsoft.com/exchange/smallicon']">
								<IMG id="imgCol" style="cursor:hand" >
									<xsl:attribute name="src">
										<xsl:value-of select="//view/baseroot"></xsl:value-of>view-document.gif
									</xsl:attribute>
								</IMG>
							</xsl:when>
							<!-- Flag status col -->
							<xsl:when test="prop[.  = 'http://schemas.microsoft.com/mapi/proptag/x10900003']">
								<IMG id="imgCol" style="cursor:hand">
									<xsl:attribute name="src">
										<xsl:value-of select="//view/baseroot"></xsl:value-of>view-flag.gif
									</xsl:attribute>
								</IMG>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="heading"/>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:if   test="bitmap[. != '1']">
							<xsl:for-each select="prop">
								<xsl:if expr="g_rgSortByProps[this.text] == 'DESC'">
									<IMG id="imgSortIndicator">
										<xsl:attribute  name="src">
											<xsl:value-of select="//view/baseroot"></xsl:value-of>view-sortdown.gif
										</xsl:attribute>
									</IMG>
								</xsl:if>
								<xsl:if expr="g_rgSortByProps[this.text] == 'ASC'">
									<IMG id="imgSortIndicator">
										<xsl:attribute  name="src">
											<xsl:value-of select="//view/baseroot"></xsl:value-of>view-sortup.gif
										</xsl:attribute>
									</IMG>
								</xsl:if>
							</xsl:for-each>
						</xsl:if>
						
					</td>
					</xsl:otherwise>
				</xsl:choose>
				</xsl:for-each>
				</tr>
<!-- ****** End Column heading xsl *********************** -->
<!-- ****** Start Property xsl     *********************** -->
		<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:multistatus/a:response</xsl:attribute>
		
		<tr id="unSelected" onmousedown="event.returnValue=this" onmouseup="event.returnValue=this" ondblclick="event.returnValue=this">
			<xsl:element name="xsl:attribute">
				<xsl:attribute name="name">style</xsl:attribute>
				<xsl:value-of select="view/rowstyle"/>
				<xsl:element name="xsl:if">
					<xsl:attribute name="test">a:propstat/a:prop/read[.='0']
					</xsl:attribute>
					;font-weight:bold;
				</xsl:element>
			</xsl:element>
			<!-- Add contentClass to expando prop on the row 
			** Note - Do not add CRLF's here or xsl will output them with value
			-->
			<xsl:element name="xsl:attribute"><xsl:attribute name="name">_href</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:href</xsl:attribute></xsl:element></xsl:element>
			<xsl:element name="xsl:attribute"><xsl:attribute name="name">contentClass</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/contentclass</xsl:attribute></xsl:element></xsl:element>
			<a tabindex="-1"    onclick="return(false)">
			<xsl:element name="xsl:attribute"><xsl:attribute name="name">href</xsl:attribute>
			<xsl:element name="xsl:value-of"><xsl:attribute name="select">a:href</xsl:attribute></xsl:element>?Cmd=open                 
			</xsl:element>          
			<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:propstat/a:prop</xsl:attribute>
				<xsl:for-each select="view/column">
				<xsl:choose>
					<xsl:when test="visible[. $eq$ '0']" ></xsl:when>
					<xsl:otherwise>
					<xsl:choose>
			<!-- ****** Start Content Length Property xsl      *********************** -->                    
						<xsl:when test="prop[.  = 'http://schemas.microsoft.com/mapi/proptag/x0e080003']">
							<td nowrap="true">
							<xsl:choose >
								<xsl:when test="bitmap[. = '1']">
									<xsl:attribute name="width">18</xsl:attribute>
									<xsl:attribute name="align">center</xsl:attribute>
									<xsl:attribute name="valign">center</xsl:attribute>
								</xsl:when>
								<xsl:otherwise>
									<xsl:attribute name="style">width:<xsl:value-of select="width"/>;overflow:hidden;cursor:default;<xsl:value-of select="style"/></xsl:attribute>    
								</xsl:otherwise>
							</xsl:choose>
							 <xsl:element name="xsl:for-each">
								<xsl:attribute name="select">
									<xsl:eval>"prop" + childNumber(this)</xsl:eval>
								</xsl:attribute>
								<xsl:element name="xsl:eval">formatMessageSize(this.text)
								</xsl:element>
							
							</xsl:element>
				
							</td>
						</xsl:when>
		<!-- ****** End Content Length Property xsl     *********************** -->                    
		<!-- ****** Start Message Class Property xsl     *********************** -->                    
						<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/smallicon']">
							<td nowrap="true" align="center" valign="center" width="18" >
								<IMG width="16" height="16">
									<xsl:element name="xsl:attribute"><xsl:attribute name="name">src</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute></xsl:element></xsl:element>
								</IMG>
								
							</td>
						</xsl:when>
		<!-- ****** End Content Class Property xsl     *********************** -->                      
		<!-- ****** Start Importance Property xsl     *********************** -->  
						<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/x-priority-long']">
							<td align="middle" nowrap="true">
								<xsl:attribute  name="width">
									<xsl:value-of select="width"/>
								</xsl:attribute>
								<xsl:element name="xsl:choose">
									<xsl:element name="xsl:when">
										<xsl:attribute name="test">
											<xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='0']
										</xsl:attribute>
										<xsl:element name="IMG">
											<xsl:attribute name="src">
												<xsl:value-of select="//view/baseroot"></xsl:value-of>icon-lowimportance.gif
											</xsl:attribute>
											<xsl:attribute name="style">cursor:hand</xsl:attribute>
										</xsl:element>
									</xsl:element>
									<xsl:element name="xsl:when">
										<xsl:attribute name="test">
											<xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='2']
										</xsl:attribute>
										<xsl:element name="IMG">
											<xsl:attribute name="src">
												<xsl:value-of select="//view/baseroot"></xsl:value-of>icon-highimportance.gif
											</xsl:attribute>
											<xsl:attribute name="style">cursor:hand</xsl:attribute>
										</xsl:element>
									</xsl:element>
								</xsl:element>
						
							</td>
						</xsl:when>
		<!-- ****** End Importance Property xsl     *********************** -->
		<!-- *****  Start Flag Status Property xsl     *********************** -->  
						<xsl:when test="prop[. = 'http://schemas.microsoft.com/mapi/proptag/x10900003']">
							<td align="middle" nowrap="true">
							<xsl:attribute  name="width">
								<xsl:value-of select="width"/>
							</xsl:attribute>
							<xsl:element name="xsl:choose">
								<xsl:element name="xsl:when">
									<xsl:attribute name="test">
										<xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='1']
									</xsl:attribute>
									<xsl:element name="IMG">
										<xsl:attribute name="src">
											<xsl:value-of select="//view/baseroot"></xsl:value-of>icon-flag-complete.gif
										</xsl:attribute>
										<xsl:attribute name="style">cursor:hand</xsl:attribute>
									</xsl:element>
								</xsl:element>
								<xsl:element name="xsl:when">
									<xsl:attribute name="test">
										<xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='2']
									</xsl:attribute>
									<xsl:element name="IMG">
										<xsl:attribute name="src">
											<xsl:value-of select="//view/baseroot"></xsl:value-of>icon-flag.gif
										</xsl:attribute>
										<xsl:attribute name="style">cursor:hand</xsl:attribute>
									</xsl:element>
									
								</xsl:element>
							</xsl:element>
						
							</td>
						</xsl:when>
		<!-- ****** End Flag Status Property xsl     *********************** -->                             
		<!-- ****** Start has attachment Property xsl     *********************** -->                    
						<xsl:when test="prop[. = 'urn:schemas:httpmail:hasattachment']">
							<td align="middle" nowrap="true">
								<xsl:attribute  name="width">
									<xsl:value-of select="width"/>
								</xsl:attribute>
								<xsl:element name="xsl:choose">
									<xsl:element name="xsl:when">
										<xsl:attribute name="test">
											<xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='1']
										</xsl:attribute>
										<xsl:element name="IMG">
											<xsl:attribute name="src">
												<xsl:value-of select="//view/baseroot"></xsl:value-of>icon-paperclip.gif
											</xsl:attribute>
											<xsl:attribute name="style">cursor:hand</xsl:attribute>
										</xsl:element>
									</xsl:element>
								</xsl:element>
						
							</td>
						</xsl:when>
		<!-- ****** End has attachment Property xsl     *********************** -->                    
		<!-- ****** Start boolean properties xsl        *********************** -->                                        
						<xsl:when test="prop[@d:dt = 'bool']">
							<td align="middle" nowrap="true">
							<xsl:attribute  name="width">
								<xsl:value-of select="width"/>
							</xsl:attribute>
							<xsl:element name="xsl:choose">
								<xsl:element name="xsl:when">
									<xsl:attribute name="test">
										<xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='1']
									</xsl:attribute>
									<input style="border:solid 1px;cursor:hand" type="checkbox"  onclick="return(false)" checked="true"/>
								</xsl:element>
								<xsl:element name="xsl:otherwise">
									<input style="border:solid 1px;border:solid 1px;cursor:hand" onclick="return(false)" type="checkbox"/>
								</xsl:element>
							</xsl:element>
								
							</td>
						</xsl:when>
		<!-- ****** End boolean properties xsl        *********************** -->                                        
			 <!-- ****** Start Date Property Property xsl     *********************** -->                    
						 <xsl:when test="prop[@d:dt = 'date']">
							<td nowrap="true">
							<xsl:choose >
								<xsl:when test="bitmap[. = '1']">
								<xsl:attribute name="width">17</xsl:attribute>
								</xsl:when>
								<xsl:otherwise>
								<xsl:attribute name="style">width:<xsl:value-of select="width"/>;overflow:hidden;cursor:default;<xsl:value-of select="style"/></xsl:attribute>    
								</xsl:otherwise>
							</xsl:choose>
							<xsl:element name="xsl:for-each">
								<xsl:attribute name="select">
									<xsl:eval>"prop" + childNumber(this)</xsl:eval>
								</xsl:attribute>
								<xsl:element name="xsl:eval">getMyDate(this, "<xsl:value-of select='dateformat' />", "<xsl:value-of select='timeformat' />")</xsl:element>
							</xsl:element>
						
							</td>
						</xsl:when>
		<!-- ****** End Content Length Property xsl     *********************** -->    
			
		<!-- ****** Start non special properties xsl        *********************** -->                                        
						<xsl:otherwise>
						<td  onselectstart="return(false)" nowrap="true">
						<xsl:choose >
								<xsl:when test="bitmap[. = '1']">
								<xsl:attribute name="width">17</xsl:attribute>
								</xsl:when>
								<xsl:otherwise>
								<xsl:attribute name="style">width:<xsl:value-of select="width"/>;overflow:hidden;cursor:default;<xsl:value-of select="style"/></xsl:attribute>    
								</xsl:otherwise>
						</xsl:choose>
						<xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute>
						</xsl:element>
						</td>
						</xsl:otherwise>
		<!-- ****** End non special properties xsl        *********************** -->
					</xsl:choose>
				</xsl:otherwise>
				</xsl:choose>
				</xsl:for-each>
			</xsl:element>
		</a>
		</tr>
		</xsl:element>
		</table>
<!-- ****** End Property xsl     *********************** -->
		</xsl:element>
		</xsl:element>
</xsl:element>
</xsl:template>
</xsl:stylesheet>