<!--Copyright (c) 2000-2001 Microsoft Corporation.  All rights reserved. -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl" default-space="strip">
<xsl:template match="@*"><xsl:attribute><xsl:value-of select="."/></xsl:attribute></xsl:template> 
<xsl:template match="@style"></xsl:template>
<xsl:template match="style">
	<xsl:value-of select="." />
</xsl:template>
<xsl:template match="/">
<xsl:element name="view">
	<xsl:for-each select="view/groupby/order">
	<xsl:element name="group">
		<xsl:element name="xsl:template"><xsl:attribute name="xmlns:xsl">uri:xsl</xsl:attribute>
		<xsl:attribute name="xmlns:a">DAV:</xsl:attribute>
		<xsl:attribute name="xmlns:b">urn:schemas:httpmail:</xsl:attribute>
		<xsl:attribute name="xmlns:c">urn:schemas:mailheader:</xsl:attribute>
		<TABLE tabindex="-1">
			<xsl:apply-templates select="/view/viewstyle/@*"/>
			<xsl:attribute name="style"><xsl:value-of select="/view/viewstyle"/></xsl:attribute>
			<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:multistatus/a:response</xsl:attribute>
			<TR id="groupHeaderRow" isGroupHeader="true" onmousedown="if(null == event.returnValue) event.returnValue=this;" style="cursor:default" ondragstart="event.cancelBubble=true;return(false);">
				<TD nowrap="true" id="groupHeaderText" ondblclick="if(null == event.returnValue) event.returnValue=this;" ondragstart="event.cancelBubble=true;return(false);">
					<xsl:apply-templates select="style/@*"/>
					<xsl:attribute name="propName"><xsl:value-of select="prop" /></xsl:attribute>
					<xsl:attribute name="dataType"><xsl:value-of select="type" /></xsl:attribute>
					<xsl:attribute name="style"><xsl:value-of select="style" /></xsl:attribute>
					<xsl:attribute name="groupLevel"><xsl:eval>childNumber(this)</xsl:eval></xsl:attribute>
					<xsl:element name="xsl:for-each">
						<xsl:attribute name="select"><xsl:eval>"a:propstat/a:prop/prop" + childNumber(this)</xsl:eval></xsl:attribute>
						<xsl:element name="xsl:attribute"><xsl:attribute name="name">propValue</xsl:attribute><xsl:element name="xsl:eval">this.text</xsl:element></xsl:element>
					</xsl:element>
					<IMG onmousedown="if(null == event.returnValue) event.returnValue=this" id="groupHeaderActivator" style="cursor:hand;vertical-align:middle" ondragstart="event.cancelBubble=true;return(false);">
						<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>tree-splus.gif</xsl:attribute> 
						<xsl:attribute name="altsrc"><xsl:value-of select="/view/imagepath"></xsl:value-of>tree-sminus.gif</xsl:attribute> 
					</IMG>
					&#32;
					<SPAN id="groupHeaderSpan" ondragstart="event.cancelBubble=true;return(false);">
					<xsl:choose>
						<xsl:when test="/view/boldUnreadItems[. = 'true']">
							<xsl:element name="xsl:choose">
								<xsl:element name="xsl:when">
									<xsl:attribute name="test">a:propstat/a:prop/b:unreadcount[. $igt$ '0']</xsl:attribute>
									<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute>width:100%;cursor:default;vertical-align:middle;font-weight:bold</xsl:element>
								</xsl:element>
								<xsl:element name="xsl:otherwise">
									<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute>width:100%;cursor:default;vertical-align:middle</xsl:element>
								</xsl:element>
							</xsl:element>
						</xsl:when>
						<xsl:otherwise><xsl:attribute name="style">width:100%;cursor:default;vertical-align:middle</xsl:attribute></xsl:otherwise>
					</xsl:choose>
					<xsl:element name="xsl:choose">
						<xsl:element name="xsl:when">
							<xsl:attribute name="test">a:propstat/a:prop/b:unreadcount[. $igt$ '0']</xsl:attribute>
							<xsl:value-of select="heading"/>:
							<xsl:element name="xsl:value-of">
								<xsl:attribute name="select">
								<xsl:eval>"a:propstat/a:prop/prop" + childNumber(this)</xsl:eval>
								</xsl:attribute>
							</xsl:element>&#32;
							<xsl:choose>
								<xsl:when test="countlabel">
									<xsl:choose>
										<xsl:when test="unreadlabel">
											(<xsl:value-of select="countlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/a:visiblecount</xsl:attribute></xsl:element>,&#32;
											<xsl:value-of select="unreadlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/b:unreadcount</xsl:attribute></xsl:element> )
										</xsl:when>
										<xsl:otherwise>
											(<xsl:value-of select="countlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/a:visiblecount</xsl:attribute></xsl:element> )
										</xsl:otherwise>
									</xsl:choose>
								</xsl:when>
								<xsl:when test="unreadlabel">
									(<xsl:value-of select="unreadlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/b:unreadcount</xsl:attribute></xsl:element> )
								</xsl:when>
								<xsl:otherwise/>
							</xsl:choose>
						</xsl:element>
						<xsl:element name="xsl:otherwise">
							<xsl:value-of select="heading"/>:
							<xsl:element name="xsl:value-of">
								<xsl:attribute name="select">
									<xsl:eval>"a:propstat/a:prop/prop" + childNumber(this)</xsl:eval>
								</xsl:attribute>
							</xsl:element>
							<xsl:if test="countlabel">
								(<xsl:value-of select="countlabel" />: <xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/a:visiblecount</xsl:attribute></xsl:element>)
							</xsl:if>
						</xsl:element>
					</xsl:element>
					</SPAN>
				</TD>
			</TR>
			<TR id="groupContentRow" style="display:none;">
				<TD id="groupContentCell" nowrap="true" style="padding-left:20px"/>
			</TR>
			</xsl:element>
		</TABLE>
		</xsl:element>
	</xsl:element>
	</xsl:for-each>
	<xsl:element name="group">
		<xsl:element name="xsl:template">
		<xsl:attribute name="xmlns:xsl">uri:xsl</xsl:attribute>
		<xsl:attribute name="xmlns:a">DAV:</xsl:attribute>
		
		<xsl:element name="xsl:script">
			
		var re=/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}).\d{3}Z?$/;
		
		function formatMessageSize(szSize)
		{
			var iSize;
			if(szSize == "") 
			{
				szSize = "0";
			}
			else 
			{
				iSize = parseInt(szSize);
				if( iSize &lt; 1000 )
				{
					szSize  = iSize + " B";
				}
				else
				{
					iSize = Math.round(iSize/1024);
					szSize  = iSize + " KB";
				}
			}
			return(szSize);
		}
		function parseFormatString(szDateText, szFormatString)
		{
			if(null == szFormatString || "" == szFormatString)
			{
				szFormatString = "M/d/yyyy h:mm:ss tt";
			}
			var szFormatArray = szFormatString.split("||");
			if(szFormatArray.length >= 2)
			{
				return getMyDate(szDateText,szFormatArray[0] + " " + szFormatArray[1]);
			}
			else if(szFormatArray.length >= 1)
			{
				return getMyDate(szDateText,szFormatArray[0]);
			}
			else
			{
				return "";
			}
		}
		function getMyDate(szISODate,szDateTimeFormat)
		{
			re.lastIndex=0;
			var arr = re.exec( szISODate );
			if (null == arr) return "";
			var szQuotedDateTimeFormat = szDateTimeFormat.replace(/M{4}/g,"X");
			szQuotedDateTimeFormat = szQuotedDateTimeFormat.replace(/M{3}/g,"''''MMM''''");
			szQuotedDateTimeFormat = szQuotedDateTimeFormat.replace(/X/g,"''''MMMM''''");
			szQuotedDateTimeFormat = szQuotedDateTimeFormat.replace(/d{4}/g,"X");
			szQuotedDateTimeFormat = szQuotedDateTimeFormat.replace(/d{3}/g,"''''ddd''''");
			szQuotedDateTimeFormat = szQuotedDateTimeFormat.replace(/X/g,"''''dddd''''");
			var objD = new Date(Date.UTC(arr[1],arr[2]-1,arr[3],arr[4],arr[5],arr[6],0));
			var szFormattedDateTime	= formatDate(objD.getVarDate(), szQuotedDateTimeFormat);
			return formatTime(objD.getVarDate(), szFormattedDateTime);
		}
		</xsl:element>
		<TABLE isTabularView="true" >
		<xsl:apply-templates select="/view/viewstyle/@*"/>
		<xsl:attribute name="style"><xsl:value-of select="/view/viewstyle"/></xsl:attribute>
<!-- ******	Start Column heading xsl *********************** -->
			<TR id="tblHeader">
				<xsl:apply-templates select="/view/headerstyle/@*"/>
				<xsl:attribute name="style"><xsl:value-of select="/view/headerstyle"/></xsl:attribute>
				<xsl:for-each select="/view/column">
					<TD id="tdColumn" onclick="if(null == event.returnValue) event.returnValue=this;">
						<xsl:choose>
							<xsl:when test="visible[. = '0']">
								<xsl:attribute name="style">display:none</xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="headerstyle/@*"/>
								<xsl:attribute name="style">
									<xsl:choose>
										<xsl:when test="headerstyle"><xsl:value-of select="headerstyle"/></xsl:when>
										<xsl:otherwise>text-align:center;vertical-align:middle;cursor:hand</xsl:otherwise>
									</xsl:choose>
								</xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:attribute name="prop"><xsl:value-of select="prop"/></xsl:attribute>
						<xsl:attribute name="dataType"><xsl:value-of select="type" /></xsl:attribute>
						<xsl:attribute name="colName"><xsl:value-of select="heading"/></xsl:attribute>
						<xsl:attribute name="sortdir"><xsl:value-of select="/view/orderby/order[prop = context()/prop]/sort"/></xsl:attribute>
						<xsl:attribute name="sortable"><xsl:choose><xsl:when test="sortable[. = '0']">0</xsl:when><xsl:otherwise>1</xsl:otherwise></xsl:choose></xsl:attribute>
						<xsl:choose>
							<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/x-priority-long']">
								<IMG id="imgCol" style="cursor:hand">
									<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-importance.gif</xsl:attribute>
								</IMG>
							</xsl:when>
							<xsl:when test="prop[. = 'urn:schemas:httpmail:hasattachment']">
								<IMG id="imgCol" style="cursor:hand" >
									<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-paperclip.gif</xsl:attribute>
								</IMG>
							</xsl:when>
							<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/smallicon']">
								<IMG id="imgCol" style="cursor:hand" >
									<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-document.gif</xsl:attribute>
								</IMG>
							</xsl:when>
							<!-- Flag status col -->
							<xsl:when test="prop[.  = 'http://schemas.microsoft.com/mapi/proptag/x10900003']">
								<IMG id="imgCol" style="cursor:hand">
									<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>view-flag.gif</xsl:attribute>
								</IMG>
							</xsl:when>
							<!-- Checkbox column -->
							<xsl:when test="checkbox[. = '1']">
								<IMG>
									<xsl:attribute name="SRC">
										<xsl:choose>
											<xsl:when test="checkbox/@headercheckimage">
												<xsl:value-of select="/view/customimagepath"/><xsl:value-of select="checkbox/@headercheckimage"/>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="/view/imagepath"/>headercheck.gif
											</xsl:otherwise>
										</xsl:choose>
									</xsl:attribute>
								</IMG>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="heading"/>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:choose>
							<xsl:when test="bitmap[. = '1']" />
							<xsl:when test="sortable[. = '0']"/>
							<xsl:when test="/view/orderby/order[prop = context()/prop]/sort[. = 'DESC']">
								<IMG id="imgSortIndicator">
									<xsl:choose>
										<xsl:when test="/view/sortdescicon">
											<xsl:attribute name="src"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="/view/sortdescicon"/></xsl:attribute>
										</xsl:when>
										<xsl:otherwise>
											<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/>view-sortdown.gif</xsl:attribute>
										</xsl:otherwise>
									</xsl:choose>
								</IMG>
							</xsl:when>
							<xsl:when test="/view/orderby/order[prop = context()/prop]/sort[. = 'ASC']">
								<IMG id="imgSortIndicator">
									<xsl:choose>
										<xsl:when test="/view/sortascicon">
											<xsl:attribute name="src"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="/view/sortascicon"/></xsl:attribute>
										</xsl:when>
										<xsl:otherwise>
											<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/>view-sortup.gif</xsl:attribute>
										</xsl:otherwise>
									</xsl:choose>
								</IMG>
							</xsl:when>
						</xsl:choose>
					</TD>
				</xsl:for-each>
				</TR>
<!-- ****** End Column heading xsl *********************** -->
<!-- ****** Start Property xsl     *********************** -->
		<xsl:element name="xsl:eval">
			var i=0;
		</xsl:element>
		<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:multistatus/a:response</xsl:attribute>
		<TR id="unSelected" onmousedown="if(null == event.returnValue) event.returnValue=this" onclick="if(null == event.returnValue) event.returnValue=this" ondblclick="if(null == event.returnValue) event.returnValue=this">
			<xsl:choose>
				<xsl:when test="view[rowstyle and altrowstyle]">
					<xsl:element name="xsl:choose">
						<xsl:element name="xsl:when">
							<xsl:attribute name="expr">i++ %2</xsl:attribute>
							<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute><xsl:value-of select="view/altrowstyle"/><xsl:if test="/view/boldUnreadItems[. = 'true']"><xsl:element name="xsl:if"><xsl:attribute name="test">a:propstat/a:prop/read[.='0']</xsl:attribute>;font-weight:bold;</xsl:element></xsl:if></xsl:element>
							<xsl:for-each select = "view/altrowstyle/@*[nodeName() != 'style']">
								<xsl:element name="xsl:attribute"><xsl:attribute name="name"><xsl:eval>this.nodeName</xsl:eval></xsl:attribute><xsl:value-of select="."/></xsl:element>
							</xsl:for-each>
						</xsl:element>
						<xsl:element name="xsl:otherwise">
							<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute><xsl:value-of select="view/rowstyle"/><xsl:if test="/view/boldUnreadItems[. = 'true']"><xsl:element name="xsl:if"><xsl:attribute name="test">a:propstat/a:prop/read[.='0']</xsl:attribute>;font-weight:bold;</xsl:element></xsl:if></xsl:element>
							<xsl:for-each select = "view/rowstyle/@*[nodeName() != 'style']">
								<xsl:element name="xsl:attribute"><xsl:attribute name="name"><xsl:eval>this.nodeName</xsl:eval></xsl:attribute><xsl:value-of select="."/></xsl:element>
							</xsl:for-each>
						</xsl:element>
					</xsl:element>
				</xsl:when>
				<xsl:when test="view/rowstyle">
					<xsl:element name="xsl:attribute"><xsl:attribute name="name">style</xsl:attribute><xsl:value-of select="view/rowstyle"/><xsl:if test="/view/boldUnreadItems[. = 'true']"><xsl:element name="xsl:if"><xsl:attribute name="test">a:propstat/a:prop/read[.='0']</xsl:attribute>;font-weight:bold;</xsl:element></xsl:if></xsl:element>
					<xsl:for-each select = "view/rowstyle/@*[nodeName() != 'style']">
						<xsl:element name="xsl:attribute"><xsl:attribute name="name"><xsl:eval>this.nodeName</xsl:eval></xsl:attribute><xsl:value-of select="."/></xsl:element>
					</xsl:for-each>
				</xsl:when>
			</xsl:choose>
			<!-- Add messageClass to expando prop on the row 
			** Note - Do not add CRLF's here or xsl will output them with value
			-->
			<xsl:element name="xsl:attribute"><xsl:attribute name="name">_href</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:href</xsl:attribute></xsl:element></xsl:element>
			<xsl:element name="xsl:attribute"><xsl:attribute name="name">_davhref</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/davhref</xsl:attribute></xsl:element></xsl:element>
			<xsl:element name="xsl:attribute"><xsl:attribute name="name">messageClass</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">a:propstat/a:prop/messageclass</xsl:attribute></xsl:element></xsl:element>
			<A  onclick="return(false)" tabindex="-1">
			<xsl:element name="xsl:attribute"><xsl:attribute name="name">href</xsl:attribute>
			<xsl:element name="xsl:value-of"><xsl:attribute name="select">a:href</xsl:attribute></xsl:element></xsl:element>
			<xsl:element name="xsl:for-each"><xsl:attribute name="select">a:propstat/a:prop</xsl:attribute>
				<xsl:for-each select="view/column">
					<TD id="tableTD">
						<xsl:choose>
							<xsl:when test="visible[. = '0']">
								<xsl:attribute name="style">display:none</xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:apply-templates select="style/@*"/>
								<xsl:attribute name="style"><xsl:apply-templates select="style" /></xsl:attribute>
							</xsl:otherwise>
						</xsl:choose>
					<xsl:choose>
		<!-- ****** Start Custom XSL Property    *********************** -->
						<xsl:when test="customxsl[. != '' and /view/xslpassthrough[@name = context()/customxsl]]">
							<xsl:for-each select="/view/xslpassthrough[@name = context()/customxsl]">
								<xsl:for-each><xsl:eval no-entities='t'>this.xml</xsl:eval></xsl:for-each>
							</xsl:for-each>
						</xsl:when>
		<!-- ****** End Custom XSL Property      *********************** -->
		<!-- ****** Start Content Length Property xsl   *********************** -->
						<xsl:when test="prop[.  = 'http://schemas.microsoft.com/mapi/proptag/x0e080003']">
							<xsl:element name="xsl:for-each">
								<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute>
								<xsl:element name="xsl:eval">formatMessageSize(this.text)</xsl:element>
							</xsl:element>
						</xsl:when>
		<!-- ****** End Content Length Property xsl     *********************** -->
		<!-- ****** Start Content Class Property xsl     *********************** -->
						<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/smallicon']">
							<IMG width="16" height="16">
								<xsl:element name="xsl:attribute"><xsl:attribute name="name">src</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute></xsl:element></xsl:element>
							</IMG>
						</xsl:when>
		<!-- ****** End Content Class Property xsl     *********************** -->
		<!-- ****** Start Importance Property xsl     *********************** -->
						<xsl:when test="prop[. = 'http://schemas.microsoft.com/exchange/x-priority-long']">
							<xsl:element name="xsl:choose">
								<xsl:element name="xsl:when">
									<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='0']</xsl:attribute>
									<xsl:element name="IMG">
										<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-lowimportance.gif</xsl:attribute>
										<xsl:attribute name="style">cursor:hand</xsl:attribute>
									</xsl:element>
								</xsl:element>
								<xsl:element name="xsl:when">
									<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='2']</xsl:attribute>
									<xsl:element name="IMG">
										<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-highimportance.gif</xsl:attribute>
										<xsl:attribute name="style">cursor:hand</xsl:attribute>
									</xsl:element>
								</xsl:element>
							</xsl:element>
						</xsl:when>
		<!-- ****** End Importance Property xsl     *********************** -->
		<!-- *****  Start Flag Status Property xsl     *********************** -->  
						<xsl:when test="prop[. = 'http://schemas.microsoft.com/mapi/proptag/x10900003']">
							<xsl:element name="xsl:choose">
								<xsl:element name="xsl:when">
									<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='1']</xsl:attribute>
									<xsl:element name="IMG">
										<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-flag-complete.gif</xsl:attribute>
										<xsl:attribute name="style">cursor:hand</xsl:attribute>
									</xsl:element>
								</xsl:element>
								<xsl:element name="xsl:when">
									<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='2']</xsl:attribute>
									<xsl:element name="IMG">
										<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-flag.gif</xsl:attribute>
										<xsl:attribute name="style">cursor:hand</xsl:attribute>
									</xsl:element>
								</xsl:element>
							</xsl:element>
						</xsl:when>
		<!-- ****** End Flag Status Property xsl     *********************** -->
		<!-- ****** Start has attachment Property xsl     *********************** -->
						<xsl:when test="prop[. = 'urn:schemas:httpmail:hasattachment']">
							<xsl:element name="xsl:choose">
								<xsl:element name="xsl:when">
									<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[.='1']</xsl:attribute>
									<xsl:element name="IMG">
										<xsl:attribute name="src"><xsl:value-of select="/view/imagepath"></xsl:value-of>icon-paperclip.gif</xsl:attribute>
										<xsl:attribute name="style">cursor:hand</xsl:attribute>
									</xsl:element>
								</xsl:element>
							</xsl:element>
						</xsl:when>
		<!-- ****** End has attachment Property xsl      *********************** -->
		<!-- ****** Start checkbox properties xsl        *********************** -->
						<xsl:when test="checkbox[. = '1']">
							<xsl:attribute name="ischeckbox">true</xsl:attribute>
							<xsl:attribute name="ondblclick">event.cancelBubble=true;</xsl:attribute>
							<xsl:attribute name="onclick">event.returnValue=this</xsl:attribute>
							<xsl:element name="INPUT">
								<xsl:attribute name="type">checkbox</xsl:attribute>
								<xsl:attribute name="id">checkInput</xsl:attribute>
								<xsl:attribute name="name"><xsl:value-of select="/view/viewcontainerid"/>_<xsl:value-of select="name"/></xsl:attribute>
								<xsl:attribute name="style">DISPLAY:NONE</xsl:attribute>
								<xsl:element name="xsl:attribute"><xsl:attribute name="name">value</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute></xsl:element></xsl:element>
								<xsl:element name="xsl:attribute"><xsl:attribute name="name">_href</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">context(-2)/a:href</xsl:attribute></xsl:element></xsl:element>
								<xsl:element name="xsl:attribute"><xsl:attribute name="name">messageClass</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select">messageclass</xsl:attribute></xsl:element></xsl:element>
							</xsl:element>
							<IMG id="checkImage">
								<xsl:choose>
									<xsl:when test="checkbox/@checkedimage">
										<xsl:attribute name="checkedimage"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="checkbox/@checkedimage"/></xsl:attribute>
									</xsl:when>
									<xsl:otherwise>
										<xsl:attribute name="checkedimage"><xsl:value-of select="/view/imagepath"/>checked.gif</xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:choose>
									<xsl:when test="checkbox/@uncheckedimage[. != '']">
										<xsl:attribute name="uncheckedimage"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="checkbox/@uncheckedimage"/></xsl:attribute>
										<xsl:attribute name="SRC"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="checkbox/@uncheckedimage"/></xsl:attribute>
									</xsl:when>
									<xsl:when test="checkbox/@uncheckedimage[. = '']">
										<xsl:attribute name="style">visibility:hidden</xsl:attribute>
										<xsl:attribute name="SRC">
											<xsl:choose>
												<xsl:when test="checkbox[@checkedimage != '']"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="checkbox/@checkedimage"/></xsl:when>
												<xsl:otherwise><xsl:value-of select="/view/imagepath"/>checked.gif</xsl:otherwise>
											</xsl:choose>
										</xsl:attribute>
									</xsl:when>
									<xsl:otherwise>
										<xsl:attribute name="uncheckedimage"><xsl:value-of select="/view/imagepath"/>unchecked.gif</xsl:attribute>
										<xsl:attribute name="SRC"><xsl:value-of select="/view/imagepath"/>unchecked.gif</xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>
							</IMG>
						</xsl:when>
		<!-- ****** End checkbox properties xsl        *********************** -->
		<!-- ****** Start boolean properties xsl        *********************** -->
						<xsl:when test="type[. = 'boolean' and context()/format[. = 'boolicon']]">
							<xsl:choose>
								<xsl:when test=".[booltrueicon and boolfalseicon]">
									<xsl:element name="xsl:choose">
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '1']</xsl:attribute>
											<IMG><xsl:attribute name="src"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="booltrueicon"/></xsl:attribute></IMG>
										</xsl:element>
										<xsl:element name="xsl:when">
											<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '0']</xsl:attribute>
											<IMG><xsl:attribute name="src"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="boolfalseicon"/></xsl:attribute></IMG>
										</xsl:element>
									</xsl:element>
								</xsl:when>
								<xsl:when test="booltrueicon">
									<xsl:element name="xsl:if">
										<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '1']</xsl:attribute>
										<IMG><xsl:attribute name="src"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="booltrueicon"/></xsl:attribute></IMG>
									</xsl:element>
								</xsl:when>
								<xsl:when test="boolfalseicon">
									<xsl:element name="xsl:if">
										<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '0']</xsl:attribute>
										<IMG><xsl:attribute name="src"><xsl:value-of select="/view/customimagepath"/><xsl:value-of select="boolfalseicon"/></xsl:attribute></IMG>
									</xsl:element>
								</xsl:when>
								<xsl:otherwise>
									<xsl:element name="xsl:if">
										<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. = '1']</xsl:attribute>
										<IMG><xsl:attribute name="src"><xsl:value-of select="/view/imagepath"/>boolean.gif</xsl:attribute></IMG>
									</xsl:element>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
		<!-- ****** End boolean properties xsl        *********************** -->
		<!-- ****** Start non special properties xsl   *********************** -->
						<xsl:otherwise>
							<xsl:element name="xsl:choose">
								<xsl:element name="xsl:when">
									<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[@b:dt = 'mv.string']</xsl:attribute>
									<xsl:element name="xsl:for-each">
										<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval>/*</xsl:attribute>
										<xsl:element name="xsl:value-of"><xsl:attribute name="select">.</xsl:attribute></xsl:element><xsl:element name="xsl:if"><xsl:attribute name="test">context()[not(end())]</xsl:attribute>, </xsl:element>
									</xsl:element>
								</xsl:element>
								<xsl:element name="xsl:when">
									<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[@b:dt = 'int' or @b:dt = 'float' or @b:dt = 'i1' or @b:dt = 'i2' or @b:dt = 'i4' or @b:dt = 'i8' or @b:dt = 'ui1' or @b:dt = 'ui2' or @b:dt = 'ui4' or @b:dt = 'ui8' or @b:dt = 'r4' or @b:dt = 'r8']</xsl:attribute>
									<xsl:element name="xsl:for-each">
										<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute>
										<xsl:element name="xsl:eval">formatNumber(new Number(this.text), "<xsl:value-of select='format' />")</xsl:element>
									</xsl:element>
								</xsl:element>
								<xsl:element name="xsl:when">
									<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[@b:dt = 'dateTime.tz' or @b:dt = 'dateTime']</xsl:attribute>
									<xsl:element name="xsl:for-each">
										<xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute>
										<xsl:element name="xsl:eval">parseFormatString(this.text, "<xsl:value-of select='format' />")</xsl:element>
									</xsl:element>
								</xsl:element>
								<xsl:element name="xsl:otherwise">
									<xsl:choose>
										<xsl:when test="bitmap[. = '1']">
											<xsl:element name="xsl:if">
												<xsl:attribute name="test"><xsl:eval>"prop" + childNumber(this)</xsl:eval>[. != '']</xsl:attribute>
												<IMG>
													<xsl:element name="xsl:attribute"><xsl:attribute name="name">src</xsl:attribute><xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute></xsl:element></xsl:element>
												</IMG>
											</xsl:element>
										</xsl:when>
										<xsl:otherwise>
											<xsl:element name="xsl:value-of"><xsl:attribute name="select"><xsl:eval>"prop" + childNumber(this)</xsl:eval></xsl:attribute></xsl:element>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:element>
							</xsl:element>
						</xsl:otherwise>
		<!-- ****** End non special properties xsl        *********************** -->
					</xsl:choose>
				</TD>
				</xsl:for-each>
			</xsl:element>
		</A>
		</TR>
		</xsl:element>
		</TABLE>
<!-- ****** End Property xsl     *********************** -->
		</xsl:element>
		</xsl:element>
</xsl:element>
</xsl:template>
</xsl:stylesheet>  